/*------------------------------------------------------------------
!  BEM_EDIT.C               Version 1.09a                  12.08.1997
!
!	Dieses Programm kann die *.EVT und *.DAT-Dateien des BEM
!	editieren und anzeigen
!
+------------------------------------------------------------------*/

#define TITEL " B.E.M.Editor V1.09a (12.08.97)"
#define INFO_ZEILE "  1994-97 by Michael Pieper"

#define TRUE 1
#define FALSE 0
#define U_TO_U   0x0880	/* User to User Message							*/
#define GO_TOP	 0x0001	/* Als Message sich am Bildschirm bemerkbar zu machen	*/
#define LOAD_EVT 0x0002	/* Message fr User	= Update der EVT-Dateien	*/
#define MAX_FENSTER 10	/* Anzahl der maximal darstellbaren Fenster	*/

#define MAX_TI_EVT 20	/* Anzahl der zustzlichen Timer Speicherpltze	*/
#define MAX_PR_EVT 20	/* Anzahl der zustzlichen Programm Speicherpltze	*/
#define MAX_TA_EVT 20	/* Anzahl der zustzlichen Tastatur Speicherpltze	*/
#define MAX_SS_EVT 20	/* Anzahl der zustzlichen Device Speicherpltze	*/
#define MAX_FT_TAG 30	/* Anzahl der zustzlichen Feiertag Speicherpltze	*/

#define MIN(x, y) (((x) < (y)) ? (x) : (y))
#define MAX(x, y) (((x) > (y)) ? (x) : (y))

char c_titel[]=TITEL;
char c_text[]=INFO_ZEILE;
	
#include <aes.h>
#include <ctype.h>
#include <ext.h>
#include <new_aes.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <screen.h>
#include <time.h>
#include <magx.h>
#include <vaproto.h>
#include <fslx_lib.h>

#include "feiertag.h"
#include "d:\multi.prg\multibox\system.h"

#include "BEM_EDIT.H"		/* Userdefinitionen	*/

typedef struct {
	int		wind_handle;
	int		art;
	int		fx;
	int		fy;
	int		fw;
	int		fh;
	int		vslide;
	int		top_line;		/* Angezeigte oberste Zeile	*/
	int		anz;			/* ANzahl der vorhandenen Zeilen	*/
	
	int		edit_ob;		/* aktuelles Edit-objekt	*/
	int		edit_idx;		/* aktueller Editindex		*/
	
	char	*titel;
	char	*info;
		
	int		aktiv		:1;
	int		edit_init	:1;	/* Edit ein oder aus	*/
	int		changed		:1;	/* Es wurde gendert aber nicht gesichert!	*/
	int		inf_open	:1;	/* durch INF geffnet	*/

	int		dx;
	int		dy;
	OBJECT	*ob;
	
	int		selected;		/* gibt 0-4 an wer ausgewhlt wurde! -1 = nix ausgewhlt	*/
	int		save_button;	/* Gibt den "Sichern" Knopf an!	*/
	int		deff_button;	/* Gibt den Derzeitigen Default Knopf an oder -1 wenn ncht vorh.	*/
	int		menu;			/* Zugehriger Eintrag im Men oder -1	*/
	void	(* bearbeiten) (int ob);	/* Prozedur zum bearbeiten! Aufruf: bearbeiten(objekt)	*/
	void	(* speichern) (void);	/* prozedur zum speichern!	Aufruf: speichern()	*/
} FENSTER;

FENSTER haupt, timer, programm, maus, device, tastatur, feiertag, konfig;
FENSTER *edit_win;			/* In diesem Fenster wurde editiert	*/

FENSTER *fenster[MAX_FENSTER];		/* Speicher fr alle Fensterarten	*/

OBJECT *menu;
OBJECT *msg;

typedef struct {
	char	zeit[16];
	char	wiederh[8];
	char	gueltig[6];
	char	ereignis[32];
} TI_EVT;

TI_EVT *ti_evt = NULL;
int		max_ti_evt = 0;
int		ti_sort = TISO_AKTION;

typedef struct {
	char	name[10];
	char	s_ereignis[32];
	char	e_ereignis[32];
} PR_EVT;

PR_EVT	*pr_evt = NULL;
int		max_pr_evt = 0;
int		pr_sort = PRSO_PROGRAMM;

typedef struct {
	char	name[16];
	char	ereignis[32];
} MA_EVT;

MA_EVT *ma_evt = NULL;
#define max_ma_evt 16 * 4	/* Fr 4 Ebenen!	*/
int		ma_sort = MASO_NR;

typedef struct {
	int		ascii;
	int		scan;
	char	ereignis[32];
} TA_EVT;

TA_EVT	*ta_evt = NULL;
int		max_ta_evt = 0;
int		ta_sort = TASO_CODE;

typedef struct {
	int		dev;
	char	string[46];
	char	ereignis[32];
} SS_EVT;

SS_EVT	*ss_evt = NULL;
int		max_ss_evt = 0;
int		ss_sort = SSSO_STRING;

typedef struct {
	int		art;	/* Gibt an welcher Feiertag, (fest, beweglich)	*/
	char	datum[10];
	char	bemerkung[32];
} FE_DAT;

FEIERTAG	*fe_tag = NULL;
int			max_fe_tag = 0;
int			bundesland;
int			ft_sort = FTSO_DATUM;

char		konf_editor[128];	/* Pfad des TextEditors	*/
char		konf_bemedit[128];	/* Pfad des BEM_EDIT.PRG	*/
char		konf_edit_rsc[128];	/* Pfad des BEM_EDIT.RSC	*/
char		konf_event_rsc[128];/* Pfad des EVENTMAN.RSC	*/
char		konf_syspfad[128];	/* Pfad der EVT-Dateien		*/
int			konf_sek_prg = 2;	/* Zeit fr Programmvergleich	*/
int			konf_sek_dat = 2;	/* Zeit fr Dateienvergleich	*/
int			konf_info = 5;		/* Anzahl fr Infomeldungen		*/

int ap_id;
int parallel;		/* Indikator, ob Parallelstart mglich oder nicht	*/
int env_gesetzt;	/* Indikator, ob BAVARIA-SYSTEM gesetzt ist			*/

char *environment;
char pfad[128];

char st_help[128];

/*-------------------------------------------------------------------
!	Prototypen
+------------------------------------------------------------------*/

void main(void);
int	appl_anmelden(void);
int appl_abmelden(void);
void sys_events(void);

int message_katalog(int *buffer);
int message_keyboard(int key);
int message_button(int mx, int my);

int	intersect(GRECT *re_1, GRECT *re_2);
void rsrc_init(void);

void setze_fenster(FENSTER *f, int objekt, int art, char *titel, char *info);
void oeffne_fenster(FENSTER *f);
void schliesse_fenster(FENSTER *f);

TI_EVT *lade_timer_ereignis(int	*ti_anz);
void speicher_timer_ereignis(void);
void setze_timer(TI_EVT *ti, int anz_ti, int top);
void sort_timer(TI_EVT *ti, int max_anz_ti, int art);
int comp_timer_dat(TI_EVT *klein, TI_EVT *gross);
int comp_timer_zei(TI_EVT *klein, TI_EVT *gross);
int comp_timer_wie(TI_EVT *klein, TI_EVT *gross);
int comp_timer_akt(TI_EVT *klein, TI_EVT *gross);
int comp_timer_gueltig(TI_EVT *klein, TI_EVT *gross);
void neuer_timer(OBJECT *ob, int neu);
void loeschen_timer(void);

PR_EVT *lade_prog_ereignis(int *pr_anz);
void speicher_prog_ereignis(void);
void setze_prog(PR_EVT *pr, int anz_pr, int top);
void sort_prog(PR_EVT *pr, int max_anz_pr, int art);
int comp_prog_pro(PR_EVT *klein, PR_EVT *gross);
int comp_prog_sta(PR_EVT *klein, PR_EVT *gross);
int comp_prog_end(PR_EVT *klein, PR_EVT *gross);
void neues_programm(OBJECT *ob, int alt_pos);
void loeschen_programm(void);

MA_EVT *lade_maus_ereignis(void);
void speicher_maus_ereignis(void);
void setze_maus(MA_EVT *ma, int top);

TA_EVT *lade_tast_ereignis(int *ta_anz);
void speicher_tast_ereignis(void);
void setze_tast(TA_EVT *ta, int anz_ta, int top);
void sort_tast(TA_EVT *ta, int max_anz_ta, int art);
int comp_tast_akt(TA_EVT *klein, TA_EVT *gross);
int comp_tast_cod(TA_EVT *klein, TA_EVT *gross);
void neue_tast(OBJECT *ob, int alt_pos);
void loeschen_tast(void);

SS_EVT *lade_ss_ereignis(int *ss_anz);
void speicher_ss_ereignis(void);
void setze_ss(SS_EVT *ss, int anz_ss, int top);
void sort_ss(SS_EVT *ss, int max_anz_ss, int art);
int comp_ss_dev(SS_EVT *klein, SS_EVT *gross);
int comp_ss_akt(SS_EVT *klein, SS_EVT *gross);
int comp_ss_str(SS_EVT *klein, SS_EVT *gross);
void neue_ss(OBJECT *ob, int alt_pos);
void loeschen_ss(void);

void speicher_syskonf(void);

FENSTER *hole_fenster(int wind_handle);
void setze_ob(FENSTER *akt, int kind, char *text);
void setze_vslsize(FENSTER *akt);

char *welche_wiederholung(char *string);
void setze_wiederholung(char *wiederh);

int setze_programm(char *name, char *text, char *ext);
void setze_code(char *scan_ascii);
void auswahl_device(void);

void setze_neupos(FENSTER *akt);
void setze_kinder(OBJECT *object, int start, int end, int wert);

int test_cookie(char *text);
int xtoi(char *string);
void send_update(void);

void aender_objc(FENSTER *akt, int kind, int neustatus);
int  dialog_popup(OBJECT *pop_baum, FENSTER *f, int start);
void popup_aktion(FENSTER *f, int start);

void update_save_flags(void);

void sort_ft(FEIERTAG *ft, int max_anz_ft, int art);
int comp_ft_bemerkung(FEIERTAG *klein, FEIERTAG *gross);
int comp_ft_art(FEIERTAG *klein, FEIERTAG *gross);
int comp_ft_datum(FEIERTAG *klein, FEIERTAG *gross);
void zeige_feiertag(FEIERTAG *ft, int anz_fe, int top);
void loeschen_feiertag(void);
void neuer_feiertag(OBJECT *ob, int neu);

void bearbeite_haupt(int erg);
void bearbeite_timer(int erg);
void bearbeite_programm(int erg);
void bearbeite_maus(int erg);
void bearbeite_tastatur(int erg);
void bearbeite_device(int erg);
void bearbeite_feiertag(int erg);
void bearbeite_konfig(int erg);

void oeffne_timer(void);
void oeffne_programm(void);
void oeffne_maus(void);
void oeffne_tastatur(void);
void oeffne_device(void);
void oeffne_feiertag(void);
void oeffne_akedit(char *aktion);
void oeffne_konfig(void);

void lese_inf(void);
void sichern_inf(void);

void go_help(void);
int  ordner(char *ordner);

/*----------------------------------------------------------------
!	Hauptschleife
+-----------------------------------------------------------------*/

void main(void)

{
	char *c;
	Dgetpath(&pfad[2], 0);
	pfad[0] = Dgetdrv() + 'A'; 
	pfad[1] = ':';
	strcat(pfad, "\\EVENTMAN.DAT");

	env_gesetzt = FALSE;
	c = getenv("BAVARIA-SYSTEM");
	if (c != NULL) {
		env_gesetzt = TRUE;
		strcpy(pfad, c);
		if (pfad[strlen(pfad) - 1] == '\\') pfad[strlen(pfad) - 1] = '\0';
	}
	
	strcpy(konf_syspfad, pfad);

	strcpy(konf_bemedit, pfad);
	c = strrchr(konf_bemedit, '\\');
	if (c != NULL) *c = '\0';

	strcpy(konf_edit_rsc, konf_bemedit);
	strcat(konf_edit_rsc, "\\BEM_EDIT.RSC");
	strcpy(konf_event_rsc, konf_bemedit);
	strcat(konf_event_rsc, "\\EVENTMAN.RSC");

	strcat(konf_bemedit, "\\BEM_EDIT.PRG");

	*konf_editor = '\0';
	strncat(konf_editor, pfad, 3);
	
	ap_id = appl_anmelden();
	graf_mouse(ARROW, NULL);

	rsrc_init();
	ordner(pfad);

	lese_inf();
	
	if (timer.inf_open) oeffne_timer();
	if (programm.inf_open) oeffne_programm();
	if (tastatur.inf_open) oeffne_tastatur();
	if (maus.inf_open) oeffne_maus();
	if (device.inf_open) oeffne_device();
	if (feiertag.inf_open) oeffne_feiertag();
	if (haupt.inf_open) oeffne_fenster(&haupt);
	if (konfig.inf_open) oeffne_fenster(&konfig);
	
	fenster[0] = &haupt;
	fenster[1] = &timer;
	fenster[2] = &programm;
	fenster[3] = &maus;
	fenster[4] = &device;
	fenster[5] = &tastatur;
	fenster[6] = &feiertag;
	fenster[7] = &konfig;
	fenster[8] = NULL;

	do sys_events();
	while(TRUE);
	
	/* hierher kommen wir eh nie	*/
}


/*-----------------------------------------------------------------------
!	Meldet das Programm an und berprft, ob ein gleichnamiges Programm
!	bereits aktiviert wurde (festgelegt auf den Namen "EVENTMAN")
!	<- app_id der eigenen Applikation
+----------------------------------------------------------------------*/

int	appl_anmelden(void)

{
	int ap_id, a, b, c, d;
	char err[128];
	
	ap_id = appl_init();			/* anmelden	*/
	if (ap_id < 0) {
		sprintf(err, msg[MSG_INITFEHLER].ob_spec.free_string, TITEL);
		form_alert(1, err);
		appl_exit();
		exit(0);
	}

    if(_GemParBlk.global[0] >= 0x399) {		/* appl_getinfo vorhanden	*/

		if (appl_getinfo(APG_SHWR, &a, &b, &c, &d)) {
			if ((a & 0x00ff) >= 9) shel_write(SHW_MSGREC, 0x0001, 0, NULL, NULL);	/* AP_TERM aktivieren	*/
		}
	}
	
	return(ap_id);
}

/*-----------------------------------------------------------------------
!	Meldet das Programm ab
+-----------------------------------------------------------------------*/

int appl_abmelden(void)

{
	int i;
	FENSTER **f;
	char text[128];
	
	for (f = fenster; *f != NULL; f++) {
		if ((*f)->changed) {
			sprintf(text, msg[MSG_NOTSAVED].ob_spec.free_string, (*f)->titel);

			switch(form_alert(1, text)) {
				case 1:	if (*f == &feiertag) speicher_feiertag(pfad, fe_tag, feiertag.anz);
						else if ((*f)->speichern != NULL) (*(*f)->speichern)();
						schliesse_fenster(*f);
						break;
				case 3:	return(FALSE);
			}
		}
	}

	if (ti_evt != NULL) free(ti_evt);
	if (pr_evt != NULL) free(pr_evt);
	if (ma_evt != NULL) free(ma_evt);
	if (ss_evt != NULL) free(ss_evt);
	if (ta_evt != NULL) free(ta_evt);
	if (fe_tag != NULL) free(fe_tag);

	send_update();

	if (!parallel) {
		wind_get(0, WF_TOP, &i);
		while (i > 0) {
			wind_close(i);		/* Auch ACC-Fenster unter SingelTOS schlieen!	*/
			wind_delete(i);
			wind_get(0, WF_TOP, &i);
		}
	}

	appl_exit();
	return(TRUE);
}

/*----------------------------------------------------------------
!	User aktionen
!	Beendet das Programm, wenn Programm beendet werden soll
+-----------------------------------------------------------------*/

void sys_events(void)

{
	int erg, quit, kr, br, mx, my, mb, ks;
	int buffer[16];
	
	do {
		quit = FALSE;
		erg = evnt_multi(MU_MESAG|MU_TIMER|MU_KEYBD|MU_BUTTON,
                 2, 1, 1,
                 0, 0, 0, 0, 0,
                 0, 0, 0, 0, 0,
                 buffer,
                 100, 0,  
                 &mx, &my,
                 &mb, &ks,
                 &kr, &br);
        
		if (erg & MU_MESAG) quit |= message_katalog(buffer);
		if ((erg & MU_BUTTON) && (br >= 1)) quit |= message_button(mx, my);	/* nur beachten, wenn Maus wieder losgelassen	*/
		if (erg & MU_KEYBD) quit |= message_keyboard(kr);
		if (quit) quit = appl_abmelden();
		if (erg & MU_TIMER && !quit) return;

	} while (!quit);
	exit(0);
}


/*----------------------------------------------------------------
!	Behandelt die Nachrichten 
!	Gibt TRUE zurck, wenn beendet werden soll
+-----------------------------------------------------------------*/

int message_katalog(int *buffer)

{
	GRECT re, wi;
	int end = FALSE, stand, top_window, end_update = FALSE;
	FENSTER *akt, **f;
	
	wind_update(BEG_UPDATE);
	wind_get(0, WF_TOP, &top_window);
	
	if (*buffer != MN_SELECTED) akt = hole_fenster(buffer[3]);
	else akt = hole_fenster(-1);

	switch(buffer[0]) {			/* ev_mgpbuff */
		case MN_SELECTED:
			wind_update(END_UPDATE);
			end_update = TRUE;
			switch(buffer[4]) {
				case MENU_QUIT:
					end = TRUE;
					break;
				case MENU_EINSTELLUNG:
					sichern_inf();
					break;
				case MENU_SAVEALL:
					for (f = fenster; *f != NULL; f++)
						if (((*f)->changed) && ((*f)->speichern != NULL)) (*(*f)->speichern)();
						
					if (feiertag.changed) {
						speicher_feiertag(pfad, fe_tag, feiertag.anz);
						send_update();
					}
					menu_ienable(menu, MENU_SAVEALL, FALSE);
					break;
				case MENU_SAVE:
					if (akt == NULL) break;
					if (akt->speichern != NULL) (*akt->speichern)();
					else if (top_window == feiertag.wind_handle) {
						speicher_feiertag(pfad, fe_tag, feiertag.anz);
						send_update();
					}
					akt->changed = FALSE;
					break;
				case MENU_FEIERTAG:
					oeffne_feiertag();
					break;		
				case MENU_INFO:
					oeffne_fenster(&haupt);
					break;
				case MENU_TIMER:
					oeffne_timer();
					break;		
				case MENU_PROGRAMM:
					oeffne_programm();
					break;		
				case MENU_MAUS:
					oeffne_maus();
					break;		
				case MENU_DEVICE:
					oeffne_device();
					break;		
				case MENU_TASTATUR:
					oeffne_tastatur();
					break;
				case MENU_AKTION:
					oeffne_akedit(NULL);
					break;
			}
			menu_tnormal(menu, buffer[3], TRUE);
			break;
		case U_TO_U:			/* anderes Programm will was	*/
			switch(buffer[3]) {
				case GO_TOP:oeffne_fenster(&haupt);
							break;
			}
			break;
		case WM_CLOSED:			/* Schliessbox	*/
			schliesse_fenster(akt);
			break;
		case WM_MOVED:			/* Bewegen	*/
			akt->ob->ob_x = buffer[4] + akt->dx;
			akt->ob->ob_y = buffer[5] + akt->dy;
			wind_set(buffer[3], WF_CURRXYWH, buffer[4], buffer[5], buffer[6], buffer[7]);
			akt->fx = buffer[4];
			akt->fy = buffer[5];
			akt->fw = buffer[6];
			akt->fh = buffer[7];
			break;
		case WM_REDRAW:			/* Neuzeichnen		*/
			wind_get(buffer[3], WF_FIRSTXYWH, &re.g_x, &re.g_y, &re.g_w, &re.g_h);
			wi.g_x = buffer[4];
			wi.g_y = buffer[5];
			wi.g_w = buffer[6];
			wi.g_h = buffer[7];
			if ((akt->edit_ob != 0) && akt->edit_init && (buffer[3] == top_window)) 
				objc_edit(akt->ob, akt->edit_ob, 0, &akt->edit_idx, ED_END);	/* Beim Zeichnen Cursor ausschalten	*/

			while (re.g_w != 0 || re.g_h != 0) {
				if (intersect(&re, &wi))
					objc_draw(akt->ob, 0, 10, re.g_x, re.g_y, re.g_w, re.g_h);
				wind_get(buffer[3], WF_NEXTXYWH, &re.g_x, &re.g_y, &re.g_w, &re.g_h);
			}

			if ((akt->edit_ob != 0) && (buffer[3] == top_window)) {	/* immer INIT machen, da Cursor bermalt wird!	*/
				objc_edit(akt->ob, akt->edit_ob, 0, &akt->edit_idx, ED_INIT);
				akt->edit_init = TRUE;
				edit_win = akt;
			}

			break;
		case WM_TOPPED:			/* Nach oben holen	*/
			if ((buffer[3] != edit_win->wind_handle) && (edit_win->edit_init)) {
				objc_edit(edit_win->ob, edit_win->edit_ob, 0, &edit_win->edit_idx, ED_END);
				edit_win->edit_init = FALSE;
			}
			wind_set(buffer[3], WF_TOP);
			update_save_flags();
			break;
		case WM_BOTTOM:
			if ((buffer[3] != edit_win->wind_handle) && (edit_win->edit_init)) {
				objc_edit(edit_win->ob, edit_win->edit_ob, 0, &edit_win->edit_idx, ED_END);
				edit_win->edit_init = FALSE;
			}			
			wind_set(buffer[3], WF_BOTTOM);
			update_save_flags();
			break;
		case WM_UNTOPPED:
			if ((buffer[3] == edit_win->wind_handle) && (edit_win->edit_init)) {
				objc_edit(edit_win->ob, edit_win->edit_ob, 0, &edit_win->edit_idx, ED_END);
				edit_win->edit_init = FALSE;
			}
			update_save_flags();
			break;
		case WM_VSLID:
			stand = akt->top_line;
			akt->top_line = (int )((long )buffer[4] * (long )(akt->anz - 5) / 1000L);
			if (stand != akt->top_line) setze_neupos(akt);
			break;
		case WM_ARROWED:
			stand = akt->top_line;
			switch(buffer[4]) {
				case WA_UPLINE:
					akt->top_line--;
					break;
				case WA_DNLINE:
					akt->top_line++;
					break;
				case WA_UPPAGE:
					akt->top_line -= 4;
					break;
				case WA_DNPAGE:
					akt->top_line += 4;
					break;
			}
			if (akt->top_line > akt->anz - 5) akt->top_line = akt->anz - 5;
			if (akt->top_line < 0) akt->top_line = 0;
			if (stand != akt->top_line) setze_neupos(akt);
			break;
		case AP_TERM:
			end = TRUE;
			break;
	}
	if (!end_update) wind_update(END_UPDATE);
	return(end);
}

/*--------------------------------------------------------------------------
!	ffnet das TIMER Fenster
+--------------------------------------------------------------------------*/

void oeffne_timer(void)

{
	if (ti_evt == NULL) ti_evt = lade_timer_ereignis(&timer.anz);
	setze_timer(ti_evt, timer.anz, 0);
	oeffne_fenster(&timer);
}

/*--------------------------------------------------------------------------
!	ffnet das Programm fenster
+-------------------------------------------------------------------------*/

void oeffne_programm(void)

{
	if (pr_evt == NULL) pr_evt = lade_prog_ereignis(&programm.anz);
	setze_prog(pr_evt, programm.anz, 0);
	oeffne_fenster(&programm);
}

/*--------------------------------------------------------------------------
!	ffnet das Tastatur fenster
+-------------------------------------------------------------------------*/

void oeffne_tastatur(void)

{
	if (ta_evt == NULL) ta_evt = lade_tast_ereignis(&tastatur.anz);
	setze_tast(ta_evt, tastatur.anz, 0);
	oeffne_fenster(&tastatur);
}

/*--------------------------------------------------------------------------
!	ffnet das maus fenster
+-------------------------------------------------------------------------*/

void oeffne_maus(void)

{
	if (ma_evt == NULL) ma_evt = lade_maus_ereignis();
	setze_maus(ma_evt, 0);
	oeffne_fenster(&maus);
}

/*--------------------------------------------------------------------------
!	ffnet das Device fenster
+-------------------------------------------------------------------------*/

void oeffne_device(void)

{
	if (ss_evt == NULL) ss_evt = lade_ss_ereignis(&device.anz);
	setze_ss(ss_evt, device.anz, 0);
	oeffne_fenster(&device);
}


/*--------------------------------------------------------------------------
!	ffnet das Feiertags-fenster
+-------------------------------------------------------------------------*/

void oeffne_feiertag(void)

{
	char dummy[20];
	int i;
	if (fe_tag == NULL) {
		max_fe_tag = MAX_FT_TAG;
		fe_tag = lade_feiertag(pfad, &bundesland, &max_fe_tag, -1);
		for (i = 0; (i < MAX_FT_TAG) && (fe_tag[i].tag > 0); i++);
		feiertag.anz = i;
		strcpy(dummy, " ");
		strcat(dummy, b_land[bundesland]);
		setze_ob(&feiertag, FE_BUNDESLAND, dummy);
		sort_ft(fe_tag, max_fe_tag, ft_sort);
	}
	zeige_feiertag(fe_tag, feiertag.anz, 0);
	oeffne_fenster(&feiertag);
}

/*-----------------------------------------------------------------------------
!	ffnet den Aktionseditor
+-----------------------------------------------------------------------------*/

void oeffne_akedit(char *aktion)

{
	int i, anz, appl_id, buffer[16];
	char param[128];
	char p[128], f[20], *c, *d;
	struct ffblk ffb;

	FENSTER *win, *fe[MAX_FENSTER];

	if (findfirst(konf_editor, &ffb, 0) != 0) {	/* Nicht gefunden!	*/
		*p = Dgetdrv() + 'A';
		p[1] = ':';
		Dgetpath(&p[2], 0);
		strcat(p, "\\*.*");
		*f = '\0';
		fsel_exinput(p, f, &i, msg[MSG_FS_TEXTEDIT].ob_spec.free_string);
		if ((i == 0) || (*f == '\0')) return;
		strcpy(konf_editor, p);
		c = strrchr(konf_editor, '\\');
		if (c != NULL) *(++c) = '\0';
		strcat(konf_editor, f);
	}
	
	strcpy(&param[1], pfad);
	strcat(&param[1], "\\aktion.dat");

	param[0] = (char )strlen(&param[1]);
	
	if (parallel) {	/* parallellauf mglich (MultiTOS/MiniX)	*/
		c = strrchr(konf_editor, '\\');
		if (c == NULL) c = konf_editor;
		else c++;
		for (d = f, i = 0; *c != '\0' && *c != '.' && i < 8; *(d++) = *(c++), i++);
		if (i < 8) for ( ; i < 8; *(d++) = ' ', i++);
		*d = '\0';
	
		appl_id = appl_find(f);		/* Editor bereits gestartet?	*/

		if (appl_id < 0) {
			if (konf_editor[1] == ':') strcpy(p, konf_editor);		/* Pfad setzen	*/
			else {
				p[0] = Dgetdrv() + 'A';
				p[1] = ':';
				p[2] = '\0';
				if (konf_editor[0] != '\\') {
					Dgetpath(&p[2], *p - 'A');
					strcat(p, "\\");
				}
				strcat(p, konf_editor);
			}
			c = strrchr(p, '\\');
			if (c != NULL) *c = '\0';
			Dsetdrv(*p - 'A');
			Dsetpath(&p[2]);
			shel_write(SHW_APPEXEC, TRUE, SHW_PARALLEL, konf_editor, param);
		} else {
			strcpy(st_help, &param[1]);
			
			buffer[0] = VA_START;
			buffer[1] = ap_id;
			buffer[2] = 0;

			buffer[3] = (int )((long )st_help >> 16);
			buffer[4] = (int ) st_help;

			buffer[5] = buffer[6] = buffer[7] = 0;
			appl_write(appl_id, 16, buffer);
		}
	} else {
		menu_bar(menu, FALSE);

		anz = 0;
		wind_get(0, WF_TOP, &i);
		while(i > 0) {
			if ((win = hole_fenster(i)) != NULL) {
				fe[anz++] = win;
				win->aktiv = FALSE;
				win->wind_handle = -1;
			}
			wind_close(i);							/* Auch ACC-Fenster schlieen!	*/
			wind_delete(i);
			wind_get(0, WF_TOP, &i);
		}
		appl_exit();
		Pexec(0, konf_editor, param, environment);
		ap_id = appl_init();

		menu_bar(menu, TRUE);
		
		for (anz--; anz >= 0; oeffne_fenster(fe[anz--]));
	}
}

/*-----------------------------------------------------------------------------
!	Setzt evtl. vernderte Positionen
+----------------------------------------------------------------------------*/

void setze_neupos(FENSTER *akt)

{
	int loe = -1, edit;
	
	wind_set(akt->wind_handle, WF_VSLIDE, (int )((1000l * (long )(akt->top_line)) / (long )(akt->anz - 5)));
	if (akt == &timer) {
		if (!(timer.ob[TI_LOESCHEN].ob_state & DISABLED)) {
			loe = TI_LOESCHEN;
			edit = TI_EDIT;
		}
		setze_timer(ti_evt, timer.anz, timer.top_line);
	} else if (akt == &programm) {
		if (!(programm.ob[PR_LOESCHEN].ob_state & DISABLED)) {
			setze_kinder(programm.ob, P_NR, P_NR + 19, NORMAL);
			loe = PR_LOESCHEN;
			edit = PR_EDIT;
		}
		setze_prog(pr_evt, programm.anz, programm.top_line);
	} else if (akt == &maus) {
		if (!(maus.ob[TM_EDIT].ob_state & DISABLED)) {
			setze_kinder(maus.ob, M_NR, M_NR + 14, NORMAL);
			loe = TM_LOESCHEN;
			edit = TM_EDIT;
		}
		setze_maus(ma_evt, maus.top_line);
	} else if (akt == &tastatur) {
		if (!(tastatur.ob[TA_EDIT].ob_state & DISABLED)) {
			setze_kinder(tastatur.ob, TA_NR, TA_NR + 14, NORMAL);
			loe = TA_LOESCHEN;
			edit = TA_EDIT;
		}
		setze_tast(ta_evt, tastatur.anz, tastatur.top_line);
	} else if (akt == &device) {
		if (!(device.ob[SS_EDIT].ob_state & DISABLED)) {
			setze_kinder(device.ob, SS_NR, SS_NR + 14, NORMAL);
			loe = SS_LOESCHEN;
			edit = SS_EDIT;
		}
		setze_ss(ss_evt, device.anz, device.top_line);
	} else if (akt == &feiertag) {
		if (!(feiertag.ob[FE_EDIT].ob_state & DISABLED)) {
			setze_kinder(feiertag.ob, FT_NR, FT_NR + 19, NORMAL);
			loe = FE_LOESCHEN;
			edit = FE_EDIT;
		}
		zeige_feiertag(fe_tag, feiertag.anz, feiertag.top_line);
	}
	if (loe != -1) {
		akt->ob[loe].ob_state = akt->ob[edit].ob_state = DISABLED;
		setze_ob(akt, loe, NULL);
		setze_ob(akt, edit, NULL);
	}
}

/*------------------------------------------------------------------------
!	Behandelt die Tastatureingabe
!	Liefert TRUE, wenn beendet werden soll!
+-----------------------------------------------------------------------*/

int message_keyboard(int key)

{
	int no, chr, i;
	FENSTER *akt, **f;
	
	akt = hole_fenster(-1);

	if (key == 0x6200) {
		go_help();	/* HELP-Taste		*/
		return(FALSE);
	}
	
	switch(key & 0x00FF) {			/* Controltasten	*/
		case 0x11:	return(TRUE);		/* ^Q	*/
		case 0x14:	oeffne_timer();		/* ^T	*/
					return(FALSE);
		case 0x10:	oeffne_programm();	/* ^P	*/
					return(FALSE);
		case 0x0b:	oeffne_tastatur();	/* ^K	*/
					return(FALSE);
		case 0x0d:	if (key != 0x320d) break;		/* RETURN gedrckt	*/
					oeffne_maus();		/* ^M	*/
					return(FALSE);
		case 0x04:	oeffne_device();	/* ^D	*/
					return(FALSE);
		case 0x06:	oeffne_feiertag();	/* ^F	*/
					return(FALSE);
		case 0x01:	oeffne_akedit(NULL);/* ^A	*/
					return(FALSE);
		case 0x00:	if (key != 0x1f00) break;		/* ALT-S	*/

					for (f = fenster; *f != NULL; f++)
						if (((*f)->changed) && ((*f)->speichern != NULL)) (*(*f)->speichern)();

					if (feiertag.changed) {
						speicher_feiertag(pfad, fe_tag, feiertag.anz);
						send_update();
					}
					menu_ienable(menu, MENU_SAVEALL, FALSE);
					break;
		case 0x13:						/* ^S	*/
					if (akt == NULL) break;
					if (akt->speichern != NULL) (*akt->speichern)();
					else if (akt->wind_handle == feiertag.wind_handle) {
						speicher_feiertag(pfad, fe_tag, feiertag.anz);
						send_update();
					}
					akt->changed = FALSE;
					break;				

	}
	
	if (akt != NULL) {
		i = form_keybd(akt->ob, akt->edit_ob, 0, key, &no, &chr);
		if (i == 0) {
			if (akt->ob[no].ob_state & DISABLED) aender_objc(akt, no, DISABLED);
			else if (akt->bearbeiten != NULL) (*akt->bearbeiten)(no);
		}
		if (chr != 0) {
			objc_edit(akt->ob, akt->edit_ob, chr, &akt->edit_idx, ED_CHAR);
			if (akt == &konfig) {
				konfig.changed = TRUE;
				update_save_flags();
			}
		} else {
			if (no != akt->edit_ob) {
				objc_edit(akt->ob, akt->edit_ob, chr, &akt->edit_idx, ED_END);
				if (akt->ob[no].ob_flags & EDITABLE) akt->edit_ob = no;
				objc_edit(akt->ob, akt->edit_ob, 0, &akt->edit_idx, ED_INIT);
			}
		}
	}
	return(FALSE);
}

/*----------------------------------------------------------------
!	Behandelt die Nachrichten 
!	Liefert immer FALSE, da ein Abbruch des Programms per Maus
!	nicht mglich ist (auer im Men!)
+-----------------------------------------------------------------*/

int message_button(int mx, int my)

{
	int i, erg, exit;
	FENSTER *akt;

	akt = hole_fenster(-1);

	erg = objc_find(akt->ob, 0, 10, mx, my);
	if ((erg < 0) || (akt->ob[erg].ob_state & DISABLED)) return(FALSE);
	
	if ((akt->edit_init) && (akt->aktiv)) {
		objc_edit(akt->ob, akt->edit_ob, 0, &akt->edit_idx, ED_END);
		akt->edit_init = FALSE;
	}
	
	exit = form_button(akt->ob, erg, 1, &i);
	edit_win = akt;
	if (akt->ob[i].ob_flags & EDITABLE) akt->edit_ob = i;

	if ((exit == 0) && (akt->bearbeiten != NULL)) (*akt->bearbeiten)(erg);

	if ((akt->edit_ob > 0) && (akt->aktiv)) {
		objc_edit(akt->ob, akt->edit_ob, 0, &akt->edit_idx, ED_INIT);
		akt->edit_init = TRUE;
	}

	return(FALSE);
}

/*-------------------------------------------------------------------------
!	Bedient die Hauptdialogbox
!	erg = das festgestellte zu verarbeitende Objekt!
+------------------------------------------------------------------------*/

void bearbeite_haupt(int erg)

{
	haupt.ob[erg].ob_state &= ~SELECTED;
	switch(erg) {
		case H_TIMER:
			oeffne_timer();
			setze_ob(&haupt, UG_TIMER, NULL);
			break;		
		case H_PROG:
			oeffne_programm();
			setze_ob(&haupt, UG_PROGRAMM, NULL);
			break;		
		case H_MAUS:
			oeffne_maus();
			setze_ob(&haupt, UG_MAUS, NULL);
			break;		
		case H_SS:
			oeffne_device();
			setze_ob(&haupt, UG_DEVICE, NULL);
			break;		
		case H_TASTATUR:
			oeffne_tastatur();
			setze_ob(&haupt, UG_TASTATUR, NULL);
			break;
		case H_FE:
			oeffne_feiertag();
			setze_ob(&haupt, UG_FEIERTAG, NULL);
			break;
		case H_AKTION:
			oeffne_akedit(NULL);
			setze_ob(&haupt, UG_BATCH, NULL);
			break;
		case H_KONF:
			oeffne_fenster(&konfig);
			setze_ob(&haupt, UG_KONF, NULL);
			break;
	}
}

/*------------------------------------------------------------------
!	Bearbeitet die TimerBox
+-----------------------------------------------------------------*/

void bearbeite_timer(int erg)

{
	TI_EVT *ti;
	char dummy[50]="  ";
	OBJECT *pop;
	
	if ((erg >= TI_1) && (erg <= TI_1 + 4)) {
		timer.selected = erg - TI_1;
		ti = &ti_evt[timer.selected + timer.top_line];

		setze_ob(&timer, TI_DATUM, ti->zeit);
		setze_ob(&timer, TI_ZEIT, &(ti->zeit[8]));
		setze_ob(&timer, TI_WIEDERH, ti->wiederh);
		strcat(dummy, ti->ereignis);
		setze_ob(&timer, TI_EREIGNIS, dummy);
		setze_ob(&timer, TI_GUELTIG, ti->gueltig);

		setze_wiederholung(ti->wiederh);

		aender_objc(&timer, TI_LOESCHEN, NORMAL);

		timer.ob[timer.deff_button].ob_flags &= ~DEFAULT;
		timer.ob[TI_EDIT].ob_flags |= DEFAULT;
		timer.deff_button = TI_EDIT;
		timer.ob[TI_EDIT].ob_state &= ~DISABLED;
		
		setze_ob(&timer, TI_DEF_GRUND, NULL);
	} else {
		switch(erg) {
			case TISO_DATUM:
			case TISO_ZEIT:
			case TISO_WIEDERH:
			case TISO_GUELTIG:
			case TISO_AKTION:
				timer.ob[ti_sort].ob_state &= ~DISABLED;
				ti_sort = erg;
				timer.ob[ti_sort].ob_state |= DISABLED;
				sort_timer(ti_evt, max_ti_evt, ti_sort);
				setze_timer(ti_evt, timer.anz, timer.top_line);
				break;
			case TI_EREIGNIS:
				popup_aktion(&timer, TI_EREIGNIS);
				break;
			case TI_RHYTMUS:
				rsrc_gaddr(0, TIM_EVT, &pop);
				dialog_popup(pop, &timer, TI_RHYTMUS);
				break;
			case TI_SAVE:
				speicher_timer_ereignis();
				break;
			case TI_NEU:
				neuer_timer(timer.ob, TRUE);
				break;
			case TI_LOESCHEN:
				loeschen_timer();
				break;
			case TI_EDIT:
				neuer_timer(timer.ob, FALSE);
				break;
		}
		timer.ob[erg].ob_state &= ~SELECTED;
		setze_ob(&timer, erg, NULL);
	}
}

/*------------------------------------------------------------------
!	Bearbeitet die ProgrammBox
+-----------------------------------------------------------------*/

void bearbeite_programm(int erg)

{
	char *c, *d, buffer[128];
	PR_EVT *pr;
	
	if ((erg >= PR_1) && (erg <= PR_1 + 4)) {
		programm.selected = erg - PR_1;
		pr = &pr_evt[programm.selected + programm.top_line];
		
		setze_ob(&programm, TP_PROGRAMM, pr->name);
		strcpy(buffer, "  ");
		strcat(buffer, pr->s_ereignis);
		setze_ob(&programm, TP_SEREIGNIS, buffer);
		strcpy(buffer, "  ");
		strcat(buffer, pr->e_ereignis);
		setze_ob(&programm, TP_EEREIGNIS, buffer);

		aender_objc(&programm, PR_LOESCHEN, NORMAL);

		programm.ob[programm.deff_button].ob_flags &= ~DEFAULT;
		programm.ob[PR_EDIT].ob_flags |= DEFAULT;
		programm.deff_button = PR_EDIT;
		programm.ob[PR_EDIT].ob_state &= ~DISABLED;

		setze_ob(&programm, PR_DEF_GRUND, NULL);
	} else {
		switch(erg) {
			case TP_SEREIGNIS:
			case TP_EEREIGNIS:
				popup_aktion(&programm, erg);
				break;
			case PRSO_ST_AKTION:
			case PRSO_END_AKTION:
			case PRSO_PROGRAMM:
				programm.ob[pr_sort].ob_state &= ~DISABLED;
				pr_sort = erg;
				programm.ob[pr_sort].ob_state |= DISABLED;
				sort_prog(pr_evt, max_pr_evt, pr_sort);
				setze_prog(pr_evt, programm.anz, programm.top_line);
				break;
			case TP_PROGRAMM:
				strcpy(buffer, programm.ob[TP_PROGRAMM].ob_spec.tedinfo->te_ptext);
				setze_programm(buffer, msg[MSG_FS_PRG].ob_spec.free_string, "*.*");
				if ((c = strrchr(buffer, '\\')) == NULL) break;
				if ((d = strchr(++c, '.')) != NULL) *d = '\0';
				strcpy(programm.ob[TP_PROGRAMM].ob_spec.tedinfo->te_ptext, c);
				break;		
			case PR_SAVE:
				speicher_prog_ereignis();
				break;
			case PR_NEU:
 				neues_programm(programm.ob, TRUE);
				break;
			case PR_LOESCHEN:
				loeschen_programm();
				break;
			case PR_EDIT:
				neues_programm(programm.ob, FALSE);
				break;
		}
		programm.ob[erg].ob_state &= ~SELECTED;
		setze_ob(&programm, erg, NULL);
	}
} 

/*--------------------------------------------------------------
!	Bearbeitet die TastaturBox
+-------------------------------------------------------------*/

void bearbeite_tastatur(int erg)

{
	int e;
	char *c, dummy[50];
	
	if ((erg >= TA_1) && (erg <= TA_1 + 4)) {
		tastatur.selected = erg - TA_1;
		e = ((erg - TA_1) * 3) + TA_NR;

		c = tastatur.ob[e+1].ob_spec.tedinfo->te_ptext;
		setze_ob(&tastatur, TA_SCAN, &c[3]);
		strcpy(dummy, "  ");
		strcat(dummy, tastatur.ob[e+2].ob_spec.tedinfo->te_ptext);
		setze_ob(&tastatur, TA_EREIGNIS, dummy);

		if (c[3] == '-') aender_objc(&tastatur, TAS_SCAN, NORMAL);
		else aender_objc(&tastatur, TAS_SCAN, SELECTED);
		if (c[5] == '-') aender_objc(&tastatur, TAS_ASC, NORMAL);
		else aender_objc(&tastatur, TAS_ASC, SELECTED);
		
		aender_objc(&tastatur, TA_LOESCHEN, NORMAL);

		tastatur.ob[tastatur.deff_button].ob_flags &= ~DEFAULT;
		tastatur.ob[TA_EDIT].ob_flags |= DEFAULT;
		tastatur.deff_button = TA_EDIT;
		tastatur.ob[TA_EDIT].ob_state &= ~DISABLED;

		setze_ob(&tastatur, TA_DEF_GRUND, NULL);
	} else {
		switch(erg) {
			case TA_EREIGNIS:
				popup_aktion(&tastatur, TA_EREIGNIS);
				break;
			case TASO_AKTION:
			case TASO_CODE:
				tastatur.ob[ta_sort].ob_state &= ~DISABLED;
				ta_sort = erg;
				tastatur.ob[ta_sort].ob_state |= DISABLED;
				sort_tast(ta_evt, max_ta_evt, ta_sort);
				setze_tast(ta_evt, tastatur.anz, tastatur.top_line);
				break;
			case TA_SCAN:
				setze_code(tastatur.ob[TA_SCAN].ob_spec.tedinfo->te_ptext);
				tastatur.edit_init = FALSE;
				break;
			case TA_SAVE:
				speicher_tast_ereignis();
				break;
			case TA_NEU:
				neue_tast(tastatur.ob, TRUE);
				break;
			case TA_LOESCHEN:
				loeschen_tast();
				break;
			case TA_EDIT:
				neue_tast(tastatur.ob, FALSE);
				break;
		}
		tastatur.ob[erg].ob_state &= ~SELECTED;
		setze_ob(&tastatur, erg, NULL);
	}
}

/*-------------------------------------------------------
!	Bearbeitet die MausBox
+------------------------------------------------------*/

void bearbeite_maus(int erg)

{
	MA_EVT *ma;
	char *c, dummy[50];
	
	if ((erg >= MA_1) && (erg <= MA_1 + 4)) {
		maus.selected = erg - MA_1;
		ma = &ma_evt[maus.top_line + maus.selected];

		if (*ma->ereignis != '\0') {
			setze_ob(&maus, TM_NAME, ma->name);
			strcpy(dummy, "  ");
			strcat(dummy, ma->ereignis);
			setze_ob(&maus, TM_EREIGNIS, dummy);
			aender_objc(&maus, TM_LOESCHEN, NORMAL);
		} else {
			aender_objc(&maus, TM_LOESCHEN, DISABLED);
		}
			
		aender_objc(&maus, TM_EDIT, NORMAL);
	} else {
		switch(erg) {
			case TM_EREIGNIS:
				popup_aktion(&maus, TM_EREIGNIS);
				break;
			case TM_SAVE:
				speicher_maus_ereignis();
				break;
			case TM_LOESCHEN:
				ma = &ma_evt[maus.top_line + maus.selected];
				*ma->name = *ma->ereignis = '\0';

				setze_maus(ma_evt, maus.top_line);
				maus.changed = TRUE;
				break;
			case TM_EDIT:
				if ((*(maus.ob[TM_NAME].ob_spec.tedinfo->te_ptext) == '\0') ||
					(*(maus.ob[TM_EREIGNIS].ob_spec.tedinfo->te_ptext) == '\0')) {
						Bell();
						break;
				}
				ma = &ma_evt[maus.top_line + maus.selected];
				strcpy(ma->name, maus.ob[TM_NAME].ob_spec.tedinfo->te_ptext);
				strcpy(ma->ereignis, &maus.ob[TM_EREIGNIS].ob_spec.tedinfo->te_ptext[2]);
				for(c = ma->ereignis; *c != '\0'; c++) if (*c == ' ') *c = '_';
				for(c = ma->name; *c != '\0'; c++) if (*c == ' ') *c = '_';

				setze_maus(ma_evt, maus.top_line);
				maus.changed = TRUE;
		}
		update_save_flags();
		maus.ob[erg].ob_state &= ~SELECTED;
		setze_ob(&maus, erg, NULL);
	}
}

/*-----------------------------------------------------------------
!	Bearbeitet DeviceBox
+----------------------------------------------------------------*/

void bearbeite_device(int erg)

{	
	SS_EVT *ss;
	char dev[10]="  ", dummy[20];
	OBJECT *pop;
	
	if ((erg >= SS_1) && (erg <= SS_1 + 4)) {
		device.selected = erg - SS_1;
		ss = &ss_evt[device.selected + device.top_line];

		set_dev(ss->dev, &dev[2]);
		setze_ob(&device, SS_DEVICE, dev);
		setze_ob(&device, SS_STRING, ss->string);
		strcpy(dummy, "  ");
		strcat(dummy, ss->ereignis);
		setze_ob(&device, SS_EREIGNIS, dummy);

		aender_objc(&device, SS_LOESCHEN, NORMAL);

		device.ob[device.deff_button].ob_flags &= ~DEFAULT;
		device.ob[SS_EDIT].ob_flags |= DEFAULT;
		device.deff_button = SS_EDIT;
		device.ob[SS_EDIT].ob_state &= ~DISABLED;

		setze_ob(&device, SS_DEF_GRUND, NULL);
	} else {
		switch(erg) {
			case SS_EREIGNIS:
				popup_aktion(&device, SS_EREIGNIS);
				break;
			case SSSO_DEVICE:
			case SSSO_STRING:
			case SSSO_AKTION:
				device.ob[ss_sort].ob_state &= ~DISABLED;
				ss_sort = erg;
				device.ob[ss_sort].ob_state |= DISABLED;
				sort_ss(ss_evt, max_ss_evt, ss_sort);
				setze_ss(ss_evt, device.anz, device.top_line);
				break;
			case SS_DEVICE:
				rsrc_gaddr(0, DEV_EVT, &pop);
				dialog_popup(pop, &device, SS_DEVICE);
				break;
			case SS_SAVE:
				speicher_ss_ereignis();
				break;
			case SS_NEU:
				neue_ss(device.ob, TRUE);
				break;
			case SS_LOESCHEN:
				loeschen_ss();
				break;
			case SS_EDIT:
				neue_ss(device.ob, FALSE);
				break;
		}
		device.ob[erg].ob_state &= ~SELECTED;
		setze_ob(&device, erg, NULL);
	}
}

/*-----------------------------------------------------------------
!	Bearbeitet Feiertagsbox
+----------------------------------------------------------------*/

void bearbeite_feiertag(int erg)

{
	FEIERTAG *ft;
	int i;
	char buffer[10];
	OBJECT *pop;
		
	if ((erg >= FE_1) && (erg <= FE_1 + 4)) {
		feiertag.selected = erg - FE_1;
		ft = &fe_tag[feiertag.selected + feiertag.top_line];

		sprintf(buffer, "%02i%02i%04i", ft->tag, ft->monat + 1, ft->jahr);
		setze_ob(&feiertag, FE_DATUM, buffer);

		feiertag.ob[feiertag.deff_button].ob_flags &= ~DEFAULT;

		if (ft->art > JAEHRLICH) {
			feiertag.ob[FE_EDIT].ob_state |= DISABLED;
			feiertag.ob[FE_NEU].ob_flags |= DEFAULT;
			feiertag.deff_button = FE_NEU;
			aender_objc(&feiertag, FE_LOESCHEN, DISABLED);
			setze_ob(&feiertag, FE_BEMERKUNG, ft_name[ft->art]);
		} else {
			feiertag.ob[FE_EDIT].ob_flags |= DEFAULT;
			feiertag.deff_button = FE_EDIT;
			feiertag.ob[FE_EDIT].ob_state &= ~DISABLED;
			aender_objc(&feiertag, FE_LOESCHEN, NORMAL);
			setze_ob(&feiertag, FE_BEMERKUNG, ft->bemerkung);
		}

		if (ft->art == JAEHRLICH) aender_objc(&feiertag, FE_FEST, SELECTED);
		else aender_objc(&feiertag, FE_FEST, NORMAL);

		setze_ob(&feiertag, FE_DEF_GRUND, NULL);
	} else {
		switch(erg) {
			case FTSO_DATUM:
			case FTSO_BEMERKUNG:
			case FTSO_ART:
				feiertag.ob[ft_sort].ob_state &= ~DISABLED;
				ft_sort = erg;
				feiertag.ob[ft_sort].ob_state |= DISABLED;
				sort_ft(fe_tag, max_fe_tag, ft_sort);
				zeige_feiertag(fe_tag, feiertag.anz, feiertag.top_line);
				break;
			case FE_BUNDESLAND:
				sort_ft(fe_tag, max_fe_tag, FTSO_ART);	/* Bei nderungen immer nach ART sortieren!	*/

				rsrc_gaddr(0, STANDORT, &pop);
				bundesland = dialog_popup(pop, &feiertag, FE_BUNDESLAND) - 1;
				if (bundesland > BUNDESEINHEITLICH) bundesland--;
				for (i = 0; (i < max_fe_tag) && (fe_tag[i].art <= JAEHRLICH); i++);
				setze_feiertag(bundesland, -1, &fe_tag[i]);
				for (i = 0; (i < max_fe_tag) && (fe_tag[i].tag > 0); i++);
				feiertag.anz = i;
				for (; i < max_fe_tag; fe_tag[i++].tag = -1);	/* Tage lschen	*/
				
				if (feiertag.anz < feiertag.top_line + 5) feiertag.top_line = feiertag.anz - 5;
				if (feiertag.top_line < 0) feiertag.top_line = 0;
				setze_vslsize(&feiertag);

				sort_ft(fe_tag, max_fe_tag, ft_sort);
				zeige_feiertag(fe_tag, feiertag.anz, feiertag.top_line);
				feiertag.changed = TRUE;
				update_save_flags();
				break;
			case FE_SAVE:
				speicher_feiertag(pfad, fe_tag, bundesland);
				feiertag.changed = FALSE;
				update_save_flags();
				send_update();
				break;
			case FE_NEU:
				neuer_feiertag(feiertag.ob, TRUE);
				break;
			case FE_LOESCHEN:
				loeschen_feiertag();
				break;
			case FE_EDIT:
				neuer_feiertag(feiertag.ob, FALSE);
				break;
		}
		feiertag.ob[erg].ob_state &= ~SELECTED;
		setze_ob(&feiertag, erg, NULL);
	}
}

/*--------------------------------------------------
!	Bearbeitet den Konfigurationsdialog
+-------------------------------------------------*/

void bearbeite_konfig(int erg)

{
	char *c;
	switch(erg) {
		case KONF_SICHERN:
			speicher_syskonf();
			konfig.changed = FALSE;
			break;
		case KONF_EVT_PFAD:
			if (setze_programm(konf_syspfad, msg[MSG_FS_SYSPATH].ob_spec.free_string, "*.*")) {
				c = &konf_syspfad[strlen(konf_syspfad)-1];
				if (*c == '\\') *c = '\0';
				setze_ob(&konfig, KONF_EVT_PFAD, konf_syspfad);
				konfig.changed = TRUE;
			}
			break;		
		case KONF_TEXTEDIT:
			if (setze_programm(konf_editor, msg[MSG_FS_TEXTEDIT].ob_spec.free_string, "*.*")) {
				setze_ob(&konfig, KONF_TEXTEDIT, konf_editor);
				konfig.changed = TRUE;
			}
			break;		
		case KONF_BEMEDIT:
			if (setze_programm(konf_bemedit, msg[MSG_FS_BEMEDIT].ob_spec.free_string, "BEM_EDIT.PRG")) {
				setze_ob(&konfig, KONF_BEMEDIT, konf_bemedit);
				konfig.changed = TRUE;
			}
			break;
		case KONF_EDIT_RSC:
			if (setze_programm(konf_edit_rsc, msg[MSG_FS_EDITRSC].ob_spec.free_string, "*.RSC")) {
				setze_ob(&konfig, KONF_EDIT_RSC, konf_edit_rsc);
				konfig.changed = TRUE;
				form_alert(0, msg[MSG_RSC_CHANGE].ob_spec.free_string);
			}
			break;
		case KONF_EVENT_RSC:
			if (setze_programm(konf_event_rsc, msg[MSG_FS_EVENTRSC].ob_spec.free_string, "*.RSC")) {
				setze_ob(&konfig, KONF_EVENT_RSC, konf_event_rsc);
				konfig.changed = TRUE;
				form_alert(0, msg[MSG_RSC_CHANGE].ob_spec.free_string);
			}
			break;
	}
	konfig.ob[erg].ob_state &= ~SELECTED;
	setze_ob(&konfig, erg, NULL);
	update_save_flags();
}

/*--------------------------------------------------
!	Setzt den String der Wiederholung
+-------------------------------------------------*/

char *welche_wiederholung(char *string)

{
	char *s;
	OBJECT *t;
	
	rsrc_gaddr(0, TIM_EVT, &t);
	s = timer.ob[TI_RHYTMUS].ob_spec.tedinfo->te_ptext;

	strcpy(string, timer.ob[TI_WIEDERH].ob_spec.tedinfo->te_ptext);
	if (strlen(string) < 2) {
		if (*string == '\0') strcpy(string, "01");
		else {
			string[1] = *string;
			*string = '0';
			string[2] = '\0';
		}
	}
	
	if (strcmp(s, t[TI_JAHR].ob_spec.free_string) == 0) strcat(string, "JA");
	else if (strcmp(s, t[TI_MONAT].ob_spec.free_string) == 0) strcat(string, "MO");
	else if (strcmp(s, t[TI_WOCHE].ob_spec.free_string) == 0) strcat(string, "WO");
	else if (strcmp(s, t[TI_TAGE].ob_spec.free_string) == 0) strcat(string, "TA");
	else if (strcmp(s, t[TI_STUNDEN].ob_spec.free_string) == 0) strcat(string, "ST");
	else if (strcmp(s, t[TI_MINUTEN].ob_spec.free_string) == 0) strcat(string, "MI");
	else if (strcmp(s, t[TI_WERKTAGS].ob_spec.free_string) == 0) strcat(string, "WT");
	else if (strcmp(s, t[TI_FEIERTAGS].ob_spec.free_string) == 0) strcat(string, "FT");
	else if (strcmp(s, t[TI_EINMALIG].ob_spec.free_string) == 0) strcpy(string, "01EI");

	if (timer.ob[TI_NACHHOLEN].ob_state & SELECTED) strcat(string, "!");
	
	return(string);
}

/*-----------------------------------------------------------------
!	Setzt das RHYTMUS-Feld korrekt
+----------------------------------------------------------------*/

void setze_wiederholung(char *wiederh)

{
	char s[3];
	char *e;
	OBJECT *t;
	
	rsrc_gaddr(0, TIM_EVT, &t);
	
	if (wiederh[4] == '!') timer.ob[TI_NACHHOLEN].ob_state |= SELECTED;
	else timer.ob[TI_NACHHOLEN].ob_state &= ~SELECTED;

	e = timer.ob[TI_RHYTMUS].ob_spec.tedinfo->te_ptext;
	strncpy(s, &wiederh[2], 2);
	s[2] = '\0';
	
	if (strcmp(s, "JA") == 0) strcpy(e, t[TI_JAHR].ob_spec.free_string);
	else if (strcmp(s, "MO") == 0) strcpy(e, t[TI_MONAT].ob_spec.free_string);
	else if (strcmp(s, "WO") == 0) strcpy(e, t[TI_WOCHE].ob_spec.free_string);
	else if (strcmp(s, "TA") == 0) strcpy(e, t[TI_TAGE].ob_spec.free_string);
	else if (strcmp(s, "ST") == 0) strcpy(e, t[TI_STUNDEN].ob_spec.free_string);
	else if (strcmp(s, "MI") == 0) strcpy(e, t[TI_MINUTEN].ob_spec.free_string);
	else if (strcmp(s, "WT") == 0) strcpy(e, t[TI_WERKTAGS].ob_spec.free_string);
	else if (strcmp(s, "FT") == 0) strcpy(e, t[TI_FEIERTAGS].ob_spec.free_string);
	else if (strcmp(s, "EI") == 0) strcpy(e, t[TI_EINMALIG].ob_spec.free_string);
	setze_ob(&timer, TI_RHYTMUS, NULL);
	setze_ob(&timer, TI_NACHHOLEN, NULL);

}

/*-----------------------------------------------------------------
!	Bietet Fileselektor zur Programmauswahl
!	text = Titel
!	ext = Extension des Programms. Angabe z.b: "*.PRG"
!	Returnwert TRUE = Pfad wurde gendert!
+----------------------------------------------------------------*/

int setze_programm(char *name, char *text, char *ext)

{
	int i;
	char file[16], *c;
	char path[128]="A:";
	
	if (strchr(name, '\\') != NULL) {
		strcpy(path, name);
		c = strrchr(path, '\\');
		*(c++) = '\0';
		strcpy(file, c);
	} else {
		strcpy(file, name);
	
		Dgetpath(&path[2], 0);
		*path = Dgetdrv() + 'A';
	}
	
	strcat(path, "\\");
	strcat(path, ext);
	
	fsel_exinput(path, file, &i, text);
	
	if (i == 0) return(FALSE);
	if ((c = strrchr(path, '\\')) != NULL) *(++c) = '\0';
	strcpy(name, path);
	strcat(name, file);
	return(TRUE);
}

/*----------------------------------------------------------------
!	Stellt den popup fr alle Aktionen zusammen
+---------------------------------------------------------------*/

void popup_aktion(FENSTER *f, int start)

{
	OBJECT *tree;
	int i, anz;
	long l;
	FILE *fd;
	char file[128], *c, *e, *text, *t;
	char buffer[128];
	
	strcpy(file, pfad);
	strcat(file, "\\aktion.dat");

	fd = fopen(file, "r");		/* Erster Durchlauf: Testen wieviel Aktionen definiert sind	*/
	if (fd != NULL) {
		anz = 0;
		l = 0L;
		while (fgets(buffer, 127, fd) != NULL) {
			for (c = buffer; *c != '\0' && isspace(*c); c++);	/* Anfang suchen	*/
			if (*c == '[') {
				anz++;
				for (e = c; *e != '\0' && *e != ']'; e++);	/* Ende suchen	*/
				l += (long )(e - c + 2);					/* 2 Leerzeichen vorne!	*/
			}
		}
		fclose(fd);
	}
	
	tree = (OBJECT *)malloc((anz+1) * sizeof(OBJECT));
	if (tree == NULL) return;
	t = text = (char *)malloc(l);
	if (text == NULL) {
		free(tree);
		return;
	}

	fd = fopen(file, "r");		/* Zweiter Durchlauf: Aktionen eintragen	*/
	if (fd != NULL) {

		/* Vaterobjekt:	*/

		tree->ob_next = -1;
		tree->ob_head = 1;
		tree->ob_tail = 1;
		tree->ob_type = G_BOX;
		tree->ob_flags = NONE;
		tree->ob_state = SHADOWED;
		tree->ob_spec.index = 0x00FF1100L;
		tree->ob_x = f->ob[start].ob_x;
		tree->ob_y = f->ob[start].ob_y;
		tree->ob_width = f->ob[start].ob_width;
		tree->ob_height = f->ob[start].ob_height * anz;
	
		i = 1;
		while (fgets(buffer, 127, fd) != NULL) {
			for (c = buffer; *c != '\0' && isspace(*c); c++);	/* Anfang suchen	*/
			if (*c == '[') {
				for (e = c; *e != '\0' && *e != ']'; e++);	/* Ende suchen	*/
				*e = '\0';
				c++;
				strcpy(text, "  ");
				strcat(text, c);
				tree[i].ob_next = tree[i].ob_head = tree[i].ob_tail = -1;
				tree[i].ob_type = G_STRING;
				tree[i].ob_flags = SELECTABLE|EXIT;
				tree[i].ob_state = NORMAL;
				tree[i].ob_spec.free_string = text;
				text += strlen(text)+1;				/* Nchsten Freien Platz suchen!	*/

				tree[i].ob_x = 0;
				tree[i].ob_y = f->ob[start].ob_height * (i-1);
				tree[i].ob_width = f->ob[start].ob_width;
				tree[i].ob_height = f->ob[start].ob_height;
		
				objc_add(tree, 0, i);
				if (i++ >= anz) break;
			}
		}

		tree[i-1].ob_flags |= LASTOB;	/* Ende festlegen!	*/
	
		fclose(fd);
		dialog_popup(tree, f, start);
		free(t);
		free(tree);
	}
}

/*----------------------------------------------------------------
!	Stellt ein Popup dar
!	Liefert den Ergebnisknopf
+---------------------------------------------------------------*/

int dialog_popup(OBJECT *pop, FENSTER *f, int start)

{
	MENU popup, end_pop;
	int erg ,x , y, w, h, mx, my, mb, st, i, ev, in, sy, sh;
	int a1, p, s, a4;
	
	objc_offset(f->ob, start, &x, &y);
	w = f->ob[start].ob_width;
	h = f->ob[start].ob_height;
	
	if (pop[0].ob_flags & LASTOB) return(0);	/* Keine Aktion!	*/
	
	for (i = 1; 
			(strcmp(pop[i].ob_spec.free_string, f->ob[start].ob_spec.tedinfo->te_ptext) != 0) 
			&& (!(pop[i].ob_flags & LASTOB)); 
						i++);

	p = s = (_GemParBlk.global[0] >= 0x330 && !test_cookie("MagX")) ? TRUE : FALSE;

    if(_GemParBlk.global[0] >= 0x399) {		/* appl_getinfo vorhanden	*/
		if (!appl_getinfo(APG_MENUE, &a1, &p, &s, &a4)) p = s = FALSE;
	}

	if (pop[1].ob_flags & LASTOB) {		/* Nur eine Wahlmglichkeit?	*/
		erg = 1;
	} else if (p) {
		popup.mn_tree = pop;
		popup.mn_menu = 0;
		popup.mn_item = i;
		popup.mn_scroll = s;
		popup.mn_keystate = 0;
		if (menu_popup(&popup, x, y, &end_pop) == 0) return(-1);

		erg = end_pop.mn_item;
		if (erg < 0) return(erg);
	} else if (test_cookie("MagX")) {
		x += (pop->ob_width / 2);
		y -= (pop[1].ob_height * (i-1));
		erg = form_popup(pop, x, y);
		if (erg < 0) return(erg);
	} else {
		mx = x;
		my = y;
		
		y -= (pop[1].ob_height * (i-1));
		wind_get(0, WF_WORKXYWH, &i, &sy, &i, &sh);
		i = (sy + sh) - pop->ob_height;		/* maximale y-Koordinate	*/
		if (y > i) y = i;
		if (y < sy) y = sy;
		
		pop->ob_x = x;
		pop->ob_y = y;
		wind_update(BEG_MCTRL);
		form_dial(FMD_START, 1,1,1,1, pop->ob_x - 2, pop->ob_y - 2, pop->ob_width + 4, pop->ob_height + 4);
		objc_draw(pop, 0, 2, pop->ob_x - 2, pop->ob_y - 2, pop->ob_width + 4, pop->ob_height + 4);

		do {
			erg = objc_find(pop, 0, 2, mx, my);
			if (erg >= 0) {
				in = TRUE;	/* Maus innerhalb des Popup	*/
				objc_offset(pop, erg, &x, &y);
				h = pop[erg].ob_height;
				if (!(pop[erg].ob_state & DISABLED)) 
					objc_change(pop, erg, 0, x, y, w, h, SELECTED, TRUE);
			} else {
				in = FALSE;	/* Maus auerhalb des Popup	*/
				x = pop->ob_x;
				y = pop->ob_y;
				h = pop->ob_height;
			}
			ev = evnt_multi(MU_M1|MU_BUTTON, 1,1,1, 
						in, x, y, w, h, 
						0,0,0,0,0,
						NULL, 0,0,
						&mx, &my, &mb, &st, &i, &i);
			if (ev & MU_M1) {
				if ((erg > 0) && (!(pop[erg].ob_state & DISABLED)))
					objc_change(pop, erg, 0, x, y, w, h, NORMAL, TRUE);
			}
		} while(!(ev & MU_BUTTON));

		form_dial(FMD_FINISH, 1,1,1,1, pop->ob_x - 2, pop->ob_y - 2, pop->ob_width + 4, pop->ob_height + 4);
		wind_update(END_MCTRL);
		if ((erg < 0) || (pop[erg].ob_state & DISABLED)) return(erg);
		pop[erg].ob_state &= ~SELECTED;
	}
	setze_ob(f, start, pop[erg].ob_spec.free_string);
	return(erg);
}

/*----------------------------------------------------------------
!	Setzt den Scan und ASCII-Code einer Taste
+----------------------------------------------------------------*/

void setze_code(char *scan_ascii)

{
	OBJECT *key;

	int i;
	rsrc_gaddr(0, TAST_EINGABE, &key);
	form_center(key, &i, &i, &i, &i);
	
	wind_update(BEG_UPDATE);
	form_dial(FMD_START, 1,1,1,1, key->ob_x - 2, key->ob_y - 2, key->ob_width + 4, key->ob_height + 4);
	objc_draw(key, 0, 2, key->ob_x - 2, key->ob_y - 2, key->ob_width + 4, key->ob_height + 4);

	sprintf(scan_ascii, "%04X", evnt_keybd());
	
	form_dial(FMD_FINISH, 1,1,1,1, key->ob_x - 2, key->ob_y - 2, key->ob_width + 4, key->ob_height + 4);
	wind_update(END_UPDATE);
}
/*----------------------------------------------------------------
!	Berechnet aus zwei Rechtecken das Rechteck, das gezeichnet
!	werden soll
+-----------------------------------------------------------------*/

int	intersect(GRECT *re_1, GRECT *re_2)

{
	GRECT erg;
	if (re_1->g_x + re_1->g_w <= re_2->g_x) return(FALSE);
	if (re_2->g_x + re_2->g_w <= re_1->g_x) return(FALSE);
	if (re_1->g_y + re_1->g_h <= re_2->g_y) return(FALSE);
	if (re_2->g_y + re_2->g_h <= re_1->g_y) return(FALSE);
	erg.g_x = MAX(re_1->g_x, re_2->g_x);
	erg.g_y = MAX(re_1->g_y, re_2->g_y);
	erg.g_w = MIN(re_1->g_x + re_1->g_w, re_2->g_x + re_2->g_w) - erg.g_x;
	erg.g_h = MIN(re_1->g_y + re_1->g_h, re_2->g_y + re_2->g_h) - erg.g_y;
	re_1->g_x = erg.g_x;
	re_1->g_y = erg.g_y;
	re_1->g_w = erg.g_w;
	re_1->g_h = erg.g_h;
	return(TRUE);
}


/*----------------------------------------------------------------------
!	Setzt die erste Zeile im Objekt
!	Es wird kein CHECK & SET verwendet, da keine Zeitkritischen
!	Verfahren implementiert sind!
+----------------------------------------------------------------------*/

void setze_ob(FENSTER *f, int kind, char *text)

{
	TEDINFO *te;
	int type;
	int x,y,w,h;
	int tiefe = 0; 
	
	type = f->ob[kind].ob_type;
	te = f->ob[kind].ob_spec.tedinfo;
	
	if ((text != NULL && (
		(type == G_TEXT) || 
		(type == G_BOXTEXT) ||
		(type == G_FTEXT) || 
		(type == G_FBOXTEXT)))) {
		*te->te_ptext = '\0';
		strncat(te->te_ptext, text, te->te_txtlen - 1);
	} else if ((text != NULL) && (type == G_STRING)) {
		strcpy(f->ob[kind].ob_spec.free_string, text);
	} else tiefe = 10;
	
	if (!f->aktiv) return;
	wind_update(BEG_UPDATE);
	wind_get(f->wind_handle, WF_FIRSTXYWH, &x, &y, &w, &h);
	while (w != 0 || h != 0) {
		objc_draw(f->ob, kind, tiefe, x, y, w, h);
		wind_get(f->wind_handle, WF_NEXTXYWH, &x, &y, &w, &h);
	} 
	wind_update(END_UPDATE);
}

/*----------------------------------------------------------------------
!	Setzt die gre des vertikalen Sliders
+----------------------------------------------------------------------*/

void setze_vslsize(FENSTER *akt)

{
	long l;
	
	if (akt->anz <= 5) {
		akt->vslide = 1000;
		wind_set(akt->wind_handle, WF_VSLSIZE, akt->vslide);
		wind_set(akt->wind_handle, WF_VSLIDE, 0);
	} else {
		l = ((long )akt->anz * 1000) / 5;
		if (l == 0) l = 1;
		akt->vslide = (int )(1000000L / l);
		wind_set(akt->wind_handle, WF_VSLSIZE, akt->vslide);
		wind_set(akt->wind_handle, WF_VSLIDE, (int )((1000l * (long )(akt->top_line)) / (long )(akt->anz - 5)));
	}
}

/*----------------------------------------------------------------------
!	Initialisiert das RSC-File
!	Liest vorher aus der INI-Datei das RSC-File!
+---------------------------------------------------------------------*/

void rsrc_init(void)

{
	int i, a;
	char file[128], *c;
	char t[256];
	FILE *fd;
	
	strcpy(file, pfad);
	strcat(file, "\\BEM_EDIT.INF");
	fd = fopen(file, "r");
	if (fd != NULL) {
		while (fgets(t, 127, fd) != NULL) {
			if ((c = strtok(t, " \t\n")) == NULL) continue;
			if (stricmp(c, "Use-RSCFile:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) {
					*konf_edit_rsc = '\0';
					strncat(konf_edit_rsc, c, 128);
				}
				break;	/* Mehr wolln wir nicht wissen	*/
			}
		}
		fclose(fd);
	}
	
	if (test_cookie("MagX")) parallel = TRUE;
	if (test_cookie("MiNT")) {
		parallel = TRUE;
		menu_register(ap_id,"  B.E.M.-Editor");   /* Dann tragen wir uns mal in das DESK-Men ein und erhalten unsere Eintragsnr. */
	}
	
    if(_GemParBlk.global[0] >= 0x399) {		/* appl_getinfo vorhanden	*/
		if (appl_getinfo(APG_SHWR, &i, &i, &a ,&i) && !a) parallel = TRUE;	/* shel_write startet parallel!	*/
	}

	strcpy(file, pfad);
	c = strrchr(file, '\\');
	if (c != NULL) *c = '\0';
	strcat(file, "\\BEM_EDIT.RSC");
	
	if (rsrc_load(konf_edit_rsc) == 0) {
		sprintf(t, "[3][Can't load file/|Kann Datei nicht finden|%s][Quit/Abbruch]", konf_edit_rsc);
		form_alert(1, t);
		appl_abmelden();
		exit(0);
	}

	rsrc_gaddr(0, MENUE, &menu);
	menu_ienable(menu, MENU_SAVEALL, FALSE);
	menu_ienable(menu, MENU_SAVE, FALSE);
	menu_bar(menu, TRUE);

	rsrc_gaddr(0, MESSAGES, &msg);	/* Fenstertitel und Meldungen aus dem RSC setzen	*/
		
	setze_fenster(&haupt, HAUPT, NAME|CLOSER|MOVER|INFO, c_titel, c_text);
	haupt.edit_ob = 0;
	
	setze_fenster(&timer, TIMER, NAME|CLOSER|MOVER|UPARROW|DNARROW|VSLIDE, msg[MSG_TIMER].ob_spec.free_string, NULL);
	timer.vslide = 1000;
	timer.top_line = timer.anz = 0;
	timer.edit_ob = TI_DATUM;
	
	timer.ob[TI_DATUM].ob_spec.tedinfo->te_ptext[0] = 
	timer.ob[TI_ZEIT].ob_spec.tedinfo->te_ptext[0] = 
	timer.ob[TI_EREIGNIS].ob_spec.tedinfo->te_ptext[0] = 
	timer.ob[TI_WIEDERH].ob_spec.tedinfo->te_ptext[0] = '\0';
	
	strcpy(timer.ob[TI_GUELTIG].ob_spec.tedinfo->te_ptext, "1");
	timer.ob[TI_LOESCHEN].ob_state |= DISABLED;
	timer.ob[TI_EDIT].ob_state |= DISABLED;
	timer.ob[ti_sort].ob_state |= DISABLED;

	setze_fenster(&programm, PROGRAMM, NAME|CLOSER|MOVER|UPARROW|DNARROW|VSLIDE, msg[MSG_PROGRAMM].ob_spec.free_string, NULL);
	programm.vslide = 1000;
	programm.top_line = programm.anz = 0;
	programm.edit_ob = TP_PROGRAMM;

	programm.ob[TP_PROGRAMM].ob_spec.tedinfo->te_ptext[0] = 
	programm.ob[TP_SEREIGNIS].ob_spec.free_string[0] = 
	programm.ob[TP_EEREIGNIS].ob_spec.free_string[0] = '\0';
	
	programm.ob[PR_LOESCHEN].ob_state |= DISABLED;
	programm.ob[PR_EDIT].ob_state |= DISABLED;
	programm.ob[pr_sort].ob_state |= DISABLED;

	setze_fenster(&maus, MAUS, NAME|CLOSER|MOVER|UPARROW|DNARROW|VSLIDE, msg[MSG_MAUS].ob_spec.free_string, NULL);
	maus.vslide = (int )(1000000L / ((max_ma_evt * 1000L) / 5L));
	maus.top_line = 0;
	maus.anz = max_ma_evt;
	maus.edit_ob = TM_NAME;

	maus.ob[TM_NAME].ob_spec.tedinfo->te_ptext[0] = 
	maus.ob[TM_EREIGNIS].ob_spec.tedinfo->te_ptext[0] = '\0';
	
	maus.ob[TM_LOESCHEN].ob_state |= DISABLED;
	maus.ob[TM_EDIT].ob_state |= DISABLED;
	maus.ob[ma_sort].ob_state |= DISABLED;

	setze_fenster(&device, DEVICE, NAME|CLOSER|MOVER|UPARROW|DNARROW|VSLIDE, msg[MSG_SCHNITTST].ob_spec.free_string, NULL);
	device.vslide = 1000;
	device.top_line = device.anz = 0;
	device.edit_ob = SS_STRING;

	device.ob[SS_STRING].ob_spec.tedinfo->te_ptext[0] = 
	device.ob[SS_EREIGNIS].ob_spec.tedinfo->te_ptext[0] = '\0';
	
	device.ob[SS_LOESCHEN].ob_state |= DISABLED;
	device.ob[SS_EDIT].ob_state |= DISABLED;
	device.ob[ss_sort].ob_state |= DISABLED;

	setze_fenster(&tastatur, TASTATUR, NAME|CLOSER|MOVER|UPARROW|DNARROW|VSLIDE, msg[MSG_TASTATUR].ob_spec.free_string, NULL);
	tastatur.vslide = 1000;
	tastatur.top_line = tastatur.anz = 0;
	tastatur.edit_ob = TA_SCAN;

	tastatur.ob[TA_SCAN].ob_spec.tedinfo->te_ptext[0] = 
	tastatur.ob[TA_EREIGNIS].ob_spec.tedinfo->te_ptext[0] = '\0';
	
	tastatur.ob[TA_LOESCHEN].ob_state |= DISABLED;
	tastatur.ob[TA_EDIT].ob_state |= DISABLED;
	tastatur.ob[TAS_ASC].ob_state |= SELECTED;
	tastatur.ob[TAS_SCAN].ob_state |= SELECTED;
	tastatur.ob[ta_sort].ob_state |= DISABLED;

	setze_fenster(&feiertag, FEIERTAGE, NAME|CLOSER|MOVER|UPARROW|DNARROW|VSLIDE, msg[MSG_FEIERTAG].ob_spec.free_string, NULL);
	feiertag.vslide = 1000;
	feiertag.top_line = feiertag.anz = 0;
	feiertag.edit_ob = FE_DATUM;

	feiertag.ob[FE_DATUM].ob_spec.tedinfo->te_ptext[0] = 
	feiertag.ob[FE_BEMERKUNG].ob_spec.tedinfo->te_ptext[0] = '\0';
	
	feiertag.ob[FE_LOESCHEN].ob_state |= DISABLED;
	feiertag.ob[FE_EDIT].ob_state |= DISABLED;
	feiertag.ob[ft_sort].ob_state |= DISABLED;

	setze_fenster(&konfig, KONFIG, NAME|CLOSER|MOVER, msg[MSG_SYSTEM].ob_spec.free_string, NULL);
	konfig.vslide = konfig.top_line = konfig.anz = 0;
	
	konfig.edit_init = FALSE;
	if (env_gesetzt) {
		konfig.ob[KONF_EVT_PFAD].ob_state |= DISABLED;
		konfig.edit_ob = KONF_EVT_PFAD;
	} else konfig.edit_ob = KONF_TEXTEDIT;

	timer.save_button = TI_SAVE;
	programm.save_button = PR_SAVE;
	maus.save_button = TM_SAVE;
	device.save_button = SS_SAVE;
	tastatur.save_button = TA_SAVE;
	feiertag.save_button = FE_SAVE;
	haupt.save_button = -1;
	konfig.save_button = KONF_SICHERN;
	
	timer.deff_button = TI_NEU;
	programm.deff_button = PR_NEU;
	maus.deff_button = TM_EDIT;
	device.deff_button = SS_NEU;
	tastatur.deff_button = TA_NEU;
	feiertag.deff_button = FE_NEU;

	timer.menu = MENU_TIMER;
	programm.menu = MENU_PROGRAMM;
	maus.menu = MENU_MAUS;
	device.menu = MENU_DEVICE;
	tastatur.menu = MENU_TASTATUR;
	feiertag.menu = MENU_FEIERTAG;
	haupt.menu = -1;
	konfig.menu = -1;

	haupt.bearbeiten = bearbeite_haupt;
	haupt.speichern = NULL;

	timer.bearbeiten = bearbeite_timer;			/* Adresse der Routinen	*/
	timer.speichern = speicher_timer_ereignis;

	maus.bearbeiten = bearbeite_maus;
	maus.speichern = speicher_maus_ereignis;

	programm.bearbeiten = bearbeite_programm;
	programm.speichern = speicher_prog_ereignis;
	
	device.bearbeiten = bearbeite_device;
	device.speichern = speicher_ss_ereignis;
	
	tastatur.bearbeiten = bearbeite_tastatur;
	tastatur.speichern = speicher_tast_ereignis;

	feiertag.bearbeiten = bearbeite_feiertag;
	feiertag.speichern = NULL;
	
	konfig.bearbeiten = bearbeite_konfig;
	konfig.speichern = speicher_syskonf;

	timer.selected = programm.selected = maus.selected = device.selected = tastatur.selected = 
	feiertag.selected = konfig.selected = -1;
}

/*-----------------------------------------------------------------------------
!	Setzt die Werte fr ein Fensterobjekt
+----------------------------------------------------------------------------*/

void setze_fenster(FENSTER *f, int objekt, int art, char *titel, char *info)

{
	int x, y, br, ho;
	rsrc_gaddr(0, objekt, &(f->ob));
	f->art = art;
	
	form_center(f->ob, &x, &y, &br, &ho);
	wind_calc(WC_BORDER, f->art, x, y, br, ho, &(f->fx), &(f->fy), &(f->fw), &(f->fh));
	f->titel = titel;
	f->info = info;

	f->dx = f->ob->ob_x - f->fx;
	f->dy = f->ob->ob_y - f->fy;
	f->wind_handle = -1;
	f->changed = f->aktiv = FALSE;
}

/*-----------------------------------------------------------------------------
!	ffnet ein fenster. Wenn noch kein Handle vorhanden, dann wird es created
!	Wenn bereits offen, dann wird es getoppt
+-----------------------------------------------------------------------------*/

void oeffne_fenster(FENSTER *f)

{
	if (f->wind_handle < 0) f->wind_handle = wind_create(f->art, f->fx, f->fy, f->fw, f->fh);
	
	if (f->wind_handle >= 0) {

		if (f->art & VSLIDE) {
			wind_set(f->wind_handle, WF_VSLSIZE, f->vslide);
			wind_set(f->wind_handle, WF_VSLIDE, 0);	/* oben!	*/
		}
		if (f->titel != NULL) wind_set(f->wind_handle, WF_NAME, f->titel);
		if (f->info != NULL) wind_set(f->wind_handle, WF_INFO, f->info);

		if (!f->aktiv) {
			wind_open(f->wind_handle, f->fx, f->fy, f->fw, f->fh);
			f->aktiv = TRUE;
		} else wind_set(f->wind_handle, WF_TOP);

		if (f->changed) menu_ienable(menu, MENU_SAVE, FALSE);
		if (f->menu >= 0) menu_icheck(menu, f->menu, TRUE);

	} else {
		form_alert(1, msg[MSG_ERRFENSTER].ob_spec.free_string);
	}
	edit_win = f;
}

/*-----------------------------------------------------------------------------------
!	Schliet ein Fenster und lscht dieses gleich wieder.
+-----------------------------------------------------------------------------------*/

void schliesse_fenster(FENSTER *f)

{
	if ((f->wind_handle >= 0) && (f->aktiv)) {
		wind_close(f->wind_handle);
		f->aktiv = FALSE;
		wind_delete(f->wind_handle);
		f->wind_handle = -1;
		if (f->menu >= 0) menu_icheck(menu, f->menu, FALSE);
	}
	update_save_flags();
}

/*-------------------------------------------------------------------------------------
!	Liest die Datei TIMER.EVT ein und stellt gengend Speicherplatz zur Verfgung
!	Um weitere NEU_TIMER-Ereignisse einfgen zu knnen!
!	Liefert den Zeiger auf die Struktur zurck
+------------------------------------------------------------------------------------*/

TI_EVT *lade_timer_ereignis(int	*ti_anz)

{
	struct stat st;
	char file[128];
	int i = 0;
	TI_EVT *ti_mem, *ti;
	FILE *fd;
	char buffer[128], *c, dummy[5];
	
	strcpy(file, pfad);
	strcat(file, "\\TIMER.EVT");
	
	if (stat(file, &st) != 0) max_ti_evt = MAX_TI_EVT;
	else max_ti_evt = (int )((st.st_size / 20) + MAX_TI_EVT);
	
	ti = ti_mem = (TI_EVT *)malloc(max_ti_evt * sizeof(TI_EVT));
	if (ti == NULL) return(NULL);
	*ti_anz = 0;
	
	memset(ti, 0, max_ti_evt * sizeof(TI_EVT));
	
	timer.changed = FALSE;
	fd = fopen(file, "r");
	if (fd != NULL) {
		while (fgets(buffer, 127, fd) != NULL) {
			if (strlen(buffer) < 15) continue;

			*(ti->zeit) = *(ti->gueltig) = '\0';
			strncat(ti->zeit, (c = strtok(buffer, " \t\n")), 14);
			if (c[14] == '-') strncat(ti->gueltig, &c[15], 4);
			
			strncpy(dummy, c, 4);
			strncpy(ti->zeit, &c[6], 2);
			strncpy(&ti->zeit[2], &c[4], 2);
			strncpy(&ti->zeit[4], dummy, 4);

			c = strtok(NULL, " \t\n");
			if (isdigit(*(c+1)) && isdigit(*c)) strcpy(ti->wiederh, c);
			else if (isdigit(*c)) {
				ti->wiederh[0] = '0';
				strcpy(&ti->wiederh[1], c);
			} else {
				strcpy(ti->wiederh, "01");
				strcpy(&ti->wiederh[2], c);
			}
			c = strtok(NULL, " \t\n");
			strcpy(ti->ereignis, strtok(NULL, " \t\n"));
			i++;
			ti++;
		}
		fclose(fd);
		*ti_anz = i;
		sort_timer(ti_mem, max_ti_evt, ti_sort);
	}
	if (i < 5) for (i += TI_1; i < TI_1 + 5; timer.ob[i++].ob_flags &= ~SELECTABLE);
	return(ti_mem);
}

/*-------------------------------------------------------------------------------------
!	Liest die Datei PROGRAMM.EVT ein und stellt gengend Speicherplatz zur Verfgung
!	Um weitere NEU_PROG-Ereignisse einfgen zu knnen!
!	Liefert den Zeiger auf die Struktur zurck
+------------------------------------------------------------------------------------*/

PR_EVT *lade_prog_ereignis(int *pr_anz)

{
	struct stat st;
	char file[128];
	int i = 0;
	PR_EVT *pr_mem, *pr;
	FILE *fd;
	char buffer[128], *c;
	
	strcpy(file, pfad);
	strcat(file, "\\PROGRAMM.EVT");
	
	if (stat(file, &st) != 0) max_pr_evt = MAX_PR_EVT;
	else max_pr_evt = (int )((st.st_size / 5) + MAX_PR_EVT);
	
	pr = pr_mem = (PR_EVT *)malloc(max_pr_evt * sizeof(PR_EVT));
	if (pr == NULL) return(NULL);
	*pr_anz = 0;
	
	memset(pr, 0, max_pr_evt * sizeof(PR_EVT));

	programm.changed = FALSE;
		
	fd = fopen(file, "r");
	if (fd != NULL) {
		while (fgets(buffer, 127, fd) != NULL) {
			if (strlen(buffer) < 5) continue;
			if ((c = strtok(buffer, " \t\n")) != NULL) strcpy(pr->name, c);
			else continue;
			if ((c = strtok(NULL, " \t\n")) != NULL) strcpy(pr->s_ereignis, c);
			else strcpy(pr->s_ereignis, "-");
			if ((c = strtok(NULL, " \t\n")) != NULL) strcpy(pr->e_ereignis, c);
			else strcpy(pr->e_ereignis, "-");
			
			i++;
			pr++;
		}
		fclose(fd);
		*pr_anz = i;
		sort_prog(pr_mem, max_pr_evt, pr_sort);
	}
	if (i < 5) for (i += PR_1; i < PR_1 + 5; programm.ob[i++].ob_flags &= ~SELECTABLE);
	return(pr_mem);
}

/*-------------------------------------------------------------------------------------
!	Liest die Datei BUTTON.EVT ein und stellt gengend Speicherplatz zur Verfgung
!	Liefert den Zeiger auf die Struktur zurck
+------------------------------------------------------------------------------------*/

MA_EVT *lade_maus_ereignis(void)

{
	char file[128];
	MA_EVT *ma_mem, *ma;
	FILE *fd;
	char buffer[128], *c;
	
	strcpy(file, pfad);
	strcat(file, "\\BUTTON.EVT");
	
	ma_mem = (MA_EVT *)malloc(max_ma_evt * sizeof(MA_EVT));
	if (ma_mem == NULL) return(NULL);
	
	memset(ma_mem, 0, max_ma_evt * sizeof(MA_EVT));
	
	maus.changed = FALSE;
	fd = fopen(file, "r");
	if (fd != NULL) {
		while (fgets(buffer, 127, fd) != NULL) {
			if (strlen(buffer) < 5) continue;

			c = strtok(buffer, " \t\n");
			ma = &ma_mem[atoi(c) - 1];
			
			strcpy(ma->name, strtok(NULL, " \t\n"));
			strcpy(ma->ereignis, strtok(NULL, " \t\n"));
		}
		fclose(fd);
	}
	return(ma_mem);
}

/*-------------------------------------------------------------------------------------
!	Liest die Datei KEYBOARD.EVT ein und stellt gengend Speicherplatz zur Verfgung
!	Um weitere NEU_KEY-Ereignisse einfgen zu knnen!
!	Liefert den Zeiger auf die Struktur zurck
+------------------------------------------------------------------------------------*/

TA_EVT *lade_tast_ereignis(int *ta_anz)

{
	struct stat st;
	char file[128];
	int i = 0;
	TA_EVT *ta_mem, *ta;
	FILE *fd;
	char buffer[128], dummy[5], *c;
	
	strcpy(file, pfad);
	strcat(file, "\\KEYBOARD.EVT");
	
	if (stat(file, &st) != 0) max_ta_evt = MAX_TA_EVT;
	else max_ta_evt = (int )((st.st_size / 5) + MAX_TA_EVT);
	
	ta = ta_mem = (TA_EVT *)malloc(max_ta_evt * sizeof(TA_EVT));
	if (ta == NULL) return(NULL);
	*ta_anz = 0;
	
	memset(ta, 0, max_ta_evt * sizeof(TA_EVT));

	tastatur.changed = FALSE;
		
	fd = fopen(file, "r");
	if (fd != NULL) {
		while (fgets(buffer, 127, fd) != NULL) {
			if (strlen(buffer) < 6) continue;

			c = strtok(buffer, " \t\n");
			dummy[2] = '\0';
			strncpy(dummy, c, 2);
			if (*dummy == '-') ta->scan = -1;
			else ta->scan = xtoi(dummy);
			strncpy(dummy, &c[2], 2);
			if (*dummy == '-') ta->ascii = -1;
			else ta->ascii = xtoi(dummy);
			strcpy(ta->ereignis, strtok(NULL, " \t\n"));

			i++;
			ta++;
		}
		fclose(fd);
		*ta_anz = i;
		sort_tast(ta_mem, max_ta_evt, ta_sort);
	}
	if (i < 5) for (i += TA_1; i < TA_1 + 5; tastatur.ob[i++].ob_flags &= ~SELECTABLE);
	return(ta_mem);
}

/*-------------------------------------------------------------------------------------
!	Liest die Datei SS.EVT ein und stellt gengend Speicherplatz zur Verfgung
!	Um weitere NEU_SS-Ereignisse einfgen zu knnen!
!	Liefert den Zeiger auf die Struktur zurck
+------------------------------------------------------------------------------------*/

SS_EVT *lade_ss_ereignis(int *ss_anz)

{
	struct stat st;
	char file[128];
	int i = 0;
	SS_EVT *ss_mem, *ss;
	FILE *fd;
	char buffer[128], *d, *t, *e, *c;
	
	strcpy(file, pfad);
	strcat(file, "\\SS.EVT");
	
	if (stat(file, &st) != 0) max_ss_evt = MAX_SS_EVT;
	else max_ss_evt = (int )((st.st_size / 5) + MAX_SS_EVT);
	
	ss = ss_mem = (SS_EVT *)malloc(max_ss_evt * sizeof(SS_EVT));
	if (ss == NULL) return(NULL);
	*ss_anz = 0;
	
	memset(ss, 0, max_ss_evt * sizeof(SS_EVT));

	device.changed = FALSE;
		
	fd = fopen(file, "r");
	if (fd != NULL) {
		while (fgets(buffer, 127, fd) != NULL) {
			for(d = buffer; isspace(*d); d++);
			for(t = d; !isspace(*t); t++);
			*(t++) = '\0';
			for(; isspace(*t); t++);
			if (*t == '\"') {
				for(e = ++t; *e != '\"'; e++);
				*e = '\0';
				e++;
			} else for(e = t; !isspace(*e); e++);
			*(e++) = '\0';
			for( ;isspace(*e); e++);
			for(c = e; !isspace(*c); c++);
			*c = '\0';		
			
			if ((d == NULL) || (t == NULL) || (e == NULL)) continue;
			if ((strlen(d) == 0) || (strlen(t) == 0) || (strlen(e) == 0)) continue;
				
			ss->dev = get_dev_nr(d);
			strcpy(ss->string, t);
			strcpy(ss->ereignis, e);
			
			i++;
			ss++;
		}
		fclose(fd);
		*ss_anz = i;
		sort_ss(ss_mem, max_ss_evt, ss_sort);
	}
	if (i < 5) for (i += SS_1; i < SS_1 + 5; device.ob[i++].ob_flags &= ~SELECTABLE);
	return(ss_mem);
}

/*-------------------------------------------------------------------------------------
!	Speichert die Datei TIMER.EVT ein und stellt gengend Speicherplatz zur Verfgung
+------------------------------------------------------------------------------------*/

void speicher_timer_ereignis(void)

{
	char file[128];
	int i = 0;
	TI_EVT *ti;
	FILE *fd;
	char buffer[20];
	
	if (!ordner(pfad)) return;
	strcpy(file, pfad);
	strcat(file, "\\TIMER.EVT");
	
	fd = fopen(file, "w");
	if (fd != NULL) {
		for (i = 0, ti = ti_evt; i < timer.anz; i++, ti++) {
			buffer[0] = '\0';
			strncat(buffer, &ti->zeit[4], 4);
			strncat(buffer, &ti->zeit[2], 2);
			strncat(buffer, ti->zeit, 2);
			strcat(buffer, &ti->zeit[8]);

			fprintf(fd, "%s-%i   %s \t%i \t%s\n", buffer, atoi(ti->gueltig), ti->wiederh, i, ti->ereignis);
		}
		fclose(fd);
		if (timer.anz == 0) unlink(file);

		timer.changed = FALSE;
		update_save_flags();
		send_update();
	}
}

/*-------------------------------------------------------------------------------------
!	Speichert die Datei PROGRAMM.EVT
+------------------------------------------------------------------------------------*/

void speicher_prog_ereignis(void)

{
	char file[128];
	int i = 0;
	PR_EVT *pr;
	FILE *fd;
	
	if (!ordner(pfad)) return;
	strcpy(file, pfad);
	strcat(file, "\\PROGRAMM.EVT");
	
	fd = fopen(file, "w");
	if (fd != NULL) {
		for (i = 0, pr = pr_evt; i < programm.anz; i++, pr++) {
			fprintf(fd, "%s \t%s \t%s\n", pr->name, pr->s_ereignis, pr->e_ereignis);
		}
		fclose(fd);
		if (programm.anz == 0) unlink(file);

		update_save_flags();
		programm.changed = FALSE;
		
		send_update();
	}
}

/*-------------------------------------------------------------------------------------
!	Speichert die Datei Keyboard.EVT
+------------------------------------------------------------------------------------*/

void speicher_tast_ereignis(void)

{
	char file[128], buffer[10];
	int i = 0;
	TA_EVT *ta;
	FILE *fd;
	
	if (!ordner(pfad)) return;
	strcpy(file, pfad);
	strcat(file, "\\KEYBOARD.EVT");
	
	fd = fopen(file, "w");
	if (fd != NULL) {
		for (i = 0, ta = ta_evt; i < tastatur.anz; i++, ta++) {
			if (ta->scan < 0) strcpy(buffer, "--");
			else sprintf(buffer, "%02X", ta->scan);
			if (ta->ascii < 0) strcat(buffer, "--");
			else sprintf(&buffer[2], "%02X", ta->ascii);
			fprintf(fd, "%s \t%s\n", buffer, ta->ereignis);
		}
		fclose(fd);
		if (tastatur.anz == 0) unlink(file);

		tastatur.changed = FALSE;
		update_save_flags();
		send_update();
	}
}

/*-------------------------------------------------------------------------------------
!	Speichert die Datei BUTTON.EVT 
+------------------------------------------------------------------------------------*/

void speicher_maus_ereignis()

{
	char file[128];
	int i = 0, anz = 0;
	MA_EVT *ma;
	FILE *fd;
	
	if (!ordner(pfad)) return;
	strcpy(file, pfad);
	strcat(file, "\\BUTTON.EVT");
	
	fd = fopen(file, "w");
	if (fd != NULL) {
		for (i = 0, ma = ma_evt; i < max_ma_evt; i++, ma++) {
			if ((*ma->name == '\0') || (*ma->ereignis == '\0')) continue;
			fprintf(fd, "%i \t%s \t%s\n", i+1, ma->name, ma->ereignis);
			anz++;
		}
		fclose(fd);
		if (anz == 0) unlink(file);

		maus.changed = FALSE;
		update_save_flags();
		send_update();
	}
}

/*-------------------------------------------------------------------------------------
!	Speichert die Datei SS.EVT ein und stellt gengend Speicherplatz zur Verfgung
+------------------------------------------------------------------------------------*/

void speicher_ss_ereignis(void)

{
	char file[128];
	int i = 0;
	SS_EVT *ss;
	FILE *fd;
	char buffer[20];
	
	if (!ordner(pfad)) return;

	strcpy(file, pfad);
	strcat(file, "\\SS.EVT");
	
	fd = fopen(file, "w");
	if (fd != NULL) {
		for (i = 0, ss = ss_evt; i < device.anz; i++, ss++) {
			set_dev(ss->dev, buffer);
			fprintf(fd, "%s \t\"%s\" \t%s\n", buffer, ss->string, ss->ereignis);
		}
		fclose(fd);

		if (device.anz == 0) unlink(file);
		
		device.changed = FALSE;
		update_save_flags();
		send_update();
	}
}

/*---------------------------------------------------------------
!	Speichert die EVENTMAN.INF-Datei und ein Wert der BEM_EDIT.INF
+---------------------------------------------------------------*/

void speicher_syskonf(void)

{
	FILE *fd_r, *fd_w;
	char file_r[128], file_w[128];
	char buffer[152];
	
	if (!ordner(konf_syspfad)) return;
	
	strcpy(file_r, konf_syspfad);
	strcat(file_r, "\\EVENTMAN.INF");
	strcpy(file_w, konf_syspfad);
	strcat(file_w, "\\EVENTMAN.BAK");

	fd_r = fopen(file_r, "r");
	fd_w = fopen(file_w, "w");
	
	konf_sek_prg = atoi(konfig.ob[KONF_SEKPROG].ob_spec.tedinfo->te_ptext);
	konf_sek_dat = atoi(konfig.ob[KONF_SEKEVT].ob_spec.tedinfo->te_ptext);
	konf_info = atoi(konfig.ob[KONF_INFO].ob_spec.tedinfo->te_ptext);
	
	if (fd_w != NULL) {
		fprintf(fd_w, "AccFilePath: %s\n", konf_syspfad);
		fprintf(fd_w, "Use-RSCFile: %s\n", konf_event_rsc);
		fprintf(fd_w, "BEMEditPath: %s\n", konf_bemedit);
		fprintf(fd_w, "SekProgFind: %d\n", konf_sek_prg);
		fprintf(fd_w, "SekEvtDatei: %d\n", konf_sek_dat);
		fprintf(fd_w, "INFO-Anzahl: %d\n", konf_info);
		
		if (fd_r != NULL) {
			while  (fgets(buffer, 151, fd_r) != NULL) {
				if ((strstr(buffer, "Window") != NULL) || 
					(strnicmp(buffer, "KnopfInfoln", 11) == 0)) fputs(buffer, fd_w);
			}
			fclose(fd_r);
		}
		fclose(fd_w);
		unlink(file_r);
		rename(file_w, file_r);
		konfig.changed = FALSE;
	}

	strcpy(file_r, konf_syspfad);
	strcat(file_r, "\\BEM_EDIT.INF");
	strcpy(file_w, konf_syspfad);
	strcat(file_w, "\\BEM_EDIT.BAK");

	fd_r = fopen(file_r, "r");
	fd_w = fopen(file_w, "w");
	
	if (fd_w != NULL) {
		fprintf(fd_w, "AktionsEdit: %s\n", konf_editor);
		fprintf(fd_w, "Use-RSCFile: %s\n", konf_edit_rsc);
		
		if (fd_r != NULL) {
			while  (fgets(buffer, 151, fd_r) != NULL) {
				if (strnicmp(buffer, "AktionsEdit:", 12) == 0) continue;
				else if (strnicmp(buffer, "Use-RSCFile:", 12) == 0) continue;
				else fputs(buffer, fd_w);
			}
			fclose(fd_r);
		}
		fclose(fd_w);
		unlink(file_r);
		rename(file_w, file_r);
		konfig.changed = FALSE;
	}
	update_save_flags();
}

/*--------------------------------------------------------------
!	Sortiert die timerereignisse anhand des Ereignisnamens
+-------------------------------------------------------------*/

void sort_timer(TI_EVT *ti, int max_anz_ti, int art)

{
	switch(art) {
		case TISO_DATUM:
			qsort(ti, max_anz_ti, sizeof(TI_EVT), comp_timer_dat);
			break;
		case TISO_ZEIT:
			qsort(ti, max_anz_ti, sizeof(TI_EVT), comp_timer_zei);
			break;
		case TISO_WIEDERH:
			qsort(ti, max_anz_ti, sizeof(TI_EVT), comp_timer_wie);
			break;
		case TISO_AKTION:
			qsort(ti, max_anz_ti, sizeof(TI_EVT), comp_timer_akt);
			break;
		case TISO_GUELTIG:
			qsort(ti, max_anz_ti, sizeof(TI_EVT), comp_timer_gueltig);
			break;
	}
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine fr Datum!
+-------------------------------------------------------------*/

int comp_timer_dat(TI_EVT *klein, TI_EVT *gross)

{
	char k[16], g[16];
	
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);

	strncpy(k, &klein->zeit[4], 4);		/* Jahr	*/
	strncpy(&k[4], &klein->zeit[2], 2);	/* Monat	*/
	strncpy(&k[6], klein->zeit, 2);		/* Tag		*/
	strncpy(&k[8], &klein->zeit[8], 6);	/* Zeit		*/
	k[14] = '\0';

	strncpy(g, &gross->zeit[4], 4);		/* Jahr	*/
	strncpy(&g[4], &gross->zeit[2], 2);	/* Monat	*/
	strncpy(&g[6], gross->zeit, 2);		/* Tag		*/
	strncpy(&g[8], &gross->zeit[8], 6);	/* Zeit		*/
	g[14] = '\0';

	return(stricmp(k, g));
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine fr die Zeit
+-------------------------------------------------------------*/

int comp_timer_zei(TI_EVT *klein, TI_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	return(stricmp(&klein->zeit[8], &gross->zeit[8]));
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Wiederholung
+-------------------------------------------------------------*/

int comp_timer_wie(TI_EVT *klein, TI_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	return(stricmp(klein->wiederh, gross->wiederh));
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Aktionanme
+-------------------------------------------------------------*/

int comp_timer_akt(TI_EVT *klein, TI_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	return(stricmp(klein->ereignis, gross->ereignis));
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Gltig
+-------------------------------------------------------------*/

int comp_timer_gueltig(TI_EVT *klein, TI_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	return(stricmp(klein->gueltig, gross->gueltig));
}

/*--------------------------------------------------------------
!	Sortiert die timerereignisse anhand des Ereignisnamens
+-------------------------------------------------------------*/

void sort_ss(SS_EVT *ss, int max_anz_ss, int art)

{
	switch(art) {
		case SSSO_DEVICE:
			qsort(ss, max_anz_ss, sizeof(SS_EVT), comp_ss_dev);
			break;
		case SSSO_STRING:
			qsort(ss, max_anz_ss, sizeof(SS_EVT), comp_ss_str);
			break;
		case SSSO_AKTION:
			qsort(ss, max_anz_ss, sizeof(SS_EVT), comp_ss_akt);
			break;
	}
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Aktion
+-------------------------------------------------------------*/

int comp_ss_akt(SS_EVT *klein, SS_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	return(stricmp(klein->ereignis, gross->ereignis));
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine String
+-------------------------------------------------------------*/

int comp_ss_str(SS_EVT *klein, SS_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	return(stricmp(klein->string, gross->string));
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Aktion
+-------------------------------------------------------------*/

int comp_ss_dev(SS_EVT *klein, SS_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	if (klein->dev < gross->dev) return(-1);
	if (klein->dev > gross->dev) return(1);
	return(stricmp(klein->string, gross->string));
}

/*--------------------------------------------------------------
!	Sortiert die Programmereignisse anhand des Programmnamens
+-------------------------------------------------------------*/

void sort_prog(PR_EVT *pr, int max_anz_pr, int art)

{
	switch(art) {
		case PRSO_PROGRAMM:
			qsort(pr, max_anz_pr, sizeof(PR_EVT), comp_prog_pro);
			break;
		case PRSO_ST_AKTION:
			qsort(pr, max_anz_pr, sizeof(PR_EVT), comp_prog_sta);
			break;
		case PRSO_END_AKTION:
			qsort(pr, max_anz_pr, sizeof(PR_EVT), comp_prog_end);
			break;
	}
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Programm
+-------------------------------------------------------------*/

int comp_prog_pro(PR_EVT *klein, PR_EVT *gross)

{
	if (*(klein->name) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->name) == '\0') return(-1);
	return(stricmp(klein->name, gross->name));
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Startaktion
+-------------------------------------------------------------*/

int comp_prog_sta(PR_EVT *klein, PR_EVT *gross)

{
	if (*(klein->name) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->name) == '\0') return(-1);
	return(stricmp(klein->s_ereignis, gross->s_ereignis));
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Endaktion
+-------------------------------------------------------------*/

int comp_prog_end(PR_EVT *klein, PR_EVT *gross)

{
	if (*(klein->name) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->name) == '\0') return(-1);
	return(stricmp(klein->e_ereignis, gross->e_ereignis));
}

/*--------------------------------------------------------------
!	Sortiert die tastaturereignisse anhand des ASCII-Codes
+-------------------------------------------------------------*/

void sort_tast(TA_EVT *ta, int max_anz_ta, int art)

{
	switch(art) {
		case TASO_AKTION:
			qsort(ta, max_anz_ta, sizeof(TA_EVT), comp_tast_akt);
			break;
		case TASO_CODE:
			qsort(ta, max_anz_ta, sizeof(TA_EVT), comp_tast_cod);
			break;
	}
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine tastaturcode!
+-------------------------------------------------------------*/

int comp_tast_cod(TA_EVT *klein, TA_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	if (gross->ascii < klein->ascii) return(1);
	if (gross->ascii > klein->ascii) return(-1);
	if (gross->scan < klein->scan) return(1);
	if (gross->scan > klein->scan) return(-1);
	return(0);
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Aktionsname
+-------------------------------------------------------------*/

int comp_tast_akt(TA_EVT *klein, TA_EVT *gross)

{
	if (*(klein->ereignis) == '\0') return(1);		/* Leere Ereignisse nach hinten	*/
	if (*(gross->ereignis) == '\0') return(-1);
	return(stricmp(klein->ereignis, gross->ereignis));
}

/*--------------------------------------------------------------
!	Sortiert die Feiertage
+-------------------------------------------------------------*/

void sort_ft(FEIERTAG *ft, int max_anz_ft, int art)

{
	switch(art) {
		case FTSO_DATUM:
			qsort(ft, max_anz_ft, sizeof(FEIERTAG), comp_ft_datum);
			break;
		case FTSO_BEMERKUNG:
			qsort(ft, max_anz_ft, sizeof(FEIERTAG), comp_ft_bemerkung);
			break;
		case FTSO_ART:
			qsort(ft, max_anz_ft, sizeof(FEIERTAG), comp_ft_art);
			break;
	}
}

/*--------------------------------------------------------------
!	Liefert die Sortierroutine Bemerkung
+-------------------------------------------------------------*/

int comp_ft_bemerkung(FEIERTAG *klein, FEIERTAG *gross)

{
	char *k, *g;

	if (klein->tag < 0) return(1);		/* Leere Ereignisse nach hinten	*/
	if (gross->tag < 0) return(-1);

	if (klein->art > JAEHRLICH) k = ft_name[klein->art];
	else k = klein->bemerkung;
	if (gross->art > JAEHRLICH) g = ft_name[gross->art];
	else g = gross->bemerkung;
	return(stricmp(k, g));
}

/*---------------------------------------------------------------
!	Liefert die Sortierroutine fr ART bei Feiertag
+--------------------------------------------------------------*/

int comp_ft_art(FEIERTAG *klein, FEIERTAG *gross)

{
	if (klein->tag < 0) return(1);		/* Leere Ereignisse nach hinten	*/
	if (gross->tag < 0) return(-1);

	return(klein->art - gross->art);
}

/*---------------------------------------------------------------
!	Liefert die Sortierroutine fr ART bei Feiertag
+--------------------------------------------------------------*/

int comp_ft_datum(FEIERTAG *klein, FEIERTAG *gross)

{
	int k, g;
	if (klein->tag < 0) return(1);		/* Leere Ereignisse nach hinten	*/
	if (gross->tag < 0) return(-1);

	k = (klein->jahr * 400) + ((klein->monat+1) * 40) + klein->tag;
	g = (gross->jahr * 400) + ((gross->monat+1) * 40) + gross->tag;

	return(k - g);
}

/*--------------------------------------------------------------
!	Setzt den Timerdialog auf die korrekten werte!
!	top = oberster Eintrag
!	Lscht alle Selektionen und setzt die Buttons NEU als Standard und
!	Edit disabled!
+-------------------------------------------------------------*/

void setze_timer(TI_EVT *ti, int anz_ti, int top)

{
	int i, e;
	long l;
	
	if (anz_ti < 5) for(i = TI_NR; i < TI_NR + 25; *(timer.ob[i++].ob_spec.tedinfo->te_ptext) = '\0');

	if (timer.selected >= 0) {
		timer.ob[timer.selected + TI_1].ob_state &= ~SELECTED;
		timer.selected = -1;
	}
	for(i = TI_NR, e = top; i < TI_NR + 25 && anz_ti > e; e++) {
		itoa(e+1, timer.ob[i++].ob_spec.tedinfo->te_ptext, 10);
		strcpy(timer.ob[i++].ob_spec.tedinfo->te_ptext, ti[e].zeit);
		strcpy(timer.ob[i++].ob_spec.tedinfo->te_ptext, ti[e].wiederh);
		strcpy(timer.ob[i++].ob_spec.tedinfo->te_ptext, ti[e].gueltig);
		strcpy(timer.ob[i++].ob_spec.tedinfo->te_ptext, ti[e].ereignis);
	}
	if (timer.anz >= max_ti_evt) timer.ob[TI_NEU].ob_state |= DISABLED;
	l = ((long )anz_ti * 1000) / 5;
	if (l == 0) l = 1;
	timer.vslide = (int )(1000000L / l);

	timer.ob[timer.deff_button].ob_flags &= ~DEFAULT;
	timer.ob[TI_NEU].ob_flags |= DEFAULT;
	timer.deff_button = TI_NEU;

	timer.ob[TI_EDIT].ob_state |= DISABLED;

	if (timer.aktiv) {
		setze_ob(&timer, TI_EREIGNISSE, NULL);
		setze_ob(&timer, TI_DEF_GRUND, NULL);
	}
	aender_objc(&timer, TI_LOESCHEN, DISABLED);
}

/*--------------------------------------------------------------
!	Setzt den Programmdialog auf die korrekten werte!
!	top = oberster Eintrag
+-------------------------------------------------------------*/

void setze_prog(PR_EVT *pr, int anz_pr, int top)

{
	int i, e;
	long l;
	
	if (anz_pr < 5) for(i = P_NR; i < P_NR + 20; *(programm.ob[i++].ob_spec.tedinfo->te_ptext) = '\0');

	if (programm.selected >= 0) {
		programm.ob[programm.selected + PR_1].ob_state &= ~SELECTED;
		programm.selected = -1;
	}

	for(i = P_NR, e = top; i < P_NR + 20 && anz_pr > e; e++) {
		itoa(e+1, programm.ob[i++].ob_spec.tedinfo->te_ptext, 10);
		strcpy(programm.ob[i++].ob_spec.tedinfo->te_ptext, pr[e].name);
		strcpy(programm.ob[i++].ob_spec.tedinfo->te_ptext, pr[e].s_ereignis);
		strcpy(programm.ob[i++].ob_spec.tedinfo->te_ptext, pr[e].e_ereignis);
	}
	if (programm.anz >= max_pr_evt) programm.ob[PR_NEU].ob_state |= DISABLED;
	l = ((long )anz_pr * 1000) / 5;
	if (l == 0) l = 1;
	programm.vslide = (int )(1000000L / l);

	programm.ob[programm.deff_button].ob_flags &= ~DEFAULT;
	programm.ob[PR_NEU].ob_flags |= DEFAULT;
	programm.deff_button = PR_NEU;

	programm.ob[PR_EDIT].ob_state |= DISABLED;

	if (programm.aktiv) {
		setze_ob(&programm, P_EREIGNISSE, NULL);
		setze_ob(&programm, PR_DEF_GRUND, NULL);
	}

	aender_objc(&programm, PR_LOESCHEN, DISABLED);
}

/*--------------------------------------------------------------
!	Setzt den Programmdialog auf die korrekten werte!
!	top = oberster Eintrag
+-------------------------------------------------------------*/

void setze_tast(TA_EVT *ta, int anz_ta, int top)

{
	int i, e, a, s;
	long l;
	char *c;
	
	if (anz_ta < 5) for(i = TA_NR; i < TA_NR + 15; *(tastatur.ob[i++].ob_spec.tedinfo->te_ptext) = '\0');

	if (tastatur.selected >= 0) {
		tastatur.ob[tastatur.selected + TA_1].ob_state &= ~SELECTED;
		tastatur.selected = -1;
	}

	for(i = TA_NR, e = top; i < TA_NR + 15 && anz_ta > e; e++) {
		itoa(e+1, tastatur.ob[i++].ob_spec.tedinfo->te_ptext, 10);
		c = tastatur.ob[i++].ob_spec.tedinfo->te_ptext;
		a = ta[e].ascii;
		s = ta[e].scan;
		if (a < 0) a = 0;
		if (s < 0) s = 0;
		if (ta[e].ascii >= 32) sprintf(c, "\"%c\"%02X%02X", a, s, a);
		else if (ta[e].ascii > 0) sprintf(c, "^%c %02X%02X", a + 'A' - 1, s, a);
		else {
			sprintf(c, "   %02X%02X", s, a);
			switch(ta[e].scan) {
				case 0x3B:	strncpy(c, "F01", 3);
							break;
				case 0x3C:	strncpy(c, "F02", 3);
							break;
				case 0x3D:	strncpy(c, "F03", 3);
							break;
				case 0x3E:	strncpy(c, "F04", 3);
							break;
				case 0x3F:	strncpy(c, "F05", 3);
							break;
				case 0x40:	strncpy(c, "F06", 3);
							break;
				case 0x41:	strncpy(c, "F07", 3);
							break;
				case 0x42:	strncpy(c, "F08", 3);
							break;
				case 0x43:	strncpy(c, "F09", 3);
							break;
				case 0x44:	strncpy(c, "F10", 3);
							break;
				case 0x62:	strncpy(c, "HLP", 3);
							break;
				case 0x61:	strncpy(c, "UND", 3);
							break;
			}
		}
		if (ta[e].ascii == -1) c[5] = c[6] = '-';
		if (ta[e].scan == -1) c[3] = c[4] = '-';
		strcpy(tastatur.ob[i++].ob_spec.tedinfo->te_ptext, ta[e].ereignis);
	}
	if (tastatur.anz >= max_ta_evt) tastatur.ob[TA_NEU].ob_state |= DISABLED;
	l = ((long )anz_ta * 1000) / 5;
	if (l == 0) l = 1;
	tastatur.vslide = (int )(1000000L / l);

	tastatur.ob[tastatur.deff_button].ob_flags &= ~DEFAULT;
	tastatur.ob[TA_NEU].ob_flags |= DEFAULT;
	tastatur.deff_button = TA_NEU;

	tastatur.ob[TA_EDIT].ob_state |= DISABLED;
	if (tastatur.aktiv) {
		setze_ob(&tastatur, TA_EREIGNISSE, NULL);
		setze_ob(&tastatur, TA_DEF_GRUND, NULL);
	}

	aender_objc(&tastatur, TA_LOESCHEN, DISABLED);
}

/*--------------------------------------------------------------
!	Setzt den Mausdialog auf die korrekten werte!
!	top = oberster Eintrag
+-------------------------------------------------------------*/

void setze_maus(MA_EVT *ma, int top)

{
	int i, e;
	char nr[4]="00 ";
	
	if (maus.selected >= 0) {
		maus.ob[maus.selected + MA_1].ob_state &= ~SELECTED;
		maus.selected = -1;
	}
	
	for(i = M_NR, e = top; i < M_NR + 15; e++) {
		if (e < 9) nr[1] = e + '1';
		else {
			itoa (e+1, nr, 10);
			if (e < 16) nr[2] = ' ';
			else if (e < 32) nr[2] = 'S';
			else if (e < 48) nr[2] = 'C';
			else nr[2] = 'A';
		}
		strcpy(maus.ob[i++].ob_spec.tedinfo->te_ptext, nr);
		strcpy(maus.ob[i++].ob_spec.tedinfo->te_ptext, ma[e].name);
		strcpy(maus.ob[i++].ob_spec.tedinfo->te_ptext, ma[e].ereignis);
	}
	if (maus.aktiv) {
		setze_ob(&maus, M_EREIGNISSE, NULL);
	}
	aender_objc(&maus, TM_LOESCHEN, DISABLED);
	aender_objc(&maus, TM_EDIT, DISABLED);
}

/*--------------------------------------------------------------
!	Setzt den Schnittstellendialog auf die korrekten werte!
!	top = oberster Eintrag
+-------------------------------------------------------------*/

void setze_ss(SS_EVT *ss, int anz_ss, int top)

{
	int i, e;
	long l;
	
	if (anz_ss < 5) for(i = SS_NR; i < SS_NR + 20; *(device.ob[i++].ob_spec.tedinfo->te_ptext) = '\0');

	if (device.selected >= 0) {
		device.ob[device.selected + SS_1].ob_state &= ~SELECTED;
		device.selected = -1;
	}
	for(i = SS_NR, e = top; i < SS_NR + 20 && anz_ss > e; e++) {
		itoa(e+1, device.ob[i++].ob_spec.tedinfo->te_ptext, 10);
		set_dev(ss[e].dev, device.ob[i++].ob_spec.tedinfo->te_ptext);
		strcpy(device.ob[i++].ob_spec.tedinfo->te_ptext, ss[e].string);
		strcpy(device.ob[i++].ob_spec.tedinfo->te_ptext, ss[e].ereignis);
	}
	if (device.anz >= max_ss_evt) device.ob[SS_NEU].ob_state |= DISABLED;
	l = ((long )anz_ss * 1000) / 5;
	if (l == 0) l = 1;
	device.vslide = (int )(1000000L / l);

	device.ob[device.deff_button].ob_flags &= ~DEFAULT;
	device.ob[SS_NEU].ob_flags |= DEFAULT;
	device.deff_button = SS_NEU;

	device.ob[SS_EDIT].ob_state |= DISABLED;
	
	if (device.aktiv) {
		setze_ob(&device, SS_EREIGNISSE, NULL);
		setze_ob(&device, SS_DEF_GRUND, NULL);
	}

	aender_objc(&device, SS_LOESCHEN, DISABLED);
}

/*--------------------------------------------------------------
!	Setzt den Feiertagsdialog auf die korrekten werte!
!	top = oberster Eintrag
!	Lscht alle Selektionen und setzt die Buttons NEU als Standard und
!	Edit disabled!
+-------------------------------------------------------------*/

void zeige_feiertag(FEIERTAG *ft, int anz_fe, int top)

{
	int i, e, j;
	long l;
	
	if (feiertag.selected >= 0) {
		feiertag.ob[feiertag.selected + FE_1].ob_state &= ~SELECTED;
		feiertag.selected = -1;
	}

	ft += top;
	
	for(i = FT_NR, e = top, j = FE_1; i < FT_NR + 20 && ft->tag >= 0; e++, ft++, j++) {
		feiertag.ob[j].ob_flags |= SELECTABLE;
		itoa(e+1, feiertag.ob[i++].ob_spec.tedinfo->te_ptext, 10);
		sprintf(feiertag.ob[i++].ob_spec.tedinfo->te_ptext, "%02i%02i%04i", ft->tag, ft->monat + 1, ft->jahr);
		if (ft->art <= JAEHRLICH) {
			strcpy(feiertag.ob[i++].ob_spec.tedinfo->te_ptext, ft->bemerkung);
			strncpy(feiertag.ob[i++].ob_spec.tedinfo->te_ptext, ft_name[ft->art], 9);
		} else {
			strcpy(feiertag.ob[i++].ob_spec.tedinfo->te_ptext, ft_name[ft->art]);
			strcpy(feiertag.ob[i++].ob_spec.tedinfo->te_ptext, "definiert");
		}
	}
	for (; j < FE_1 + 5; j++) {
		feiertag.ob[j].ob_flags &= ~SELECTABLE;
		*feiertag.ob[i++].ob_spec.tedinfo->te_ptext = '\0';
		*feiertag.ob[i++].ob_spec.tedinfo->te_ptext = '\0';
		*feiertag.ob[i++].ob_spec.tedinfo->te_ptext = '\0';
		*feiertag.ob[i++].ob_spec.tedinfo->te_ptext = '\0';
	}

	l = ((long )anz_fe * 1000) / 5;
	if (l == 0) l = 1;
	feiertag.vslide = (int )(1000000L / l);

	feiertag.ob[feiertag.deff_button].ob_flags &= ~DEFAULT;
	feiertag.ob[FE_NEU].ob_flags |= DEFAULT;
	feiertag.deff_button = FE_NEU;

	feiertag.ob[FE_EDIT].ob_state |= DISABLED;
	
	if (feiertag.aktiv) {
		setze_ob(&feiertag, FE_EREIGNISSE, NULL);
		setze_ob(&feiertag, FE_DEF_GRUND, NULL);
	}

	aender_objc(&feiertag, FE_LOESCHEN, DISABLED);
}

/*-----------------------------------------------------------------
!	Holt die Fensterstruktur des bergebenen window_handles!
!	Wird ein Wert < 0 bergeben, wird das oberste Fenster geholt
+----------------------------------------------------------------*/

FENSTER *hole_fenster(int wind_handle)

{
	int wh;
	FENSTER **f;
	
	if (wind_handle < 0) wind_get(0, WF_TOP, &wh);
	else wh = wind_handle;

	f = fenster;
	while (*f != NULL) {
		if (wh == (*f)->wind_handle) return(*f);
		else f++;
	}
	return(NULL);
}

/*----------------------------------------------------------------
!	Setzt die eingegebenen Werte als NEU
+---------------------------------------------------------------*/

void neuer_timer(OBJECT *ob, int neu)

{
	TI_EVT *ti;
	char *c;

	if ((strlen(ob[TI_DATUM].ob_spec.tedinfo->te_ptext) < 8) ||
		(strlen(ob[TI_ZEIT].ob_spec.tedinfo->te_ptext) < 6) ||
		(*(ob[TI_EREIGNIS].ob_spec.tedinfo->te_ptext) == '\0')) {
			Bell();
			return;
	}


	if (!neu) {		/* Dann nur editieren!	*/
		ti = &ti_evt[timer.top_line + timer.selected];
	} else {
		if (timer.anz >= max_ti_evt) return;
		if (timer.anz < 5) timer.ob[TI_1 + timer.anz].ob_flags |= SELECTABLE;
		ti = &ti_evt[timer.anz++];

		setze_vslsize(&timer);
	}

	strcpy(ti->zeit, ob[TI_DATUM].ob_spec.tedinfo->te_ptext);
	strcat(ti->zeit, ob[TI_ZEIT].ob_spec.tedinfo->te_ptext);
	strcpy(ti->gueltig, ob[TI_GUELTIG].ob_spec.tedinfo->te_ptext);
	strcpy(ti->ereignis, &ob[TI_EREIGNIS].ob_spec.tedinfo->te_ptext[2]);
	welche_wiederholung(ti->wiederh);

	for(c = ti->ereignis; *c != '\0'; c++) if (*c == ' ') *c = '_';

	sort_timer(ti_evt, max_ti_evt, ti_sort);

	setze_ob(&timer, TI_DATUM, "");
	setze_ob(&timer, TI_ZEIT, "");
	setze_ob(&timer, TI_EREIGNIS, "");
	setze_ob(&timer, TI_WIEDERH, "");
	setze_ob(&timer, TI_GUELTIG, "1");
	timer.edit_ob = TI_DATUM;

	ob[TI_EDIT].ob_state |= DISABLED;		/* wird generell gezeichnet	*/
	aender_objc(&timer, TI_NACHHOLEN, NORMAL);

	setze_timer(ti_evt, timer.anz, timer.top_line);

	timer.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Setzt die eingegebenen Werte als NEU
+---------------------------------------------------------------*/

void neues_programm(OBJECT *ob, int neu)

{
	PR_EVT *pr;
	char *c;

	if ((*(ob[TP_PROGRAMM].ob_spec.tedinfo->te_ptext) == '\0') ||
		((*(ob[TP_SEREIGNIS].ob_spec.tedinfo->te_ptext) == '\0') &&
		 (*(ob[TP_EEREIGNIS].ob_spec.tedinfo->te_ptext) == '\0'))) {
		Bell();
		return;
	}

	if (!neu) {		/* Dann nur editieren!	*/
		pr = &pr_evt[programm.top_line + programm.selected];
	} else {
		if (programm.anz >= max_pr_evt) return;
		if (programm.anz < 5) programm.ob[PR_1 + programm.anz].ob_flags |= SELECTABLE;
		pr = &pr_evt[programm.anz++];

		setze_vslsize(&programm);
	}
	
	strcpy(pr->name, ob[TP_PROGRAMM].ob_spec.tedinfo->te_ptext);
	strcpy(pr->s_ereignis, &ob[TP_SEREIGNIS].ob_spec.tedinfo->te_ptext[2]);
	strcpy(pr->e_ereignis, &ob[TP_EEREIGNIS].ob_spec.tedinfo->te_ptext[2]);

	if (*(pr->s_ereignis) == '\0') strcpy(pr->s_ereignis, "-");
	if (*(pr->e_ereignis) == '\0') strcpy(pr->e_ereignis, "-");
	for(c = pr->s_ereignis; *c != '\0'; c++) if (*c == ' ') *c = '_';
	for(c = pr->e_ereignis; *c != '\0'; c++) if (*c == ' ') *c = '_';

	sort_prog(pr_evt, max_pr_evt, pr_sort);

	setze_ob(&programm, TP_PROGRAMM, "");
	setze_ob(&programm, TP_SEREIGNIS, "");
	setze_ob(&programm, TP_EEREIGNIS, "");
	programm.edit_ob = TP_PROGRAMM;

	ob[PR_EDIT].ob_state |= DISABLED;
	aender_objc(&programm, PR_LOESCHEN, DISABLED);
	
	setze_prog(pr_evt, programm.anz, programm.top_line);

	programm.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Setzt die eingegebenen Werte als NEU
+---------------------------------------------------------------*/

void neue_tast(OBJECT *ob, int neu)

{
	TA_EVT *ta;
	char *c, dummy[10];

	if ((strlen(ob[TA_SCAN].ob_spec.tedinfo->te_ptext) < 4) ||
		(*(ob[TA_EREIGNIS].ob_spec.tedinfo->te_ptext) == '\0')) {
			Bell();
			return;
	}

	if (!neu) {		/* Dann nur editieren!	*/
		ta = &ta_evt[tastatur.selected + tastatur.top_line];
	} else {
		if (tastatur.anz >= max_ta_evt) return;
		if (tastatur.anz < 5) tastatur.ob[TA_1 + tastatur.anz].ob_flags |= SELECTABLE;
		ta = &ta_evt[tastatur.anz++];

		setze_vslsize(&tastatur);
	}

	c = ob[TA_SCAN].ob_spec.tedinfo->te_ptext;
	dummy[2] = '\0';

	if (!(ob[TAS_SCAN].ob_state & SELECTED)) ta->scan = -1;
	else {
		strncpy(dummy, c, 2);
		ta->scan = xtoi(dummy);
	}
	if (!(ob[TAS_ASC].ob_state & SELECTED)) ta->ascii = -1;
	else {
		strncpy(dummy, &c[2], 2);
		ta->ascii = xtoi(dummy);
	}
	
	strcpy(ta->ereignis, &ob[TA_EREIGNIS].ob_spec.tedinfo->te_ptext[2]);

	for(c = ta->ereignis; *c != '\0'; c++) if (*c == ' ') *c = '_';

	sort_tast(ta_evt, max_ta_evt, ta_sort);

	setze_ob(&tastatur, TA_SCAN, "");
	setze_ob(&tastatur, TA_EREIGNIS, "");
	tastatur.edit_ob = TA_SCAN;

	aender_objc(&tastatur, TAS_SCAN, SELECTED);
	aender_objc(&tastatur, TAS_ASC, SELECTED);

	setze_tast(ta_evt, tastatur.anz, tastatur.top_line);

	tastatur.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Setzt die eingegebenen Werte als NEU
+---------------------------------------------------------------*/

void neue_ss(OBJECT *ob, int neu)

{
	SS_EVT *ss;
	char *c;

	if ((*(ob[SS_STRING].ob_spec.tedinfo->te_ptext) == '\0') ||
		(*(ob[SS_EREIGNIS].ob_spec.tedinfo->te_ptext) == '\0')) {
			Bell();
			return;
	}

	if (!neu) {		/* Dann nur editieren!	*/
		ss = &ss_evt[device.selected + device.top_line];
	} else {
		if (device.anz >= max_ss_evt) return;
		if (device.anz < 5) device.ob[SS_1 + device.anz].ob_flags |= SELECTABLE;
		ss = &ss_evt[device.anz++];

		setze_vslsize(&device);
	}

	ss->dev = get_dev_nr(&ob[SS_DEVICE].ob_spec.tedinfo->te_ptext[2]);
	strcpy(ss->string, ob[SS_STRING].ob_spec.tedinfo->te_ptext);
	strcpy(ss->ereignis, &ob[SS_EREIGNIS].ob_spec.tedinfo->te_ptext[2]);

	for(c = ss->ereignis; *c != '\0'; c++) if (*c == ' ') *c = '_';

	sort_ss(ss_evt, max_ss_evt, ss_sort);

	setze_ob(&device, SS_STRING, "");
	setze_ob(&device, SS_EREIGNIS, "");
	device.edit_ob = SS_STRING;

	setze_ss(ss_evt, device.anz, device.top_line);

	device.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Setzt die eingegebenen Werte als NEU
+---------------------------------------------------------------*/

void neuer_feiertag(OBJECT *ob, int neu)

{
	FEIERTAG *f;
	char dummy[10];
	int i;

	if ((strlen(ob[FE_DATUM].ob_spec.tedinfo->te_ptext) < 8) ||
		(*(ob[FE_BEMERKUNG].ob_spec.tedinfo->te_ptext) == '\0')) {
			Bell();
			return;
	}


	if (!neu) {		/* Dann nur editieren!	*/
		f = &fe_tag[feiertag.top_line + feiertag.selected];
	} else {
		if (feiertag.anz >= max_fe_tag) return;
		if (feiertag.anz < 5) feiertag.ob[FE_1 + feiertag.anz].ob_flags |= SELECTABLE;

		for (f = fe_tag, i = 0; (i < max_fe_tag) && (f->tag > 0); f++, i++);

		feiertag.anz++;
		setze_vslsize(&feiertag);
	}

	strcpy(dummy, ob[FE_DATUM].ob_spec.tedinfo->te_ptext);
	f->jahr = atoi(&dummy[4]);
	dummy[4] = '\0';
	f->monat = atoi(&dummy[2]) - 1;
	dummy[2] = '\0';
	f->tag = atoi(dummy);
	strcpy(f->bemerkung, ob[FE_BEMERKUNG].ob_spec.tedinfo->te_ptext);
	
	f->art = (ob[FE_FEST].ob_state & SELECTED) ? JAEHRLICH : BEWEGLICH;
	
	sort_ft(fe_tag, max_fe_tag, ft_sort);

	setze_ob(&feiertag, FE_DATUM, "");
	setze_ob(&feiertag, FE_BEMERKUNG, "");
	feiertag.edit_ob = FE_DATUM;

	ob[FE_EDIT].ob_state |= DISABLED;		/* wird generell gezeichnet	*/
	aender_objc(&feiertag, FE_FEST, NORMAL);

	zeige_feiertag(fe_tag, feiertag.anz, feiertag.top_line);

	feiertag.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Lscht den selektierten Timer
+---------------------------------------------------------------*/

void loeschen_timer(void)

{
	TI_EVT *ti;

	ti = &ti_evt[timer.selected + timer.top_line];
	*ti->zeit = *ti->ereignis = *ti->wiederh = *ti->gueltig = '\0';
	
	if (--timer.anz < 5) timer.ob[TI_1 + timer.anz].ob_flags &= ~SELECTABLE;
	else if (timer.top_line + 5 > timer.anz) timer.top_line--;
	
	sort_timer(ti_evt, max_ti_evt, ti_sort);
	setze_vslsize(&timer);
	setze_timer(ti_evt, timer.anz, timer.top_line);

	timer.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Lscht das selektierte Programm
+---------------------------------------------------------------*/

void loeschen_programm(void)

{
	PR_EVT *pr;

	pr = &pr_evt[programm.selected + programm.top_line];
	*pr->name = *pr->s_ereignis = *pr->e_ereignis = '\0';
	
	if (--programm.anz < 5) programm.ob[PR_1 + programm.anz].ob_flags &= ~SELECTABLE;
	else if (programm.top_line + 5 > programm.anz) programm.top_line--;

	sort_prog(pr_evt, max_pr_evt, pr_sort);
	setze_vslsize(&programm);
	setze_prog(pr_evt, programm.anz, programm.top_line);

	programm.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Lscht das selektierte Tastaturereignis
+---------------------------------------------------------------*/

void loeschen_tast(void)

{
	TA_EVT *ta;

	ta = &ta_evt[tastatur.selected + tastatur.top_line];

	ta->ascii = ta->scan = 0;
	*ta->ereignis = '\0';
	
	if (--tastatur.anz < 5) tastatur.ob[TA_1 + tastatur.anz].ob_flags &= ~SELECTABLE;
	else if (tastatur.top_line + 5 > tastatur.anz) tastatur.top_line--;

	sort_tast(ta_evt, max_ta_evt, ta_sort);
	setze_vslsize(&tastatur);
	setze_tast(ta_evt, tastatur.anz, tastatur.top_line);

	tastatur.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Lscht das selektierte Deviceereignis
+---------------------------------------------------------------*/

void loeschen_ss(void)

{
	SS_EVT *ss;

	ss = &ss_evt[device.selected + device.top_line];

	ss->dev = 0;
	*ss->ereignis = *ss->string = '\0';
	
	if (--device.anz < 5) device.ob[SS_1 + device.anz].ob_flags &= ~SELECTABLE;
	else if (device.top_line + 5 > device.anz) device.top_line--;

	sort_ss(ss_evt, max_ss_evt, ss_sort);
	setze_vslsize(&device);
	setze_ss(ss_evt, device.anz, device.top_line);

	device.changed = TRUE;
	update_save_flags();
}

/*----------------------------------------------------------------
!	Lscht den selektierten Feiertag
+---------------------------------------------------------------*/

void loeschen_feiertag(void)

{
	FEIERTAG *ft;

	ft = &fe_tag[feiertag.selected + feiertag.top_line];
	ft->tag = -1;
	
	if (--feiertag.anz < 5) feiertag.ob[FE_1 + feiertag.anz].ob_flags &= ~SELECTABLE;
	else if (feiertag.top_line + 5 > feiertag.anz) feiertag.top_line--;

	sort_ft(fe_tag, max_fe_tag, ft_sort);

	setze_vslsize(&feiertag);
	zeige_feiertag(fe_tag, feiertag.anz, feiertag.top_line);

	feiertag.changed = TRUE;
	update_save_flags();
}

/*-----------------------------------------------------------------------
!	Setzt von <object> die objekte <start> bis <end> auf <wert>
+----------------------------------------------------------------------*/

void setze_kinder(OBJECT *object, int start, int end, int wert)

{
	register int i;
	wert |= 0xff00;	/* Nur die unteren 8 Bit beeinflussen!	*/
	for (i = start; i <= end; object[i++].ob_state &= wert);
}

/*-----------------------------------------------------------------------
!	berprft, ob der cookie "text" vorhanden ist.
+----------------------------------------------------------------------*/

int test_cookie(char *text)

{
	void *ssp;
	int found = FALSE;
	char *ct;
	char cook[5]= "    ";
	
	ssp = (void *)Super(0);
	ct = (char *)(*(long *)0x5A0);		/* cookie Speicherplatzzeiger	*/
	do {
		memcpy(cook, ct, 4);
		ct += 8;
		if (strcmp(cook, text) == 0) {
			found = TRUE;
			break;
		}
	} while (memcmp(cook, "\0\0\0\0", 4) != 0);
	
	Super(ssp);
	return(found);
}

/*---------------------------------------------------------------
!	Routine, die eine Hexadezimale ASCII-Zahl in eine INT umwandelt
+---------------------------------------------------------------*/

int xtoi(char *string)

{
	char *c;
	int i = 1, erg = 0;
	
	strupr(string);
	for (c = &string[strlen(string) - 1]; c >= string; c--, i <<= 4) {
		if ((*c >= '0') && (*c <= '9')) erg += ((*c - '0') * i);
		else if ((*c >= 'A') && (*c <= 'F')) erg += ((*c - 'A' + 10) * i);
	}
	return(erg);
}

/*----------------------------------------------------------------
!	Message an den TImemnager!
+---------------------------------------------------------------*/

void send_update(void)

{
	int ai, appl_buffer[16];
	ai = appl_find("EVENTMAN");
	if (ai < 0) return;

	appl_buffer[0] = U_TO_U;
	appl_buffer[1] = ap_id;
	appl_buffer[2] = 0;
	appl_buffer[3] = LOAD_EVT;
	appl_write(ai, 16, appl_buffer);	/* Es mssen immer 16 Byte gesendet werden, sonst gibts Bomben	*/
}

/*----------------------------------------------------------------
!	ndert den Status eines Objects in einem Fenster
+---------------------------------------------------------------*/

void aender_objc(FENSTER *akt, int kind, int neustatus)

{
	int z;
	z = akt->aktiv ? TRUE : FALSE;
	objc_change(akt->ob, kind, 0, akt->fx, akt->fy, akt->fw, akt->fh, neustatus, z);
}

/*----------------------------------------------------------------
!	Update der Speicherflags im Men
+---------------------------------------------------------------*/

void update_save_flags(void)

{
	FENSTER *f;

	f = hole_fenster(-1);
	if (f == NULL) return;
	
	if (f->changed) {
		menu_ienable(menu, MENU_SAVE, TRUE);
		aender_objc(f, f->save_button, NORMAL);
	} else {
		menu_ienable(menu, MENU_SAVE, FALSE);
		if (f->save_button > 0) aender_objc(f, f->save_button, DISABLED);
	}
	
	if (timer.changed || programm.changed || maus.changed || tastatur.changed || 
		device.changed || feiertag.changed || konfig.changed) 
			menu_ienable(menu, MENU_SAVEALL, TRUE);
	else menu_ienable(menu, MENU_SAVEALL, FALSE);
	
}

/*--------------------------------------------------------------------
!	Speichert eine EVENTMAN.INF Datei, in der folgende Dinge gesichert
!	werden:
!	1. Position aller Fenster
!	2. Pfad des Aktionseditors
+------------------------------------------------------------------------*/

void sichern_inf(void)

{
	char inf_file[128];
	FILE *fd;
	
	if (!ordner(pfad)) return;

	strcpy(inf_file, pfad);
	strcat(inf_file, "\\BEM_EDIT.INF");
	
	fd = fopen(inf_file, "w");
	if (fd != NULL) {
		fprintf(fd, "HauptWindow: %s %d %d\n", haupt.aktiv ? "Opend" : "Closed", haupt.fx, haupt.fy);
		fprintf(fd, "TimerWindow: %s %d %d\n", timer.aktiv ? "Opend" : "Closed", timer.fx, timer.fy);
		fprintf(fd, "ProgrWindow: %s %d %d\n", programm.aktiv ? "Opend" : "Closed", programm.fx, programm.fy);
		fprintf(fd, "KeybdWindow: %s %d %d\n", tastatur.aktiv ? "Opend" : "Closed", tastatur.fx, tastatur.fy);
		fprintf(fd, "Maus_Window: %s %d %d\n", maus.aktiv ? "Opend" : "Closed", maus.fx, maus.fy);
		fprintf(fd, "DevicWindow: %s %d %d\n", device.aktiv ? "Opend" : "Closed", device.fx, device.fy);
		fprintf(fd, "FeierWindow: %s %d %d\n", feiertag.aktiv ? "Opend" : "Closed", feiertag.fx, feiertag.fy);
		fprintf(fd, "SysteWindow: %s %d %d\n", konfig.aktiv ? "Opend" : "Closed", konfig.fx, konfig.fy);
		fprintf(fd, "AktionsEdit: %s\n", konf_editor);
		fprintf(fd, "Use-RSCFile: %s\n", konf_edit_rsc);
		fclose(fd);
	}
}

/*------------------------------------------------------------------------
!	Ldt die Infodatei und stellt die Fenster ein!
+-----------------------------------------------------------------------*/

void lese_inf(void)

{
	char buffer[128], inf_file[128];
	char *c;
	FILE *fd;
	FENSTER *f;	
	int anz = 0, fx,fy,fb,fh;
	
	wind_get(0, WF_WORKXYWH, &fx, &fy, &fb, &fh);
	strcpy(inf_file, pfad);
	strcat(inf_file, "\\BEM_EDIT.INF");
	
	haupt.inf_open = TRUE;	/* bei keiner INF immer Hauptdialog ffnen	*/
	fd = fopen(inf_file, "r");
	if (fd != NULL) {
		while (fgets(buffer, 127, fd) != NULL) {
			if ((c = strtok(buffer, " \t\n")) == NULL) continue;
			if (stricmp(c, "HauptWindow:") == 0) f = &haupt;
			else if (stricmp(c, "TimerWindow:") == 0) f = &timer;
			else if (stricmp(c, "ProgrWindow:") == 0) f = &programm;
			else if (stricmp(c, "KeybdWindow:") == 0) f = &tastatur;
			else if (stricmp(c, "Maus_Window:") == 0) f = &maus;
			else if (stricmp(c, "DevicWindow:") == 0) f = &device;
			else if (stricmp(c, "FeierWindow:") == 0) f = &feiertag;
			else if (stricmp(c, "SysteWindow:") == 0) f = &konfig;
			else if (stricmp(c, "Use-RSCFile:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) {
					*konf_edit_rsc = '\0';
					strncat(konf_edit_rsc, c, 128);
				}
				continue;
			} else if (stricmp(c, "AktionsEdit:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) {
					*konf_editor = '\0';
					strncat(konf_editor, c, 128);
				}
				continue;
			} else continue;

			fenster[anz++] = f;
			if ((c = strtok(NULL, " \t\n")) == NULL) continue;
			f->inf_open = (*c == 'O') ? TRUE : FALSE;

			if ((c = strtok(NULL, " \t\n")) == NULL) continue;
			f->fx = atoi(c);
			if ((c = strtok(NULL, " \t\n")) == NULL) continue;
			f->fy = atoi(c);

			if (f->fx + f->fw > fx + fb) f->fx = fx + fb - f->fw;
			if (f->fy + f->fh > fy + fh) f->fy = fy + fh - f->fh;
			if (f->fx < fx) f->fx = fx;
			if (f->fy < fy) f->fy = fy;

			f->ob->ob_x = f->fx + f->dx;
			f->ob->ob_y = f->fy + f->dy;
		}
		fclose(fd);
	}
	setze_ob(&konfig, KONF_TEXTEDIT, konf_editor);

	if (anz == 0) {	/* Keine INF gefunden!	*/
		fenster[anz++] = &haupt;
	}
	fenster[anz] = NULL;

	/* Lesen der EVENTMAN.INF!	*/
	
	strcpy(inf_file, pfad);
	strcat(inf_file, "\\EVENTMAN.INF");
	fd = fopen(inf_file, "r");
	if (fd != NULL) {
		while (fgets(buffer, 127, fd) != NULL) {
			if ((c = strtok(buffer, " \n")) == NULL) continue;
			if (stricmp(c, "AccFilePath:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) strcpy(konf_syspfad, c);
			} else if (stricmp(c, "BEMEditPath:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) strcpy(konf_bemedit, c);
			} else if (stricmp(c, "SekProgFind:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) konf_sek_prg = atoi(c);
				strcpy(konfig.ob[KONF_SEKPROG].ob_spec.tedinfo->te_ptext, c);
			} else if (stricmp(c, "SekEvtDatei:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) konf_sek_dat = atoi(c);
				strcpy(konfig.ob[KONF_SEKEVT].ob_spec.tedinfo->te_ptext, c);
			} else if (stricmp(c, "INFO-Anzahl:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) konf_info = atoi(c);
				strcpy(konfig.ob[KONF_INFO].ob_spec.tedinfo->te_ptext, c);
			} else if (stricmp(c, "Use-RSCFile:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) {
					*konf_event_rsc = '\0';
					strncat(konf_event_rsc, c, 128);
				}
			}
		}
		fclose(fd);
	}
	setze_ob(&konfig, KONF_BEMEDIT, konf_bemedit);
	setze_ob(&konfig, KONF_EVT_PFAD, konf_syspfad);
	setze_ob(&konfig, KONF_EDIT_RSC, konf_edit_rsc);
	setze_ob(&konfig, KONF_EVENT_RSC, konf_event_rsc);
}

/*--------------------------------------------------------------------------
!	Hilfstextaufruf
+--------------------------------------------------------------------------*/

void go_help(void)

{
	int st_id, buffer[8];
	FENSTER *akt;
	
	if ((st_id = appl_find("ST-GUIDE")) < 0) return;

	strcpy(st_help, "*:\\BEM.HYP");
	akt = hole_fenster(-1);
	if (akt == &timer) strcat(st_help, " TIMER");
	else if (akt == &programm) strcat(st_help, " PROGRAMM");
	else if (akt == &tastatur) strcat(st_help, " TASTATUR");
	else if (akt == &maus) strcat(st_help, " MAUS");
	else if (akt == &device) strcat(st_help, " DEVICE");
	else if (akt == &feiertag) strcat(st_help, " Definition von Feiertagen");
	else if (akt == &haupt) strcat(st_help, " Definition von Ereignissen");
	else if (akt == &konfig) strcat(st_help, " Systemkonfiguration");
	
	buffer[0] = VA_START;
	buffer[1] = ap_id;
	buffer[2] = 0;

	buffer[3] = (int )((long )st_help >> 16);
	buffer[4] = (int ) st_help;

	buffer[5] = buffer[6] = buffer[7] = 0;
	if (akt != NULL) {
		if (akt->edit_init) {
			objc_edit(akt->ob, akt->edit_ob, 0, &akt->edit_idx, ED_END);
			akt->edit_init = FALSE;
		}
	}
	appl_write(st_id, 16, buffer);
}

/*---------------------------------------------------------------------------
!	Testet, ob der Ordner vorhanden ist und legt den kompletten Pfad an,
!	wenn das nicht der Fall ist!
+--------------------------------------------------------------------------*/

int ordner(char *ord_pfad)

{
	struct ffblk ffb;
	char *c;
	int err;
	char text[180];
	
	if (findfirst(ord_pfad, &ffb, FA_DIREC) == 0) return(TRUE);	/* Pfad schon vorhanden	*/

	sprintf(text, msg[MSG_NOERGORD].ob_spec.free_string, ord_pfad);
	if (form_alert(1, text) == 2) return(FALSE);

	if ((ord_pfad[1] == ':') && (ord_pfad[2] == '\\')) c = &ord_pfad[3];		/* Angabe mit Laufwerk	*/
	else if (*ord_pfad == '\\') c = &ord_pfad[1];		/* Angabe ohne Laufwerk, aber mit '\\'	*/
	else c = ord_pfad;

	while ((c = strchr(c, '\\')) != NULL) {				/* Ansonsten ein Ordner nach dem anderen anlegen	*/
		*c = '\0';
		if (findfirst(ord_pfad, &ffb, FA_DIREC) != 0) 
			if ((err = Dcreate(ord_pfad)) < 0) 
				break;
		*(c++) = '\\';
	}

	if (ord_pfad[strlen(ord_pfad) - 1] != '\\') err = Dcreate(ord_pfad);					/* Pfadangabe ohne abschlieenden '\\'	*/

	if (err < 0) sprintf(text, msg[MSG_CRERR].ob_spec.free_string, err, ord_pfad);
	else sprintf(text, msg[MSG_CR_OK].ob_spec.free_string, ord_pfad);
	form_alert(1, text);

	if (err < 0) return(FALSE);
	else return(TRUE);
}
