/*----------------------------------------------------------------
!	FEIERTAG.C				Version 1.01				25.10.95
!	Berechnet Feiertage und stellt diese in einer Struktur
!	FEIERTAG zur Verfgung.
+----------------------------------------------------------------*/
/* nderung in 1.1: Bu und Bettag ab 1995 kein bundeseinheitlicher
   					Feiertag mehr! Lediglich in Sachsen noch	*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>

#include "feiertag.h"

char *b_land[] = {	"keine", "bundeseinheitlich", "Baden-Wrttemberg",
					"Bayern (Augsburg)", "Bayern (evangelisch)", "Bayern (katholisch)",
					"Berlin", "Brandenburg", "Bremen", "Hamburg", "Hessen",
					"Mecklenburg-Vorpommern", "Niedersachsen",
					"Nordrhein-Westfalen", "Rheinland-Pfalz", "Saarland",
					"Sachsen (evangelisch)", "Sachsen (katholisch)",
					"Sachsen-Anhalt", "Schleswig-Holstein",
					"Thringen (evangelisch)", "Thringen (katholisch)" };

char *ft_name[] = {	"beweglich", "jhrlich", "Neujahr", "Heilige 3 Knige",
					"Karfreitag", "Ostermontag", "1. Mai", "Christi Himmelfahrt",
					"Pfingstmontag", "Fronleichnam", "Friedensfest",
					"Maria Himmelfahrt", "Tag der deutschen Einheit", "Reformationstag",
					"Allerheiligen", "Bu und Bettag", "1. Weihnachtsfeiertag",
					"2. Weihnachtsfeiertag" };

/*----------------------------------------------------------------
!	Berechnet Ostern anhand des aktuellen Jahres
!	Keine Ahnung, wie das funktioniert, wurde nur abgetippert!
+----------------------------------------------------------------*/

time_t ostern(int jahr)

{
	int a,b,c, p, q, r, x, y, d, e;
	struct tm tim;
	
	tim.tm_min = tim.tm_sec = tim.tm_hour = 0;
	if (jahr < 100) jahr += 1900;
	tim.tm_year = jahr - 1900;
	
	a = jahr % 19;
	b = jahr % 4;
	c = jahr % 7;

	p = jahr / 100;
	q = p / 3;
	r = p / 4;
	x = (15+p-q-r) % 30;
	y = (p+4-r) % 7;
	d = ((19 * a) + x) % 30;
	e = ((2 * b) + (4 * c) + (6 * d) + y) % 7;
	if (22+d+e <= 31) {
		tim.tm_mday = 22+d+e;
		tim.tm_mon = 2;		/* Monate beginnen mit 0	*/
	} else if ((d == 28) && (e == 6)) {
		tim.tm_mday = 18;
		tim.tm_mon = 3;
	} else if ((d == 29) && (e == 6)) {
		tim.tm_mday = 19;
		tim.tm_mon = 3;
	} else {
		tim.tm_mday = d+e-9;
		tim.tm_mon = 3;
	}
	return(mktime(&tim));
}

/*----------------------------------------------------------------------
!	Ldt die Feiertagsdatei und setzt die deutschen Feiertag
!	abhngig der Variablen "Feiertag:" in der INF-Datei
!	Ist Feiertag nicht vorhanden, wird bundeseinheitlich angenommen
!	Die Feiertage werden fr das Jahr 'jahr' berechnet
+---------------------------------------------------------------------*/

FEIERTAG *lade_feiertag(char *file_path, int *bundesland, int *anzahl, int jahr)

{
	int anz, i;
	FEIERTAG *ft, *f_idx;
	char file[128], buffer[81], *c, *e;
	FILE *fd;
	time_t zeit;
	struct tm *ti;
	
	if (jahr <= 0) {
		zeit = time(NULL);
		ti = localtime(&zeit);
		jahr = ti->tm_year + 1900;
	}
	
	if (*anzahl > 0) anz = *anzahl;
	else anz = 0;
	anz += 18;			/* Immer 18 Standard-Feiertage freihalten!	*/
	
	strcpy(file, file_path);
	strcat(file, "\\FEIERTAG.DAT");
	
	if ((fd = fopen(file, "r")) != NULL) {
		while (fgets(buffer, 80, fd) != NULL) {
			if (!isdigit(*buffer) || (strlen(buffer) < 8)) continue;
			anz++;
		}
		fseek(fd, 0, SEEK_SET);
	}
	
	ft = f_idx = (FEIERTAG *)malloc(anz * sizeof(FEIERTAG));
	if (ft != NULL) {

		for (i = 0; i < anz; ft[i++].tag = -1);
		*anzahl = anz;
		
		if (fd != NULL) {

			while (fgets(buffer, 80, fd) != NULL) {
				c = strtok(buffer, " \t\n");
				if (c == NULL) continue;
				if (stricmp(c, "Bundesland:") == 0) {
					c = strtok(NULL, "\n");
					*bundesland = BUNDESEINHEITLICH;
					
					for (; *c != '\0' && isspace(*c); c++);
					for (e = &c[strlen(c)-1]; e > c && isspace(*e); e--);
					*(++e) = '\0';
					for (i = 0; i < ANZ_LAENDER; i++) {
						if (stricmp(c, b_land[i]) == 0) break;
					}
					if (i < ANZ_LAENDER) *bundesland = i;
					continue;
				}
				if (!isdigit(*c) || (strlen(c) < 8)) continue;

				c[8] = '\0';
				if (stricmp(&c[4], "xxxx") == 0) {
					f_idx->jahr = jahr;
					f_idx->art = JAEHRLICH;
				} else {
					f_idx->jahr = atoi(&c[4]);
					f_idx->art = BEWEGLICH;
				}

				c[4] = '\0';
				f_idx->monat = atoi(&c[2]) - 1;
				c[2] = '\0';
				f_idx->tag = atoi(c);
				c = strtok(NULL, "\n");
				*(f_idx->bemerkung) = '\0';
				if (c != NULL) strncat(f_idx->bemerkung, c, 29);
				f_idx++;
			}

			fclose(fd);
		}
		f_idx = setze_feiertag(*bundesland, jahr, f_idx);
	}
	return(ft);	
}

/*------------------------------------------------------------------------
!	Speichert die Feiertage sowie das eingestellte Bundesland
+-----------------------------------------------------------------------*/

void speicher_feiertag(char *file_path, FEIERTAG *fe_tag, int bundesland)

{
	FILE *fd;
	char file[128];
	
	strcpy(file, file_path);
	strcat(file, "\\FEIERTAG.DAT");
	
	fd = fopen(file, "w");
	if (fd > 0) {
		fprintf(fd, "Bundesland: %s\n", b_land[bundesland]);
		while (fe_tag->tag > 0) {
			if (fe_tag->art <= JAEHRLICH) {
				fprintf(fd, "%02i%02i", fe_tag->tag, fe_tag->monat + 1);
				if (fe_tag->art == BEWEGLICH) fprintf(fd, "%04i ", fe_tag->jahr);
				else fputs("xxxx", fd);
				fprintf(fd, " %s\n", fe_tag->bemerkung);
			}			
			fe_tag++;
		}
		fclose(fd);
	}
}

/*------------------------------------------------------------------------
!	Setzt die deutschen Feiertage abhngig vom bundesland und vom Jahr
!	Liefert einen Zeiger auf den nchsten freien(!) Eintrag
+-----------------------------------------------------------------------*/

FEIERTAG *setze_feiertag(int bundesland, int jahr, FEIERTAG *ft)

{
	struct tm *ti;
	time_t o, dummy;
	
	if (bundesland == KEINE_FEIERTAGE) {
		ft->tag = -1;
		return(ft);
	}
	
	if (jahr <= 0) {
		dummy = time(NULL);
		ti = localtime(&dummy);
		jahr = ti->tm_year + 1900;
	}
	
	ft->jahr = jahr;	/* Neujahr	 1.1. bundeseinheitlich	*/
	ft->monat = 0;
	ft->tag = 1;
	ft->art = NEUJAHR;
	ft++;
	
	if ((bundesland == BAYERN_E) || (bundesland == BAYERN_K) || (bundesland == AUGSBURG) ||
		(bundesland == BADEN_WUERTTEMBERG) || (bundesland == SACHSEN_ANHALT)) {
		
		ft->jahr = jahr;	/* Heilige drei Knige	6.1. */
		ft->monat = 0;
		ft->tag = 6;
		ft->art = HEILIGE_DREI_KOENIGE;
		ft++;
	}
	
	o = ostern(jahr);		/* Wann ist denn Ostern ?	*/

	dummy = o - 172800L;
	ti = localtime(&dummy);
	
	ft->jahr = ti->tm_year + 1900;	/* Karfreitag	*/
	ft->monat	= ti->tm_mon;
	ft->tag = ti->tm_mday;
	ft->art = KARFREITAG;
	ft++;
	
	dummy = o + 86400L;
	ti = localtime(&dummy);
	
	ft->jahr = ti->tm_year + 1900;	/* Ostermontag	*/
	ft->monat	= ti->tm_mon;
	ft->tag = ti->tm_mday;
	ft->art = OSTERMONTAG;
	ft++;
	
	ft->jahr = jahr;		/* Maifeiertag 1.5. bundeseinheitlich	*/
	ft->monat = 4;
	ft->tag = 1;
	ft->art = MAIFEIERTAG;
	ft++;
	
	dummy = o + (86400L * 39L);	/* Christi Himmelfahrt	bundeseinheitlich	*/
	ti = localtime(&dummy);
	
	ft->jahr = ti->tm_year + 1900;
	ft->monat	= ti->tm_mon;
	ft->tag = ti->tm_mday;
	ft->art = CHRISTI_HIMMELFAHRT;
	ft++;
	
	dummy = o + (86400L * 50L);	/* Pfingstmontag	bundeseinheitlich	*/
	ti = localtime(&dummy);
	
	ft->jahr = ti->tm_year + 1900;
	ft->monat	= ti->tm_mon;
	ft->tag = ti->tm_mday;
	ft->art = PFINGSTMONTAG;
	ft++;
	
	if ((bundesland == BAYERN_E) || (bundesland == BAYERN_K) ||
		(bundesland == AUGSBURG) || (bundesland == BADEN_WUERTTEMBERG) ||
		(bundesland == SAARLAND) || (bundesland == RHEINLAND_PFALZ) ||
		(bundesland == HESSEN) || (bundesland == NORDRHEIN_WESTFALEN) ||
		(bundesland == SACHSEN_K) || (bundesland == THUERINGEN_K)) {
		
		dummy = o + (86400L * 60L);	/* Fronleichnam	*/
		ti = localtime(&dummy);
	
		ft->jahr = ti->tm_year + 1900;
		ft->monat	= ti->tm_mon;
		ft->tag = ti->tm_mday;
		ft->art = FRONLEICHNAM;
		ft++;
	}
	
	if (bundesland == AUGSBURG) {		/* Augsburger Friedensfest	*/
		ft->jahr = jahr;
		ft->monat = 7;
		ft->tag = 8;
		ft->art = FRIEDENSFEST;
		ft++;
	}
	
	if ((bundesland == AUGSBURG) || (bundesland == BAYERN_K) ||
		(bundesland == SAARLAND)) {
		ft->jahr = jahr;
		ft->monat = 7;
		ft->tag = 15;
		ft->art = MARIA_HIMMELFAHRT;
		ft++;
	}
	
	ft->jahr = jahr;
	ft->art = TAG_DER_DEUTSCHEN_EINHEIT;
	if (jahr >= 1990) {
		ft->monat = 9;
		ft->tag = 3;
	} else if (jahr >= 1953) {
		ft->monat = 5;
		ft->tag = 17;
	}
	ft++;
	
	if ((bundesland == BRANDENBURG) || (bundesland == MECKLENBURG_VORPOMMERN) ||
		(bundesland == SACHSEN_E) || (bundesland == SACHSEN_ANHALT) ||
		(bundesland == THUERINGEN_E)) {

		ft->jahr = jahr;
		ft->monat = 9;
		ft->tag = 31;
		ft->art = REFORMATIONSTAG;
		ft++;
	}
	
	if ((bundesland == AUGSBURG) || (bundesland == BAYERN_E) ||
		(bundesland == BAYERN_K) || (bundesland == BADEN_WUERTTEMBERG) ||
		(bundesland == SAARLAND) || (bundesland == RHEINLAND_PFALZ) ||
		(bundesland == NORDRHEIN_WESTFALEN) || (bundesland == SACHSEN_K) ||
		(bundesland == THUERINGEN_K)) {

		ft->jahr = jahr;
		ft->monat = 10;
		ft->tag = 1;
		ft->art = ALLERHEILIGEN;
		ft++;
	}
	
	ti->tm_year = jahr - 1900;
	ti->tm_mon = 10;
	ti->tm_mday = 16;
	ti->tm_sec = ti->tm_min = ti->tm_hour = 0;
	dummy = mktime(ti);
	ti = localtime(&dummy);
	
	if (jahr <= 1994 || bundesland == SACHSEN_K || bundesland == SACHSEN_E) {
		ft->jahr = jahr;
		ft->monat = 10;
		ft->tag = ti->tm_mday + (ti->tm_wday <= 3 ? 3 - ti->tm_wday : 10 - ti->tm_wday);
		ft->art = BUSS_UND_BETTAG;
		ft++;
	}

	ft->jahr = jahr;
	ft->monat = 11;
	ft->tag = 25;
	ft->art = WEIHNACHTSFEIERTAG_1;
	ft++;
	
	ft->jahr = jahr;
	ft->monat = 11;
	ft->tag = 26;
	ft->art = WEIHNACHTSFEIERTAG_2;
	
	ft++;
	ft->tag = -1;
	return(ft);
}
