#include <gscript.h>
#include <tos.h>
#include <stddef.h>
#include <aes.h>
#include <string.h>
#include <stdlib.h>

#include "variable.h"

#define FALSE 0
#define TRUE 1

static int s_apid;
static int gs_id;

int		aktion(const char *zeile, int script);

/*----------------------------------------------------
!	Dies Funktion liefert die GEMSCRIPT Untersttzung!
!	gibt TRUE oder FALSE zurck
+---------------------------------------------------*/

int gs_request(int aktiv, GS_INFO *gs_info, int ap_id, int *buffer)

{
	int send_buffer[16];

	gs_id = buffer[7];
	if (gs_info != NULL) {
		gs_info->len = sizeof(GS_INFO);
		gs_info->version = 0x0100;	/* Version */
		gs_info->msgs = GSM_COMMAND;
		send_buffer[3] = (int )((long )gs_info >> 16);
		send_buffer[4] = (int ) gs_info;
		send_buffer[6] = 0;		/* Request OK!	*/
	} else 	send_buffer[6] = -1;		/* Request OK!	*/

	if (aktiv) send_buffer[6] = -1;	/* Nur einen Request erlauben	*/
	s_apid = buffer[1];

	send_buffer[0] = GS_REPLY;
	send_buffer[1] = ap_id;
	send_buffer[2] = 0;
	send_buffer[5] = 0;
	send_buffer[7] = gs_id;
	appl_write(s_apid, 16, send_buffer);

	return(send_buffer[6]+1);	/* 0=FALSE oder 1=TRUE als Ergebnis	*/
}

/*--------------------------------------------------
!	Sendet die QUIT-Nachricht
+--------------------------------------------------*/

int gs_quit(int ap_id)

{
	int send_buffer[16];

	send_buffer[0] = GS_QUIT;
	send_buffer[1] = ap_id;
	send_buffer[2] = send_buffer[3] = 
		send_buffer[4] = send_buffer[5] = send_buffer[6] = 0;
	send_buffer[7] = gs_id;
	appl_write(s_apid, 16, send_buffer);
	
	return(FALSE);
}

/*----------------------------------------------------------
!	bernimmt die GS_COMMAND und antwortet mit GS_ACK
+-----------------------------------------------------------*/

int gs_command(int ap_id, int *buffer)

{
	int send_buffer[16], err;
	char *c, *erg;
	unsigned long bef;
	
	bef = (unsigned int )buffer[4]; 
	bef |= (unsigned long )buffer[3] << 16;
	
	for (c = (char *)bef; !(*c == '\0' && c[1] == '\0'); c++) {
		if (*c == '\0') *c = ' ';
	}

	err = aktion((char *)bef, TRUE);
	erg = malloc(strlen(var.v_art.c_string)+2);
	if (erg != NULL) {
		strcpy(erg, var.v_art.c_string);
		erg[strlen(erg)+1]='\0';
	}
	
	send_buffer[0] = GS_ACK;
	send_buffer[1] = ap_id;
	send_buffer[2] = 0;
	send_buffer[3] = buffer[3];
	send_buffer[4] = buffer[4];

	send_buffer[5] = (int )((long )erg >> 16);
	send_buffer[6] = (int ) erg;
	if (err != -7) send_buffer[7] = GSACK_OK;
	else send_buffer[7] = GSACK_UNKNOWN;
	
	appl_write(s_apid, 16, send_buffer);
	return(TRUE);
}

/*--------------------------------------------------
!	Gibt den String frei, wenn ein GS_ACK kommt
+---------------------------------------------------*/

void gs_ack(int *buffer)

{
	unsigned long bef;
	
	bef = (unsigned int )buffer[4]; 
	bef |= (unsigned long )buffer[3] << 16;
	if (bef != 0L) free((char *) bef);
}

