/*#include <stddef.h>			 /* Standard-Definitionen */
#include <string.h>      /* String-Library */
#include <extdef.h>
*/
#define MC_LIB
#define   NULL   ( (void*) 0L )

#include "mc_lib.hl"
#include "hilf.h"

static	int			apl_num = -1;
static	io_rec		io_ptr;
static  sys_par		*mcsys;
static  verwaltung	(*mcprocs)[7];

static long get_cookie(void)
{
	COOKIE  *cokie;

	cokie = 	*CJAR;
	if (cokie) 
	{
		while (cokie->tag.aslong != 0) 
		{
			if (!x_strncmp(cokie->tag.aschar, "MICO",4))
			{
				infos=(CINFO *)cokie->value;
			}
			cokie++;
		}
	}
	return(0);
}

long mygemdos(msg_typ *mc_msg)
{
 long   old_super_stack,erg;
 
 old_super_stack = x_Super( 0L );
 erg=MC_direct_call(mc_msg);
 x_Super((void *) old_super_stack );
 return( erg );
}

int get_mc_sys(syspar *sys,all_proc *allprocs)
{

  long		test;
  msg_typ   mc_msg;

	if (MiNT==0)
	{
		(void)x_Supexec(get_cookie);
		if (infos==NULL) MiNT=2;
			else	MiNT=1;
	}
	if (MiNT==1)
	{
		mc_msg.what =   0;
		*sys        = (sys_par *)mygemdos(&mc_msg);
		mc_msg.what =   1;
		*allprocs 	= (all_proc )mygemdos(&mc_msg);
		return(1);
	}
	else
	if (MiNT==2)
	{

    	mc_msg.what =   0;
	    test        =   trap111(&mc_msg);
    	if (test>0)	/* ist MIDI-COM nicht aktiviert, existiert GEMDOS 111 nicht =>-34*/
	    {
			*sys    = (sys_par *) test;
			mc_msg.what =   1;
			*allprocs = (all_proc) trap111(&mc_msg);
			return(1);
		}
	}
  return(0);
}

long	mc_message(msg_typ *mc_msg)
{
	if (MiNT==0)
	{
		(void)x_Supexec(get_cookie);
		if (infos==NULL) MiNT=2;
			else	MiNT=1;
	}
	if (MiNT==1)
		return(mygemdos(mc_msg));
	else
	    return(trap111(mc_msg));
}

long write_message(int what, int apl_num, int an, int size,char *name,void *ptr)
{
  msg_typ   mc_msg;

  mc_msg.what =   what;
  mc_msg.size=size;
  mc_msg.ptr=ptr;
  mc_msg.name=name;
  mc_msg.an=an;
  mc_msg.fill=apl_num;
  return(mc_message(&mc_msg));
}


int anmeld_ring(char *name,int buff_size)
{
 buff_size-=1;
 if (buff_size<4000) buff_size=4000;
 if (buff_size>30000) buff_size=30000;
 if (io_ptr.ibuf==NULL)
 {
  io_ptr.ibuf=x_Malloc(buff_size);
 };
 io_ptr.size=buff_size;	  /* groesse des Buffers      */
 io_ptr.   nl  =0;           /* naechste Leseposition    */
 io_ptr.   nw  =0;           /* naechste Schreibposition */
 io_ptr.   blow=0;           /* status/fehler            */
 io_ptr.   bhig=-1;          /* Ack: msg gelesen         */
 apl_num=(int)write_message(_ASSIGN,0,0,0,name,&io_ptr);
 if (apl_num>0) return(apl_num);
 return(FALSE);
}


void abmeld_ring(void)
{
	if (apl_num<=0) return;
   write_message(_GOOD_BYE,apl_num,0,0,NULL,NULL);
   if (io_ptr.ibuf)
   {
   	x_Mfree(io_ptr.ibuf);
   }
}

long transmit(int size,int an,char *name,void *dat_adr)
{  
	if (apl_num<=0) return(FALSE);
 return(write_message(_SEND_DATA,apl_num,an,size,name,dat_adr));
}

typedef	union
{
	int asint;
	char	aschar[2];
}konv1;

int lese(char *bufa1,int *esc,int *len)
{
 int i;
 konv1	help;
 
	if (apl_num<=0) return(FALSE);
 *esc=0;
 if (io_ptr.nl==io_ptr.nw) return(FALSE);
 help.aschar[0]=io_ptr.ibuf[io_ptr.nl++];
 if (io_ptr.nl==io_ptr.size) io_ptr.nl=0;
 help.aschar[1]=io_ptr.ibuf[io_ptr.nl++];
 if (io_ptr.nl==io_ptr.size) io_ptr.nl=0;
 if (help.asint>4000)
 {
   	*esc=help.asint;
	help.aschar[0]=io_ptr.ibuf[io_ptr.nl++];
	if (io_ptr.nl==io_ptr.size) io_ptr.nl=0;
	help.aschar[1]=io_ptr.ibuf[io_ptr.nl++];
	if (io_ptr.nl==io_ptr.size) io_ptr.nl=0;
	*len=help.asint;
 }
 for (i=0;i<=help.asint-3;i++)
 {
	bufa1[i]=io_ptr.ibuf[io_ptr.nl++];
	if (io_ptr.nl==io_ptr.size) io_ptr.nl=0;
 }
 return(TRUE);
}

void set_unitime(void)
{
	if (apl_num<=0) return;
 write_message(_UNITIME,apl_num,0,0,NULL,NULL);
}

void set_prconf(int conf)
{
	write_message(_PRKONF,0,0,conf,NULL,NULL);
}

int get_prconf(void)
{
	if (get_mc_sys(&mcsys,&mcprocs))
	{
		return(mcsys->prconf);
	}
	return(-1);
}

int mc_busy(void)
/* ring geschlossen und im sende-Modus */
{
 return(((io_ptr.blow & 7)==7) && ((io_ptr.blow & 64)==64));
}

int mc_closed(void)
/* ring geschlossen */
{
 return(((io_ptr.blow & 7)==7));
}

int mc_neustat(void)
/* ring-Verwaltung wurde gendert */
{
 return(((io_ptr.blow & 2048)==2048));
}

int get_Karte(all_proc karte)
{
	if (get_mc_sys(&mcsys,&mcprocs))
	{
		x_memcpy(karte,mcprocs,sizeof(procs));
		io_ptr.blow &= ~2048;	/* Hier wurde gendert!*/
		return(1);
	}
	return(0);
}

int get_LW(void)
{
	if (!mcsys)
		get_mc_sys(&mcsys,&mcprocs);
	return(mcsys->LW);
}

int relative_reply(int an)
{
int	i,cnt;
	if (an==0) return (0);
	cnt=0;
	for (i=0;i<7;i++)
	{
		if ((*mcprocs)[i].status.wert!=0) cnt++;
	}
	return(cnt-an);
}

int get_relative(int	absolut)
{
int i,erg;
	if (!mcsys)
		get_mc_sys(&mcsys,&mcprocs);
	if (absolut == mcsys->my_num) return(0);
	erg=0;
	i=mcsys->my_num;
	do
	{
		if (++i>6) i=0;
		if (i==mcsys->my_num) break;
		if ((*mcprocs)[i].status.wert!=0) erg++;
	}while (i!=absolut);
	return(erg);
}

int get_absolut(int	relativ)
{
int i,erg;
	if (!mcsys)
		get_mc_sys(&mcsys,&mcprocs);
	if (relativ == 0) return(mcsys->my_num);
	erg=0;
	i=mcsys->my_num;
	do
	{
		if (++i>6) i=0;
		if (i==mcsys->my_num) break;
		if ((*mcprocs)[i].status.wert!=0) erg++;
	}while (erg!=relativ);
	if (erg!=relativ) return(-1);
	return(i);
}

/*--------------------------- PASCAL ----------------------------*/

void c_to_pascal(char	*ziel,char *quelle)
{
char	cnt;
char	*b0;

	b0=ziel;
	b0++;
	cnt = 0;
	while (*quelle)
	{
		*b0++=*quelle++;
		cnt++;
	}
	ziel[0]=(char) cnt;
}

void pascal_to_c(char	*ziel,char *quelle)
{
char	cnt;

	cnt = *quelle++;
	while (cnt--)
	{
		*ziel++=*quelle++;
	}
	*ziel='\0';
}

int cdecl	_p_anmeld_ring(char *pname,int buff_size)
{
char	name[10];

pascal_to_c(name,pname);
return(anmeld_ring(name,buff_size));
}


void cdecl	_p_abmeld_ring(void)
{
	abmeld_ring();
}

long cdecl	_p_transmit(int size,int an,char *pname,void *dat_adr)
{  
char	name[10];
	pascal_to_c(name,pname);
	return(transmit(size,an,name,dat_adr));
}

int cdecl	_p_lese(char *bufa1,int *esc,int *len)
{
	return(lese(bufa1,esc,len));
}

void cdecl	_p_set_unitime(void)
{
	set_unitime();
}

void cdecl	_p_set_prconf(int conf)
{
	write_message(_PRKONF,0,0,conf,NULL,NULL);
}

int cdecl	_p_get_prconf(void)
{
	return(get_prconf());
}

int cdecl	_p_mc_busy(void)
/* ring geschlossen und im sende-Modus */
{
 return(((io_ptr.blow & 7)==7) && ((io_ptr.blow & 64)==64));
}

int cdecl	_p_mc_closed(void)
/* ring geschlossen */
{
 return(((io_ptr.blow & 7)==7));
}

int cdecl	_p_mc_neustat(void)
/* ring-Verwaltung wurde gendert */
{
 return(((io_ptr.blow & 2048)==2048));
}

int cdecl	_p_get_karte(all_proc karte)
{
	int i,j;
	if (get_Karte(karte))
	{
		for (i=0;i<7;i++)
		{
			c_to_pascal((*karte)[i].r_name,(*mcprocs)[i].r_name);
			for (j=0;j<6;j++)
			{
				c_to_pascal((*karte)[i].my_name[j],(*mcprocs)[i].my_name[j]);
			}
		}
		return(mcsys->my_num);
	}
	return(0);
}

int cdecl	_p_get_lw(void)
{
if (!mcsys)
	get_mc_sys(&mcsys,&mcprocs);
	return(mcsys->LW);
}

int cdecl	_p_relative_reply(int an)
{
int	i,cnt;
	if (!mcsys)
		get_mc_sys(&mcsys,&mcprocs);

	if (an==0) return (0);
	cnt=0;
	for (i=0;i<7;i++)
	{
		if ((*mcprocs)[i].status.wert!=0) cnt++;
	}
	return(cnt-an);
}

int cdecl	_p_get_relative(int	absolut)
{
int i,erg;
	if (!mcsys)
		get_mc_sys(&mcsys,&mcprocs);
	if (absolut == mcsys->my_num) return(0);
	erg=0;
	i=mcsys->my_num;
	do
	{
		if (++i>6) i=0;
		if (i==mcsys->my_num) break;
		if ((*mcprocs)[i].status.wert!=0) erg++;
	}while (i!=absolut);
	return(erg);
}

int cdecl	_p_get_absolut(int	relativ)
{
int i,erg;
	if (!mcsys)
		get_mc_sys(&mcsys,&mcprocs);
	if (relativ == 0) return(mcsys->my_num);
	erg=0;
	i=mcsys->my_num;
	do
	{
		if (++i>6) i=0;
		if (i==mcsys->my_num) break;
		if ((*mcprocs)[i].status.wert!=0) erg++;
	}while (erg!=relativ);
	if (erg!=relativ) return(-1);
	return(i);
}
