/*-------------------------------------------------------------------
!  TIMEMANA.C               Version 1.13-                23.02.1998
!
!	Hir werden Funktionen zur Verfgung gestellt, die fr die
!	Ereignismanagerfunktion bentigt werden.
!
+------------------------------------------------------------------*/

#define TITEL " BavariaEventManager V1.13- (23.02.98) "
#define INFO_ZEILE "  1994-98 by Michael Pieper"

char k_info[50]="";
char c_titel[]=TITEL;
char c_text[]=INFO_ZEILE;
char kal_info[40]="";

#include <aes.h>
#include <ext.h>
#include <new_aes.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <screen.h>
#include <time.h>
#include <magx.h>
#include <ctype.h>
#include <vaproto.h>
#include <sound.h>
#include <hsmodem.h>	/* Definitionen von Fcntl!	*/

#include <mc_lib.h>		/* Midi-Com-HEader			*/
#include <gscript.h>	/* GEM-Script behandlung	*/

#include "eventman.h"
#include "feiertag.h"
#include "gemscrip.h"
#include "variable.h"
#include "d:\multi.prg\multibox\system.h"

#define EXTERN extern

#define U_TO_U		0x0880		/* User to User Message									*/
#define GO_TOP		0x0001		/* Als Message sich am Bildschirm bemerkbar zu machen!	*/
#define LOAD_EVT	0x0002		/* Als Message, wenn was gendert wurde					*/

#define ERR_IF_OHNE_KLAMMER 2	/* Fehlermeldungen	*/
#define ERR_NO_DMASOUND		3
#define ERR_KEIN_KOMMANDO	4
#define ERR_NO_SSKONF		5
#define ERR_NO_MEM			6
#define ERR_VAR_ZULANG		7
#define ERR_VAR_VORHANDEN	8
#define ERR_FDELETE			9


OBJECT *menu;
OBJECT *msg;
OBJECT *gruppen_icon;

#define		KNOPF_EBENE	4		/* Ebenen fr die Knpfe! (norm-shift-cntrl-alt) */
#define		MAX_KNOPF	16 * KNOPF_EBENE	/* Anzahl der Buttonknpfe  */

typedef struct {
	char cookie[4];
	long value;
} MY_COOKIE;

typedef struct {
	int		wind_handle;
	int		art;				/* Aktuelle Windowgadgets	*/
	int		fx;
	int		fy;
	int		fw;
	int		fh;
	
	char	*titel;
	char	*info;
	char	kennung[6];			/* Kennung fr die INF-DATEI	*/
	
	int		aktiv		:1;
	int		iconified	:1;
	int		all_ic		:1;		/* Bei diesem Fenster wurde ALL-ICONIFY aktiviert	*/
	int		grp_ic		:1;		/* Diese Fenster sind im ALL-ICONIFY enthalten		*/
	int		gesichert	:1;		/* Dieses Fenster wurde mit sichern_inf gesichert	*/
	int		restore		:1;		/* Gibt an, ob das Fenster noch restauriert werden mu oder nicht	*/

	int		rest_ob;			/* Gibt an, welches Objekt nochmal gezeichnet werde mu	*/
	int		vslide;				/* Position des Schiebers	*/
	int		wert;				/* ANgezeigter Wert	*/

	int 	dx;					/* Differenz zwischen Fenster und Arbeitsbereich	*/
	int		dy;
	OBJECT	*ob;
	
	int		wx;					/* Arbeitsbereich	*/
	int		wy;
	int		wh;
	int		ww;
	
	int		i_dx;
	int		i_dy;
	OBJECT	*ic;
	
} FENSTER;

FENSTER info, haupt, knopf, kal, grins;
FENSTER *alle_fenster[] = { &info, &haupt, &knopf, &kal, &grins};

#define MAX_FENSTER 5

typedef struct {
	unsigned int fdate;
	unsigned int ftime;
} FILE_ZEIT;

struct file {
	FILE_ZEIT timer;
	FILE_ZEIT ss;
	FILE_ZEIT button;
	FILE_ZEIT programm;
	FILE_ZEIT feiertag;
} file_zeit;

typedef struct {
	char 	datum[10];
	char	zeit[8];
	char	text[6][51];
} INFO_BOX;

INFO_BOX	*info_box;

struct {
	int		enabled;
	char	name[14];
	char	ereignis[32];
} tasten[MAX_KNOPF];

struct flags {
	int		parallel	:1;	/* Parallelstart bei shel_write(1)	*/
	int		iconify		:1;	/* Iconify mglich?					*/
	int		magix		:1;
	int		mint		:1;
	int		midi_com	:1;	/* MIDI-COM ist installiert			*/
	int		midi_ring	:1;	/* MIDI-COM-Ring ist aktiv			*/
	int		wind_sort	:1;	/* Kann man die Reihenfolge der Fenster erkennen?	*/
	int		menu_bar	:1;	/* Hat das PRG eine Menleiste ?	*/
	int		fcntl		:1;	/* Ist die Funktion fcntl mglich?	*/
	int		finstat		:1;	/* Ist die Funktion finstat mglich	*/
	int		grp_icon	:1;	/* Gruppenicon geffnet				*/
	int		bav_env		:1;	/* BAVARIA-SYSTEM als EnvVariable	*/
	int		protokoll	:1;	/* protokoll erzeugen oder nicht	*/
	int		restore		:1;	/* Mu noch ein Fenster gemalt werden?	*/
	int		w_noakt		:1;	/* Warten auf no-aktion aktiv!		*/
	int		rsrc_load	:1;	/* rsrc_load wurde verwendet, daher rsrc_free nicht vergessen!	*/
	int		appl_search :1;	/* Ist appl_search vorhanden?		*/
	int		gs_aktiv	:1;	/* Ist Gem-Skript aktiv?			*/

	int		aktion;			/* Wieviel Aktione laufen gerade?		*/
	int		if_ebene;		/* Gibt an, in der wievielten verschachtelung sich die if-Abfrage befindet!	*/
	int		info_anzahl;	/* Anzahl der aufzuhebenden INFO-Meldungen	*/
	int		akute_infos;	/* Anzahl der vorhandenen Infomeldungen	*/
	int		mc_app_nr;		/* Applikationnr von MIDI-COM		*/
	int 	max_shlwr;		/* maximaler Shelwrite-Parameter	*/
	int		sek_evt;		/* Sekunden zum *.EVT-Dateien prfen 0=nicht */
	int		sek_prog;		/* Sekunden zum Programmberprfen			*/
	int		bundesland;		/* Fr Feiertagsberechnung	*/
	int		button_off;		/* Angezeigter OFFSET des Knopf-fensters	*/
	int		key_delay;		/* Gibt an, wielange zwischen zwei Zeichen eines Sendkey's gewartet werden soll	*/
	OBJECT	*ob;			/* Altes Object bei Gruppen Iconify			*/
} flags;

typedef struct {
	int		dev;
	char	string[50];
	char	ereignis[50];
} SS_AKT;

SS		aux 	= {AUX, 0, 0, 0, FALSE, -1, -1, 0, 0, "AUX", ""};
SS		midi 	= {MIDI, 0, 0, 0, FALSE, -1, -1, 0, 0, "MIDI", ""};
SS		modem1 	= {MODEM1, 0, 0, 0, FALSE, -1, -1, 0, 0, "MODEM1", ""};
SS		modem2 	= {MODEM2, 0, 0, 0, FALSE, -1, -1, 0, 0, "MODEM2", ""};
SS		serial1	= {SERIAL1, 0, 0, 0, FALSE, -1, -1, 0, 0, "SERIAL1", ""};
SS		serial2	= {SERIAL2, 0, 0, 0, FALSE, -1, -1, 0, 0, "SERIAL2", ""};
SS		prn 	= {PRN, 0, 0, 0, FALSE, -1, -1, 0, 0, "PRN", ""};
SS		con 	= {CON, 0, 0, 0, FALSE, -1, -1, 0, 0, "CON", ""};

SS_AKT	*ss_buffer;

int		max_ss_laenge = 0;

typedef struct {
	int		aktiv				:1;	/* Programm luft	*/
	char	programm[15];
	char	start_ereignis[50];
	char	end_ereignis[50];
} PROG_STRUKT;

PROG_STRUKT *prog_strukt;

typedef struct wait_ws {
	int		aktiv				:1;	/* Warten auf aktiv?	*/
	char	programm[15];
	int		file_nr;				/* AKT_*.DAT - Dateiname	*/
	struct wait_ws *next_ws;		/* zeiger auf die nchste Struktur!	*/
} WAIT_STRUKT;

WAIT_STRUKT *wait_strukt = NULL;

VARIABLE var;				/* Drei Variablen werden am Anfang initialisiert	*/
VARIABLE v_ereig;
VARIABLE v_argv;

char	ergebnis[130];
char	ereignis_nam[128];

FEIERTAG *f_tag;

char	timer_ereignis[256];
time_t	warte_zeit;

time_t	ereignis_zeit;
int		kal_mon;		/* Angezeigter Kalendermonat	*/
int		kal_jahr;		/* Angezeigtes Jahr	*/
int		anz_tag;		/* Aktueller Tag	*/

int		ap_id;

char	file_path[128], inf_file[128], edit_prog[128], rsrc_file[128];
char	proto_file[64]="%d_%m_%y";

char	dummy[1024];
char	f1[128], f2[128];
char	*monate[]={"Januar", "Februar", "Mrz", "April", "Mai", "Juni", "Juli",
				"August", "September", "Oktober", "November", "Dezember"};
				
char bingbong[]={0x00,0x40,0x01,0x01,
     0x07,0xfe,0x0b,0x00,0x0c,0x30,0x0d,0x00,0xff,0x1a,
     0x00,0xa0,0x01,0x01,0x0d,0x00,0xff,0x20,0xff,0x00};

char programm[128];
char parameter[128];
char va_parameter[128];
char *environment;

GS_INFO *gs_info;	/* GS_INFO fr Gemscript	*/

static int		contrl[15];
static int		global[15];
static int		intin[132];
static int		intout[140];
static int		addrin[16];
static int		addrout[16];

static AESPB	aespb = { contrl, global, intin, intout, addrin, addrout };

/*-------------------------------------------------------------------
!	Prototypen
+------------------------------------------------------------------*/

time_t	lade_n_ereignis(char *ereignis);
void	skip_timer(char *ereignis, time_t sekunden);

int		appl_anmelden(void);
int		test_cookie(char *cookie, long *value);

void	user_aktion(void);
void	rsrc_init(void);

int 	ereignis_bearbeiten(time_t zeit, char *ereignis);
int		ausfuehren(char *ereignis, int app_id);
int		aktion(const char *zeile, int script);
int		waitfor(char *was);

PROG_STRUKT *setze_programm(void);
void	setze_buttons(void);
void	disp_button(int zeichnen);
void	setze_ss(void);

time_t	message_timer(time_t ereignis_zeit, int *quit);
int		message_button(int mx, int my, int mb, int ks);
int		message_katalog(int *buffer);
int		message_keyboard(int scan);
void	lese_ss(SS *schnittstelle);
void	clear(int dev);
void	teste_ss(SS *schnittstelle);
void	init_ss(void);

int		intersect(GRECT *erg, const GRECT *re_1, const GRECT *re_2);
void	setze_ob(OBJECT *ob, int kind, char *text);
void 	update_ss(SS *schnittstelle);

void	test_evt(int start);
void	test_progs(PROG_STRUKT *prog);
int		sichern_inf(void);
void	lese_inf(FENSTER *haupt, FENSTER *knopf, FENSTER *kalender, FENSTER *g);
void	suche_inf(void);
void	gong(void);

void setze_infobox(char *text, time_t zeit);
void zeige_infobox(int wert, int oeffnen);
void lade_infobox(void);

FEIERTAG *feiertag(time_t start, time_t *ergebnis);

void	setze_kalender(int mon, int jahr);

void	oeffne_fenster(FENSTER *f);
void	schliesse_fenster(FENSTER *f);
FENSTER *hole_fenster(int wind_handle);

void set_menu(FENSTER *f, int check);
void init_win(FENSTER *f, char *titel, char *info, char *kennung);

char *erweitere_env(char *alt_env);

void fehler(int error, char *text);
void go_help(char *node);
void del_temp(void);

void del_var(VARIABLE *v);
int dim_var(char *v_namen);
void setze_var(char *v_name, char *c_string, long l_wert);
VARIABLE *teste_var(char *v_name);
char *setze_text(char *alt, char *neu, long max_laenge);
void set_file_aktion(FILE *fd, char *aktion);

int hole_midi_nr(char *rechner);
int bedingung(char *frage);
void sichern_aktiv(FILE *fd_r, char *ereignis, int app_nr, char * kommando);

int	my_wind_get(int handle, int mode, int *p1, int *p2, int *p3, int *p4);

void proto(char *art, char *text);

void	wait_neu(char *prog, int aktiv, int nr);
void	wait_del(void);
int		test_wait(WAIT_STRUKT *ws);

int  naechster_timer(time_t zeit, char *ereignis);
int antoi(char *string, int anz);
void Sound_tt(int links, int rechts);
int send_key(char *programm, char *string);
int top_app(char *appl);
int aktiv(char *programm, int *ap_id);
int va_startprog(char *prog, char *parameter, int warten);

/*----------------------------------------------------------------
!	Hauptschleife
+-----------------------------------------------------------------*/

void main(int argc, char *argv[], char *env[])

{
	int i;
	flags.mint = flags.magix = flags.parallel = flags.iconify =  
	flags.wind_sort = flags.menu_bar = flags.grp_icon = flags.midi_com = flags.midi_ring = FALSE;
	flags.protokoll = flags.mc_app_nr = flags.w_noakt = flags.rsrc_load = flags.appl_search = FALSE;
	flags.sek_evt = flags.if_ebene = flags.akute_infos = flags.aktion = 0;
	flags.sek_prog = 2;
	flags.key_delay = 200;
	flags.fcntl = flags.finstat = TRUE;
	flags.max_shlwr = 1;
	flags.info_anzahl = 5;		/* 5 INFO-Nachrichten werden aufgehoben			*/
	flags.button_off = -1;		/* Derzeit wurden noch keine Buttons angezeigt	*/
	flags.gs_aktiv = FALSE;
	
	flags.bundesland = BUNDESEINHEITLICH;
	
	gs_info = (GS_INFO *)malloc(sizeof(GS_INFO));
	
	warte_zeit = 0;
	Pdomain(1);			/* Ich kann lange Dateinamen	*/
	
	/* Initialisieren der ersten zwei Variablen */
	strcpy(var.name, "ERGEBNIS$");
	var.art = (int )sizeof(ergebnis)-1;
	var.v_art.c_string = ergebnis;
	var.next_var = &v_ereig;

	strcpy(v_ereig.name, "EREIGNIS$");
	v_ereig.art = (int )sizeof(ereignis_nam)-1;
	v_ereig.v_art.c_string = ereignis_nam;
	var.next_var = &v_argv;

	strcpy(v_argv.name, "ARGV$");
	v_argv.art = (int )sizeof(parameter)-1;
	v_argv.v_art.c_string = parameter;
	v_argv.next_var = NULL;
	
	appl_anmelden();
	suche_inf();	/* Setzt die Variable inf_file	*/

	i = 0;
	f_tag = lade_feiertag(file_path, &flags.bundesland, &i, 0);
	rsrc_init();
	environment = (_app) ? erweitere_env(*env) : erweitere_env(NULL);

	info_box = (INFO_BOX *)malloc(flags.info_anzahl * sizeof(INFO_BOX));
	lade_infobox();
	
	init_ss();
	setze_ss();
	prog_strukt = setze_programm();
	
	graf_mouse(ARROW, NULL);

	del_temp();							/* Waitfor lschen!	*/

	ereignis_zeit = lade_n_ereignis(timer_ereignis);
	ausfuehren("_Programmstart", -1);

	if (argc >= 2) {
		*parameter = '\0';
		for(i = 2; i < argc; i++) {
			strcat(parameter, argv[i]);
			strcat(parameter, " ");
		}
		ausfuehren(argv[1], -2);	/* bergebene Batchdateien starten	*/
	}
	test_evt(TRUE);
	user_aktion();

	if (flags.midi_com && mc_closed()) abmeld_ring();	/* Kann keine Nachrichten mehr empfangen!	*/

	for (i = 0; i < MAX_FENSTER; schliesse_fenster(alle_fenster[i++]));

	if (!flags.mint && !flags.magix) {
		wind_get(0, WF_TOP, &i);
		while (i > 0) {
			wind_close(i);
			wind_delete(i);
			wind_get(0, WF_TOP, &i);
		}
	}

	if (var.next_var != NULL) del_var(var.next_var);			/* Gibt Speicher fr die Variablen frei!	*/
	
	if (wait_strukt != NULL) wait_del();
	if (info_box != NULL) free(info_box);
	if (prog_strukt != NULL) free(prog_strukt);
	if (ss_buffer != NULL) free(ss_buffer);
	if (_app & (*env != environment)) free(environment);
	if (f_tag != NULL) free(f_tag);
	
	if (flags.menu_bar) menu_bar(menu, FALSE);
	if (flags.rsrc_load) rsrc_free();

	if (gs_info != NULL) {
		if (flags.gs_aktiv) gs_quit(ap_id);
		free(gs_info);
	}
	appl_exit();
	exit(0);
}

/*-----------------------------------------------------------------------
!	Meldet das Programm an und berprft, ob ein gleichnamiges Programm
!	bereits aktiviert wurde (festgelegt auf den Namen "EVENTMAN")
!	<- app_id der eigenen Applikation
+----------------------------------------------------------------------*/

int	appl_anmelden(void)

{
	int ap_type, ap_sid;
	int a,b,c,d;
	char name[30];
	char *e[];
	int appl_buffer[16];			/* buffer um der Parallelapp was zu schicken	*/
	
	ap_id = appl_init();			/* anmelden	*/
	if (ap_id < 0) {
		form_alert(1, "[3][" TITEL "| | Fehler beim Anmelden!][Abbruch]");
		appl_exit();
		exit(0);
	}

	if (test_cookie("MagX", NULL)) flags.magix = flags.parallel = TRUE;
	if (test_cookie("MiNT", NULL)) flags.mint = flags.parallel = TRUE;

	if (test_cookie("MCTR", NULL)) {
		flags.midi_com = TRUE;
		flags.midi_ring = mc_closed();
	}
	
	if ((!_app) || (flags.mint)) menu_register(ap_id,"  EventManager");   /* Dann tragen wir uns mal in das DESK-Men ein und erhalten unsere Eintragsnr. */

	if ((_app) || (flags.mint) || (flags.magix)) flags.menu_bar = TRUE;

	if (_GemParBlk.global[0] >= 0x0340) flags.wind_sort = TRUE;		/* Bereits im FalconTOS vorhanden!	*/
	
    if((_GemParBlk.global[0] >= 0x399) || (appl_find("?AGI") > 0)) {		/* appl_getinfo vorhanden	*/

		if (appl_getinfo(APG_SHWR, &a, &b, &c, &d)) {
			flags.max_shlwr = a & 0x00ff;
		}
		if (flags.max_shlwr >= 9) shel_write(SHW_MSGREC, 0x0001, 0, NULL, NULL);	/* AP_TERM aktivieren	*/
		if (appl_getinfo(APG_FENSTER, &a, &b, &c, &d)) {
			flags.iconify = (c & 0x0001) ? TRUE : FALSE ;
			flags.wind_sort = (a & 0x0011) ? TRUE : FALSE ;
		}
		if ((appl_getinfo(APG_ALLG1 ,&a, &b, &c, &d) && c) || flags.mint) {	/* appl_search vorhanden	*/
														/* Suche nach App mit gleichem Namen!	*/
			flags.appl_search = TRUE;
			appl_search(APS_FIRST, name, &ap_type, &ap_sid);
			do {
				if ((strcmp("EVENTMAN", name) == 0) && ap_sid != ap_id) {
					form_alert(1, msg[MSG_PRGRUNNING].ob_spec.free_string);
					appl_buffer[0] = U_TO_U;
					appl_buffer[1] = ap_id;
					appl_buffer[2] = 0;
					appl_buffer[3] = GO_TOP;
					appl_write(ap_sid, 16, appl_buffer);	/* Es mssen immer 16 Byte gesendet werden, sonst gibts Bomben	*/
					appl_exit();
					exit(0);
				}
			} while (appl_search(APS_NEXT, name, &ap_type, &ap_sid));
		}
		if (appl_getinfo(APG_SHWR, &a, &b, &c ,&d) && !c) flags.parallel = TRUE;	/* shel_write startet parallel!	*/
	} else flags.parallel = FALSE;
	
	file_path[1] = ':';			/* Aktueller Pfad vorbereiten!	*/
	Dgetpath(&file_path[2], 0);
	file_path[0] = Dgetdrv() + 'A';
	if (_app) strcat(file_path, "\\EVENTMAN.DAT");

	shel_envrn(e, "BAVARIA-SYSTEM=");
	if (*e != NULL) {
		strcpy(file_path, *e);
		flags.bav_env = TRUE;
	} else flags.bav_env = FALSE;
	
	return(ap_id);
}

/*-----------------------------------------------------------------------
!	berprft, ob der cookie "text" vorhanden ist.
+----------------------------------------------------------------------*/

int test_cookie(char *cookie, long *value)

{
	void *ssp;
	MY_COOKIE *cook_ptr;
	
	ssp = (void *)Super(0);

	cook_ptr = *(MY_COOKIE **)0x5A0;		/* cookie Speicherplatzzeiger	*/
	
	Super(ssp);

	if (cook_ptr != NULL) {
		do {
			if (strnicmp(cook_ptr->cookie, cookie, 4) == 0) {
				if (value != NULL) *value = cook_ptr->value;
				return(TRUE);
			}
		} while (memcmp((cook_ptr++)->cookie, "\0\0\0\0", 4) != 0);
	}	
	return(FALSE);
}

/*----------------------------------------------------------------
!	User aktionen
+-----------------------------------------------------------------*/

void user_aktion(void)

{
	int erg, quit, mx, my, mb, ks=0, kr, br, i;
	int buffer[16];
	int ms = 0;

	do {
		quit = FALSE;
		erg = evnt_multi(MU_MESAG|MU_BUTTON|MU_KEYBD|MU_TIMER,
                 2, 1, 1,
                 0, 0, 0, 0, 0,
                 0, 0, 0, 0, 0,
                 buffer,
                 100, 0,  
                 &mx, &my,
                 &mb, &ks,
                 &kr, &br);
        
		if (flags.restore) {
			flags.restore = FALSE;
			for (i = 0; i < MAX_FENSTER; i++) { /* Prfen ob nochwas gezeichnet werden mu	*/
				if (alle_fenster[i]->restore) {
					setze_ob(alle_fenster[i]->ob, alle_fenster[i]->rest_ob, NULL);
				}
			}
		}

		if (erg & MU_MESAG) 
			quit |= message_katalog(buffer);

		if (erg & MU_TIMER) {
			ms++;
			if ((flags.sek_evt != 0) && ((ms % (flags.sek_evt * 10)) == 0)) test_evt(FALSE);
			if ((ms % 20) == 0)	ereignis_zeit = message_timer(ereignis_zeit, &quit);
		}

		if (warte_zeit != 0) {							/* DELAY eingeschalten	*/
			if (warte_zeit > time(NULL)) continue;
			warte_zeit = 0;
			ereignis_zeit = lade_n_ereignis(timer_ereignis);
			quit |= ausfuehren(NULL, 998);
		}	

		if (erg & MU_TIMER) {

			if ((ms % (flags.sek_prog * 10)) == 0) {
				if (flags.sek_prog != 0) test_progs(prog_strukt);
				quit |= test_wait(wait_strukt);
			}
			if (aux.on_off > 0) lese_ss(&aux);
			if (midi.on_off > 0) lese_ss(&midi);
			if (modem1.on_off > 0) lese_ss(&modem1);
			if (modem2.on_off > 0) lese_ss(&modem2);
			if (serial1.on_off > 0) lese_ss(&serial1);
			if (serial2.on_off > 0) lese_ss(&serial2);
			if (flags.midi_com) {
				if (!flags.mc_app_nr) flags.mc_app_nr = anmeld_ring("EVENTMAN", 2048);
				else {
					flags.midi_ring = mc_closed();
					if (flags.midi_ring && 
						lese(ergebnis, &i, &erg)) {
							if (aktion(ergebnis, FALSE) == -8) {
								/* evtl. ein GOTO ? 	*/
								quit |= ausfuehren(ereignis_nam, -1);
							}
						}
				}
			}
			if (flags.w_noakt && flags.aktion == 0) quit |= waitfor("no-aktion");
		}

        if (erg & MU_BUTTON) 
        	if (br >= 1) quit |= message_button(mx, my, mb, ks);
		if (erg & MU_KEYBD) 
			quit |= message_keyboard(kr);
		
		if (hole_fenster(-1) == &knopf) 
			disp_button(FALSE);	/* Nur Updaten, wenn Fenster aktiv!	*/

	} while (!quit || !_app);
}

/*------------------------------------------------------------------------
!	Fhrt nchste Aktion aus, auf die gewartet wurde
+-----------------------------------------------------------------------*/

int waitfor(char *was)

{
	FILE *fd_r, *fd_w;
	char *wert, *nr, *c;
	int erg, starten = -1, anz = 0;

	erg = 0;
	flags.w_noakt = FALSE;
	sprintf(f1, "%s\\waitfor.dat", file_path);
	sprintf(f2, "%s\\waitfor.tmp", file_path);
	fd_r = fopen(f1, "r");
	if (fd_r != NULL) {
		fd_w = fopen(f2, "w");
		if (fd_w != NULL) {
			while (fgets(dummy, 255, fd_r) != NULL) {
				nr = strtok(dummy, "\t");
				wert = strtok(NULL, " \t\n");
				if (starten < 0 && stricmp(wert, was) == 0) {	/* maximal eine Aktion raussuchen!	*/
					if (stricmp(wert, "no-aktion") == 0) ++flags.aktion;		/* bei no-aktion muss geschummelt werden!	*/
					starten = atoi(nr);
				} else {
					anz++;
					if (stricmp(wert, "no-aktion") == 0) flags.w_noakt = TRUE;	/* da gibts noch eine no-aktion!	*/
					c = strtok(NULL, "\n");
					if (c == NULL) c = &nr[strlen(nr)];	/* Nur ein 0-Byte	*/
					fprintf(fd_w, "%s\t%s\t%s\n", nr, wert, c);
				}
			}
			fclose(fd_w);
		}
		fclose(fd_r);
		Fdelete(f1);
		Frename(0, f2, f1);
	}
	if (anz <= 0) Fdelete(f1);	/* Kein Ereignis mehr, dann wartedatei lschen	*/
	if (starten >= 0) erg = ausfuehren(NULL, starten);
	return(erg);
}

/*------------------------------------------------------------------------
!	Behandelt die Tastatureingaben
!	Liefert TRUE, wenn Programm beendet werden soll.
+-----------------------------------------------------------------------*/

int message_keyboard(int scan)

{
	char scode[5];
	char *code, *ereignis = NULL;
	int erg = FALSE, len;
	FILE *fd;
	
	if (scan == 0x6200) {
		go_help(NULL); 	/* ST-GUIDE-Hilfstexte!	*/
		return(FALSE);	/* Nicht beenden sondern schn weiter machen!	*/
	}
	
	itoa(scan, scode, 16);
	len = (int )strlen(scode);
	if (len < 4) {	/* Wenn Ergebnis nicht vierstellig!	*/
		memcpy(&scode[4-len], scode, len+1);
		strnset(scode, '0', 4 - len);
	}

	strcpy(f1, file_path);
	strcat(f1, "\\KEYBOARD.EVT");

	fd = fopen(f1, "r");
	if (fd != NULL) {
		while(fgets(dummy, 254, fd) != NULL) {
			code = strtok(dummy, " \t");
			if ((code[0] != '-') && (strnicmp(code, scode, 2) != 0)) continue;
			if ((code[2] != '-') && (strnicmp(&code[2], &scode[2], 2) != 0)) continue;
			ereignis = strtok(NULL, " \t\n");
			break;
		}
		fclose(fd);
		if (ereignis != NULL) erg = ausfuehren(ereignis, -1);
	}
	if ((ereignis == NULL) && (scan == 0x1011) && (_app)) 
		return(ausfuehren("_Programmende", -1));	/* ^Q ist festgelegt, wenn kein Ereignis dafr definiert ist	*/

	return(erg);
}
/*------------------------------------------------------------------------
!	Behandelt die Zeitabhngigen Msgs
!	liefert die Zeit des nchsten Ereignisses
!	QUIT wird beim beenden mit TRUE geodert!
+-----------------------------------------------------------------------*/

time_t message_timer(time_t ereignis_zeit, int *quit)

{
	time_t t;
	char zeit[20];
	struct tm *tm;
		
	t = time(NULL);
	tm = localtime(&t);
	strftime(zeit, 19, "%H%M%S%d%m%Y", tm);
	zeit[19]='\0';
	setze_ob(haupt.ob, AKTUELL, zeit);
	
	if (tm->tm_mday != anz_tag) setze_kalender(tm->tm_mon, tm->tm_year);
	
	if (ereignis_zeit == 0) return(0);
	if (warte_zeit > t) return(ereignis_zeit);

	if (ereignis_zeit <= t) {
		*quit |= ereignis_bearbeiten(t, timer_ereignis);
		ereignis_zeit = lade_n_ereignis(timer_ereignis);
	}
	return(ereignis_zeit);
}

/*------------------------------------------------------------------
!	Verschiebt Zeitabhngige Ereignisse um xx Minuten!
!	wird bei sekunden -1 bergeben, wird um ein Zeitintervall weitergeschalten!
+-----------------------------------------------------------------*/

void skip_timer(char *ereignis, time_t sekunden)

{
	FILE *fd_r, *fd_w;
	char buffer[128];
	char *c;
	time_t s;
	int i = FALSE;

	if (ereignis == NULL) return;
	sprintf(f1, "%s\\TIMER.EVT", file_path);
	fd_r = fopen(f1, "r");							/* zum lesen  ffnen!	*/
	strcpy(&f1[strlen(f1)-3], "BAK");
	fd_w = fopen(f1, "w");							/* zum schreiben  ffnen!	*/
	if (fd_w != NULL && fd_r != NULL) {

		i = TRUE;
		while (fgets(buffer, 127, fd_r) != NULL) {
			for (c = buffer; *c != '\0' && isspace(*c); c++);	/* fhrende Blanks entfernen	*/
			for (; *c != '\0' && !isspace(*c); c++);			/* Uhrzeit lesen	*/
			for (; *c != '\0' && isspace(*c); c++);				/* Blanks berlesen	*/
			for (; *c != '\0' && !isspace(*c); c++);			/* Wiederholung lesen	*/
			for (; *c != '\0' && isspace(*c); c++);				/* Blanks berlesen	*/
			for (; *c != '\0' && !isspace(*c); c++);			/* Kennung lesen	*/
			for (; *c != '\0' && isspace(*c); c++);				/* Blanks berlesen	*/
			if (strnicmp(ereignis, c, strlen(ereignis)) == 0) {	/* ereignis bisher ok	*/
				c += strlen(ereignis);
				if (*c == '\0' || isspace(*c)) {
					s = (sekunden > 0) ? sekunden + time(NULL) : sekunden; /* Sekunden + aktuelle Zeit setzen, ansonsten -Werte bergeben!	*/
					naechster_timer(s, buffer);					/* nur, wenn notwendig ndern!	*/
				}
			}
			fputs(buffer, fd_w);
		}
	}
	if (fd_w != NULL) fclose(fd_w);
	if (fd_r != NULL) fclose(fd_r);
	if (i) {										/* Nur umbenennen, wenn auch das Ergebnis ok war!	*/
		sprintf(f1, "%s\\TIMER.EVT", file_path);
		sprintf(f2, "%s\\TIMER.BAK", file_path);
		Fdelete(f1);
		Frename(0, f2, f1);
	}
}

/*----------------------------------------------------------------
!	Behandelt die Nachrichten 
+-----------------------------------------------------------------*/

int message_button(int mx, int my, int mb, int ks)

{
	int i, end = FALSE, erg, top_window;
	time_t t;
	struct tm *tm;

	wind_get(0, WF_TOP, &top_window);
	
	if (top_window == info.wind_handle) {

		erg = objc_find(info.ob, 0, 10, mx, my);
		if ((erg < 0) || ((info.ob[erg].ob_flags & SELECTABLE) == 0)) return(FALSE);
		if (form_button(info.ob, erg, 1, &i) != 0) return(FALSE);
		
		objc_change(info.ob, erg, 1, info.fx, info.fy, info.fw, info.fh, NORMAL, TRUE);
		switch(erg) {
			case OPEN_STATUS:
				oeffne_fenster(&haupt);
				break;
			case OPEN_BUTTON:
				oeffne_fenster(&knopf);
				break;
			case OPEN_INFO:
				oeffne_fenster(&grins);
				break;
			case OPEN_KALENDER:
				if (!kal.aktiv) {
					t = time(NULL);
					tm = localtime(&t);
					setze_kalender(tm->tm_mon, tm->tm_year);
				}
				oeffne_fenster(&kal);
				break;
			case SAVE:
				sichern_inf();
				break;
		} 
	} else if (top_window == kal.wind_handle) {
		erg = objc_find(kal.ob, 0, 10, mx, my);
		switch(erg) {
		}
	} else if (top_window == knopf.wind_handle) {
		erg = objc_find(knopf.ob, 0, 10, mx, my);
		if ((erg >= K1) && (erg <= K1 + (MAX_KNOPF / KNOPF_EBENE))) {
			if (form_button(knopf.ob, erg, 1, &i) == 0) {
				objc_change(knopf.ob, erg, 1, knopf.fx, knopf.fy, knopf.fw, knopf.fh, NORMAL, TRUE);
				end = ausfuehren(tasten[(erg - K1) + flags.button_off].ereignis, -1);
			}
		}
	}
	return(end);
}


/*----------------------------------------------------------------
!	Behandelt die Nachrichten 
!	Gibt TRUE zurck, wenn beendet werden soll
+-----------------------------------------------------------------*/

int message_katalog(int *buffer)

{
	FENSTER *akt;
	FILE *fd;
	OBJECT *ob;
	char file[128], *c, *d, f[15], p[128];
	int appl_buffer[16];
	unsigned long argv;

	GRECT re, wi;
	int end = FALSE;
	int x, y, w, h, i, j;
	
	wind_update(BEG_UPDATE);
	switch(buffer[0]) {		/* aktuelles Object errechnen	*/
		case WM_CLOSED:			/* Schliessbox	*/
		case WM_MOVED:			/* Bewegen	*/
		case WM_REDRAW:			/* Neuzeichnen		*/
		case WM_NEWTOP:
		case WM_ONTOP:
		case WM_TOPPED:			/* Nach oben holen	*/
		case WM_UNTOPPED:
		case WM_ICONIFY:
		case WM_UNICONIFY:
		case WM_ALLICONIFY:
			if ((akt = hole_fenster(buffer[3])) == NULL) {
				wind_update(END_UPDATE);
				return(end);
			}
			break;
	}
	switch(buffer[0]) {			/* ev_mgpbuff */
		case MN_SELECTED:		/* Auswahl der Menleiste	*/
			switch(buffer[4]) {
				case MENU_ENDE:
					wind_update(END_UPDATE);
					return(ausfuehren("_Programmende", -1));
				case MENU_INFO:
					oeffne_fenster(&info);
					break;
				case MENU_SAVE:
					sichern_inf();
					break;
				case MENU_INF:
					oeffne_fenster(&grins);
					break;
				case BEM_EDIT:
					if ((i = appl_find("BEM_EDIT")) >= 0) {
						appl_buffer[0] = U_TO_U;
						appl_buffer[1] = ap_id;
						appl_buffer[2] = 0;
						appl_buffer[3] = GO_TOP;
						appl_write(i, 16, appl_buffer);	/* Es mssen immer 16 Byte gesendet werden, sonst gibts Bomben	*/
					} else {
						if (*edit_prog == '\0') {
							strcpy(edit_prog, file_path);
							c = strrchr(edit_prog, '\\');
							if (c != NULL) *(++c) = '\0';
							strcat(edit_prog, "BEM_EDIT.PRG");
						}
						strcpy(file, "EXEC ");
						strcat(file, edit_prog);

						if ((fd = fopen(&file[5], "rb")) == NULL) {
							if (form_alert(1, msg[MSG_NOBEMEDIT].ob_spec.free_string) == 2) break;

							file[5] = '\0';
							strcpy(f, "BEM_EDIT.PRG");
								
							Dgetpath(&p[2], 0);
							*p = Dgetdrv() + 'A';
							p[1] = ':';
							strcat(p, "\\*.PRG");
								
							fsel_exinput(p, f, &i, msg[MSG_FS_BEMEDIT].ob_spec.free_string);
							if (i == 1) {		/* OK angeklickt	*/
								strcpy(edit_prog, p);
								c = strrchr(edit_prog, '\\');
								if (c != NULL) *(++c) = '\0';
								strcat(edit_prog, f);
								strcat(file, edit_prog);
							} else break;
						} else fclose(fd);

						wind_update(END_UPDATE);
						aktion(file, FALSE);
						test_evt(FALSE);
						wind_update(BEG_UPDATE);
					}
					break;
				case MENU_HF:
					oeffne_fenster(&haupt);
					break;
				case MENU_MS:
					oeffne_fenster(&knopf);
					break;
				case MENU_KAL:
					oeffne_fenster(&kal);
					break;
			}
			menu_tnormal(menu, buffer[3], TRUE);
			break;
		case WM_CLOSED:			/* Schliessbox	*/
			schliesse_fenster(akt);
			break;
		case WM_MOVED:			/* Bewegen	*/
			if (!(akt->iconified)) {
				akt->ob->ob_x += buffer[4] - akt->fx;
				akt->ob->ob_y += buffer[5] - akt->fy;
				akt->wx = buffer[4] + akt->dx;
				akt->wy = buffer[5] + akt->dy;
			} else {
				akt->ic->ob_x = buffer[4] + akt->i_dx;
				akt->ic->ob_y = buffer[5] + akt->i_dy;
			}
			wind_set(buffer[3], WF_CURRXYWH, buffer[4], buffer[5], buffer[6], buffer[7]);
			akt->fx = buffer[4];
			akt->fy = buffer[5];
			akt->fw = buffer[6];
			akt->fh = buffer[7];
			break;
		case WM_REDRAW:			/* Neuzeichnen		*/
			ob = (akt->iconified) ? akt->ic : akt->ob;			
			if (akt->restore) {	/* Wenn noch nicht alles gezeichnet, dann jetzt!	*/
				wi.g_x = ob->ob_x;
				wi.g_y = ob->ob_y;
				wi.g_w = ob->ob_width;
				wi.g_h = ob->ob_height;
				akt->restore = FALSE;
				akt->rest_ob = -1;
			} else {
				wi.g_x = buffer[4];
				wi.g_y = buffer[5];
				wi.g_w = buffer[6];
				wi.g_h = buffer[7];
			}
			wind_get(buffer[3], WF_FIRSTXYWH, &re.g_x, &re.g_y, &re.g_w, &re.g_h);
			while (re.g_w != 0 || re.g_h != 0) {
				if (intersect(&re, &re, &wi))
					objc_draw(ob, 0, 10, re.g_x, re.g_y, re.g_w, re.g_h);
				wind_get(buffer[3], WF_NEXTXYWH, &re.g_x, &re.g_y, &re.g_w, &re.g_h);
			} 
			break;
		case U_TO_U:			/* Mail von gleichem Programm	*/
			switch(buffer[3]) {
				case GO_TOP:	oeffne_fenster(&info);
								break;
				case LOAD_EVT:	/* Mail von Editoren	*/
								test_evt(FALSE);
								break;
			}
			break;
		case AC_OPEN:           /* Der Benutzer hat den Menpunkt angewhlt und mcht mit mir reden...          */
			oeffne_fenster(&info);
			break;
		case AC_CLOSE:
			for (i = 0; i < MAX_FENSTER; schliesse_fenster(alle_fenster[i++]));
			break;
		case WM_NEWTOP:
		case WM_ONTOP:
		case WM_TOPPED:			/* Nach oben holen	*/
			wind_set(buffer[3], WF_TOP);
			break;
		case WM_UNTOPPED:
			break;
		case WM_BOTTOM:
			wind_set(buffer[3], WF_BOTTOM);
			break;
		case CH_EXIT:			/* Ende eines gestarteten Programms	*/
			setze_var("ERGEBNIS$", NULL, buffer[4]);	/* Ergebnis setzen!	*/
			end = ausfuehren(NULL, buffer[3]);	
			break;
		case VA_PROGSTART:
			end = ausfuehren(NULL, buffer[7]);
			break;
		case VA_START:
			argv = (unsigned int )buffer[4]; 
			argv |= (unsigned long )buffer[3] << 16;
			if  (argv != 0L) {
				strcpy(p, (char *)argv);	/* kopieren	*/

				d = strpbrk(p, " \t");
				if (d != NULL) {
					*(d++) = '\0';
					strcpy(parameter, d);
				} else *parameter = '\0';
				
				end |= ausfuehren(p, -2);
				c = d;
			}

			break;
		case AV_SENDKEY:
			/*	buffer[3] = evb.shift;	Wird nicht ausgewertet */
			end = message_keyboard(buffer[4]);
			break;
		case WM_ICONIFY:
			if (!flags.grp_icon) {
				wind_set(buffer[3], WF_ICONIFY, buffer[4], buffer[5], buffer[6], buffer[7]);
				akt->fx = buffer[4];
				akt->fy = buffer[5];
				akt->fw = buffer[6];
				akt->fh = buffer[7];
				wind_calc(WC_WORK, NAME, akt->fx, akt->fy, akt->fw, akt->fh, &x, &y, &w, &h);
				akt->i_dx = x - akt->fx;
				akt->i_dy = y - akt->fy;
				akt->ic->ob_x = x;
				akt->ic->ob_y = y;
				akt->ic->ob_width = w;
				akt->ic->ob_height = h;
				akt->ic[1].ob_x = ((w - akt->ic[1].ob_width) / 2);
				akt->ic[1].ob_y = ((h - akt->ic[1].ob_height) / 2);
				akt->ic[1].ob_spec.iconblk->ib_ytext = h - akt->ic[1].ob_y - akt->ic[1].ob_spec.iconblk->ib_htext;
				akt->iconified = TRUE;
			} else {
				akt->iconified = akt->grp_ic = TRUE;
				schliesse_fenster(akt);
			}
			break;
		case WM_UNICONIFY:
			if (buffer[6] <= 0 || buffer[7] <= 0) {	/* Workarround fr MagiC 3.0	*/
				form_center(akt->ob, &x, &y, &w, &h);
				wind_calc(WC_BORDER, akt->art, x, y, w, h, &akt->fx, &akt->fy, &akt->fw, &akt->fh);
			} else {
				akt->fx = buffer[4];
				akt->fy = buffer[5];
				akt->fw = buffer[6];
				akt->fh = buffer[7];
			}
			wind_set(buffer[3], WF_UNICONIFY, akt->fx, akt->fy, akt->fw, akt->fh);
			akt->iconified = FALSE;
			if (akt->all_ic) {
				flags.grp_icon = FALSE;
				akt->ic = flags.ob;
				akt->all_ic = FALSE;
				for (i = 0; i < MAX_FENSTER; i++) {
					if (alle_fenster[i]->grp_ic) {
						alle_fenster[i]->iconified = FALSE;
						oeffne_fenster(alle_fenster[i]);
					}
				}
			}
			break;
		case WM_ALLICONIFY:
			if (!flags.grp_icon) {	/* Noch kein Gruppenicon	*/
				flags.ob = akt->ic;
				akt->ic = gruppen_icon;
				wind_set(buffer[3], WF_ICONIFY, buffer[4], buffer[5], buffer[6], buffer[7]);
				akt->fx = buffer[4];
				akt->fy = buffer[5];
				akt->fw = buffer[6];
				akt->fh = buffer[7];
				wind_calc(WC_WORK, NAME, akt->fx, akt->fy, akt->fw, akt->fh, &x, &y, &w, &h);
				akt->i_dx = x - akt->fx;
				akt->i_dy = y - akt->fy;
				akt->ic->ob_x = x;
				akt->ic->ob_y = y;
				akt->ic->ob_width = w;
				akt->ic->ob_height = h;
				akt->ic[1].ob_x = ((w - akt->ic[1].ob_width) / 2);
				akt->ic[1].ob_y = ((h - akt->ic[1].ob_height) / 2);
				akt->ic[1].ob_spec.iconblk->ib_ytext = h - akt->ic[1].ob_y - akt->ic[1].ob_spec.iconblk->ib_htext;

				akt->iconified = akt->all_ic = TRUE;

				for(i = 0; i < MAX_FENSTER; i++) {
					if (alle_fenster[i]->aktiv && !alle_fenster[i]->iconified) {
						alle_fenster[i]->grp_ic = alle_fenster[i]->iconified = TRUE;
						schliesse_fenster(alle_fenster[i]);
					}
				}
			} else {
				akt->iconified = akt->grp_ic = TRUE;
				schliesse_fenster(akt);
			}
			flags.grp_icon = TRUE;
			break;
		case WM_ARROWED:
			if (buffer[3] == kal.wind_handle) {
				i = j = ((kal_jahr - 70) * 12) + kal_mon;
				switch(buffer[4]) {
					case WA_UPLINE:
						j--;
						break;
					case WA_DNLINE:
						j++;
						break;
					case WA_UPPAGE:
						j -= 12;
						break;
					case WA_DNPAGE:
						j += 12;
						break;
				}
				if (j < 0) j = 0;
				if (j >= 816) j = 815;	/* Kalender von 1970 - 2038	*/
				if (i != j) {
					kal_mon = j % 12;
					kal_jahr = (j / 12) + 70;
					setze_kalender(kal_mon, kal_jahr);
				}
			} else if (buffer[3] == grins.wind_handle) {
				switch(buffer[4]) {
					case WA_UPLINE:
						grins.wert++;
						break;
					case WA_DNLINE:
						grins.wert--;
						break;
					case WA_UPPAGE:
						grins.wert += 5;
						break;
					case WA_DNPAGE:
						grins.wert -= 5;
						break;
				}
				if (grins.wert < 0) grins.wert = 0;
				else if (grins.wert >= flags.akute_infos) grins.wert = flags.akute_infos-1;
				zeige_infobox(grins.wert, TRUE);
			}
			break;
		case WM_VSLID:
			if (buffer[3] == kal.wind_handle) {
				j = (int )(((long )buffer[4] * 815L) / 1000L);
				i = ((kal_jahr - 70) * 12) + kal_mon;
				if (i != j) {
					kal_mon = j % 12;
					kal_jahr = (j / 12) + 70;
					setze_kalender(kal_mon, kal_jahr);
				}
			} else if (buffer[3] == grins.wind_handle) {
				grins.wert = (flags.akute_infos - 1) - (buffer[4] * (flags.akute_infos - 1) / 1000);
				zeige_infobox(grins.wert, TRUE);
			}
			break;
		case AP_TERM:
		case SHUT_COMPLETED:
			wind_update(END_UPDATE);
			return(TRUE);
		case GS_REQUEST:
			flags.gs_aktiv = gs_request(flags.gs_aktiv, gs_info, ap_id, buffer);
			break;
		case GS_COMMAND:
			gs_command(ap_id, buffer);
			break;
		case GS_QUIT:
			flags.gs_aktiv = gs_quit(ap_id);
			break;
		case GS_ACK:
			gs_ack(buffer);
			break;
	}
	wind_update(END_UPDATE);
	return(end);
}

/*----------------------------------------------------------------
!	Berechnet aus zwei Rechtecken das Rechteck, das gezeichnet
!	werden soll und liefert er in erg!
+-----------------------------------------------------------------*/

int	intersect(GRECT *erg, const GRECT *re_1, const GRECT *re_2)

{
	GRECT e;
	if (re_1->g_x + re_1->g_w <= re_2->g_x) return(FALSE);
	if (re_2->g_x + re_2->g_w <= re_1->g_x) return(FALSE);
	if (re_1->g_y + re_1->g_h <= re_2->g_y) return(FALSE);
	if (re_2->g_y + re_2->g_h <= re_1->g_y) return(FALSE);
	e.g_x = MAX(re_1->g_x, re_2->g_x);
	e.g_y = MAX(re_1->g_y, re_2->g_y);
	e.g_w = MIN(re_1->g_x + re_1->g_w, re_2->g_x + re_2->g_w) - e.g_x;
	e.g_h = MIN(re_1->g_y + re_1->g_h, re_2->g_y + re_2->g_h) - e.g_y;
	memcpy(erg, &e, sizeof(GRECT));
	return(TRUE);
}

/*-----------------------------------------------------------------------
!	Bearbeitet die TIMER.EVT-Datei.
!	-> ereignis		String sollte 256 Zeichen haben 
!	<- time_t		Sekunden seit 1970 wenn nchstes Ereignis stattfindet
!	<- ereignis		String zu dem Ereignis
+----------------------------------------------------------------------*/

time_t lade_n_ereignis(char *ereignis)

{
	char *c;
	FILE *fd;
	struct stat stbuf;
	time_t sekunden;
	struct tm zeit;
	
	strcpy(f1, file_path);
	strcat(f1, "\\TIMER.EVT");
	
	if (stat(f1, &stbuf) != 0) return(0);			/* Datei vorhanden?	*/
	strnset(ereignis, '9', 14);						/* maxwert setzen	*/
	ereignis[14] = '\0';

	fd = fopen(f1, "r");							/* Zum lesen ffnen	*/
	while(fgets(dummy, 250, fd) != NULL) {			/* noch nicht am Ende ?	*/
		if ((strlen(dummy) < 15) || (dummy[14] == '#')) continue;		/* Nur Leerzeile ??	oder schon erledigt */

		if (strncmp(ereignis, dummy, 14) > 0) {		/* Gelesenes Ereignis frher?	*/
			strcpy(ereignis, dummy);				/* ja, dann merken	*/
		}
	}												/* jngstes Ereignis merken!	*/
	fclose(fd);
	
	if (strlen(ereignis) < 15) return(0);
	
	zeit.tm_sec = antoi(&ereignis[12], 2);					/* Umwandlung in tm-Format	*/
	zeit.tm_min = antoi(&ereignis[10], 2);
	zeit.tm_hour = antoi(&ereignis[8], 2);

	zeit.tm_mday = antoi(&ereignis[6], 2);
	zeit.tm_mon = antoi(&ereignis[4], 2) - 1;			/* Monat geht von 0 - 11	*/
	zeit.tm_year = antoi(ereignis, 4) - 1900;			/* Basis ist 1900	*/
	
	sekunden = mktime(&zeit);					/* Sekunden ausrechnen	*/

	strftime(dummy, 19, "%H%M%S%d%m%Y", localtime(&sekunden));
	dummy[19]='\0';
	setze_ob(haupt.ob, ZEIT, dummy);
	strcpy(dummy, ereignis);

	strtok(dummy, " \t\n");
	c = strtok(NULL, " \t\n");
	setze_ob(haupt.ob, ART, c);
	c = strtok(NULL, " \t\n");
	c = strtok(NULL, " \t\n");
	if (c != NULL) setze_ob(haupt.ob, EREIGNIS_NAME, c);
	
	return(sekunden);
}

/*---------------------------------------------------------------------------------------------------
!	Berechnet das bergebene Timerereignis so, da es nach der bergebenen "Zeit" liegt.
!	Der bergebene String "ereignis" wird so verndert, da das neue Datum eingetragen ist.
!
!	-> time_t zeit		aktuelle Zeit bzw. Zielzeit. Das zurckgelieferte Ereignis liegt garantiert
!						_nach_ der bergebenen Zeit. Ausnahme: fr das Ereignis ist "nachholen"
!						eingeschaltet, dann wird lediglich um eine Zeiteinheit weitergeschaltet!
!	-> char *ereignis	aktueller String im Format der TIMER.EVT, der das Ereignis angibt, das
!						verndert werden mu
!	<- int				Rckgabe TRUE  -> Ereignis mu ausgefhrt werden!
!						Rckgabe FALSE -> Ereignis noch /nicht mehr auszufhren
+--------------------------------------------------------------------------------------------------*/

int naechster_timer(time_t zeit, char *ereignis)

{
	char *time_pos, *c, *a;
	char wiederholung[3];
	int multipl = 1, nachholen = FALSE, i, j, erg = FALSE;
	struct tm *tim, ti;
	time_t t, z, sek_start, sek_ende, aktuell;

	for (time_pos = ereignis; *time_pos != '\0' && isspace(*time_pos); time_pos++);	/* Start suchen!	*/

	ti.tm_year = antoi(time_pos, 4) - 1900;		/* Basis fr's Jahr ist 1900	*/
	ti.tm_mon  = antoi(&time_pos[4], 2) - 1;	/* Monat geht von 0 - 11		*/
	ti.tm_mday = antoi(&time_pos[6], 2);		/* Tage							*/

	ti.tm_hour = antoi(&time_pos[8], 2);		/* Stunden						*/
	ti.tm_min  = antoi(&time_pos[10], 2);		/* Minuten						*/
	ti.tm_sec  = antoi(&time_pos[12], 2);		/* Sekunden						*/

	sek_start = mktime(&ti);					/* Gesamt-Sekunden ausrechnen	*/
	aktuell = time(NULL);						/* aktuelle Zeit setzen	*/

	if (zeit > 0 && sek_start > zeit) return(erg);		/* Ereignis darf noch nicht stattfinden!	*/

	c = &time_pos[14];
	if (*c == '#') return(erg);					/* Ereignis wird nicht mehr ausgefhrt!		*/
	
	if (*c == '-') {					/* Gltigkeitskennzeichen gesetzt!	*/
		for (i = 0, a = ++c; *c != '\0' && isdigit(*c); c++, i++);
		i = antoi(a, i);
		if (i < 0) i = 60;
		sek_ende = sek_start + ((long )i * 3600L);
		if ((aktuell <= sek_ende) && (aktuell >= sek_start)) erg = TRUE;	/* Aktion ausfhren!	*/
	} else sek_ende = sek_start;
	
	for (; *c != '\0' && isspace(*c); c++);	/* Leerzeichen berbrcken!	*/
	if (isdigit(*c)) {						/* Mit Multiplikator		*/
		for (i = 0, a = c; *c != '\0' && isdigit(*c); c++, i++);
		multipl = antoi(a, i);
		if (multipl < 1) multipl = 1;
	}
	for (i = 0; i < 2; wiederholung[i++] = *(c++));	/* Wiederholung setzen	*/
	wiederholung[2] = '\0';
	if (*c == '!') {
		nachholen = TRUE;
		c++;
	}

	if (zeit > 0) zeit -= (sek_ende - sek_start);	/* Zeitspanne beachten!	*/

	if (strcmp(wiederholung, "MI") == 0) {				/* mintlich	*/
		z = 60 * (long )multipl;
		do sek_start += z;
		while (!nachholen && sek_start < zeit);
	} else if (strcmp(wiederholung, "ST") == 0) {	/* stndlich		*/
		z = 3600 * (long )multipl;
		do sek_start += z;
		while (!nachholen && sek_start < zeit);
	} else if (strcmp(wiederholung, "WO") == 0) {	/* wchentlich		*/
		z = 604800L * (long )multipl;
		do sek_start += z;
		while (!nachholen && sek_start < zeit);
	} else if (strcmp(wiederholung, "MO") == 0) {	/* monatlich		*/
		do {
			ti.tm_mon += multipl;
			for ( ; ti.tm_mon >= 12; ti.tm_mon -= 12, ti.tm_year++);
			sek_start = mktime(&ti);
		} while (!nachholen && sek_start < zeit);
	} else if (strcmp(wiederholung, "JA") == 0) {	/* jhrlich			*/
		do {
			ti.tm_year += multipl;
			sek_start = mktime(&ti);
		} while (!nachholen && sek_start < zeit);
	} else if (strcmp(wiederholung, "WT") == 0) {	/* MO - FR			*/
		i = multipl;
		do {
			while (--multipl >= 0) {
				do {
					tim = localtime(&sek_start);
					j = 8 - tim->tm_wday;			/* Wann fngt der nchste Werktag an?	*/
					if (j >= 4) j = 1;				/* Normalerweise nur einen Tag weiter	*/
					t = sek_start + (86400L * j);	/* Da feiertag nur feiertage liefert mu der normale Tab berechnet werden	*/
				
					feiertag(sek_start, &sek_start);
				} while (sek_start <= t);			/* Nchster Werktag ist Feiertag!	*/
				
				sek_start = t;						/* Nchsten Werktag gefunden	*/
			}
			multipl = i;
		} while ((!nachholen) && (sek_start < zeit));

	} else if (strcmp(wiederholung, "FT") == 0) {	/* SA, SO			*/
		i = multipl;
		do {
			while (--multipl >= 0) {
				tim = localtime(&sek_start);
				j = 6 - tim->tm_wday;			/* Wieviel Tage bis zum Samstag ?	*/
				if (j == 0) j = 1;				/* Am Samstag mssen wir bis Sonntag	*/
				t = sek_start + (86400L * j);	/* Da feiertag nur feiertage liefert merken wir uns, wann Wochenende wre	*/

				feiertag(sek_start, &sek_start);/* Wann ist denn nun der Feiertag?	*/
				sek_start = t < sek_start ? t : sek_start;	/* das wa eher da ist zhlt!	*/
			}
			multipl = i;
		} while ((!nachholen) && (sek_start < zeit));
	} else if (strcmp(wiederholung, "MT") == 0) {	/* Monatlich nach Tagen!	*/
		/* *c zeigt auf den folgenden String der Wiederholung!	*/
		i = c[1] -'0';		/* Welchen Tag festlegen! 1=Montag, 7=Sonntag  (intern wird 7 in 0 gewandelt) */
		if (i == 7) i = 0;
		tim = localtime(&sek_start);
		do {
			tim->tm_mon += multipl;
			for ( ; tim->tm_mon >= 12; tim->tm_mon -= 12, tim->tm_year++);
			if (*c != 'L') {		/* es geht um den x. Tag	*/
				tim->tm_mday = 1;			/* Vom ersten an!	*/
				z = mktime(tim);
				tim = localtime(&z);

				j = (i - tim->tm_wday);		/* 1. gewnschten Tag berechnen	*/
				if (j <= 0) j += 7;
				j += (*c - '1') * 7;		/* ab 2.xtag mssen 7 Tage addiert werden	*/
			} else {						/* letzter Tag berechnen!	*/
				tim->tm_mday = 1;			/* Vom ersten des nchsten Monats an!	*/
				if (++tim->tm_mon >= 12) {
					tim->tm_mon=0;
					tim->tm_year++;
				}
				z = mktime(tim) - 86400L;	/* letzter Tag!	*/
				tim = localtime(&z);
				if ((j = i - tim->tm_wday) >= 1) j -= 7;
			}
			sek_start = z + (j * 86400L);
		} while (!nachholen && sek_start < zeit);

	} else if (strcmp(wiederholung, "EI") == 0) {	/* Einmalig			*/
		time_pos[14] = '#';							/* an Position 14 ein # bedeutet, da das Ereignis nie mehr aktiviert wird!	*/
		
	} else {	/* Bleiben nur noch die Tage brig, oder unbekannte Zeiten	*/
		z = 86400L * (long )multipl;
		do sek_start += z;
		while (!nachholen && sek_start < zeit);
	}
	
	strftime(dummy, 15, "%Y%m%d%H%M%S", localtime(&sek_start));
	strncpy(time_pos, dummy, 14);
	
	if (nachholen) erg = TRUE;		/* beim nachholen, mu er immer ausfhren!	*/
	
	return(erg);
}

/*--------------------------------------------------------------------------------------------
!	Wandelt einen ASCII-String, der nicht durch ein 0-Byte beendet wird in einen int-Wert um
!	Nur fr positive Werte! ein - wird nicht beachtet!
!
!	->	char *string	Adresse des Strings, der umgewandelt werden soll
!	->	int  anz		Anzahl der Zeiche, die umgewandelt werden sollen!
!	<-	int  erg		Int-Wert, der errechnet wurde
+-------------------------------------------------------------------------------------------*/

int antoi(char *string, int anz)

{
	char *c;
	int erg=0;
	int multi=1;
	
	for (c = &string[anz -1]; c >= string && *c != '\0' && isdigit(*c); c--) {
		erg += (*c - '0') * multi;
		multi *= 10;
	}
	return(erg);
}

/*-----------------------------------------------------------------------
!	Bearbeitet das Ereignis und setzt in der TIMER.EVT das neuste Datum
+----------------------------------------------------------------------*/

int ereignis_bearbeiten(time_t zeit, char *ereignis)

{
	char *ablauf;
	int start;
	FILE *fd_r, *fd_w;
	char *c, *e;
	char ke[20], kk[20];

	start = naechster_timer(zeit, ereignis);			/* Testen, ob Ereignis stattfinden soll	*/

	for (c = ereignis; *c != '\0' && isspace(*c); c++);	/* fhrende Blanks entfernen	*/
	for (; *c != '\0' && !isspace(*c); c++);			/* Uhrzeit lesen	*/
	for (; *c != '\0' && isspace(*c); c++);				/* Blanks berlesen	*/
	for (; *c != '\0' && !isspace(*c); c++);			/* Wiederholung lesen	*/
	for (; *c != '\0' && isspace(*c); c++);				/* Blanks berlesen	*/
	for (e = ke; *c != '\0' && !isspace(*c) && (e-ke)<sizeof(ke); *e++ = *c++);/* Kennung bernehmen	*/
	*e = '\0';
	for (; *c != '\0' && isspace(*c); c++);				/* Blanks berlesen	*/
	ablauf = c;											/* Danach folgt die Aktion	*/
		
	sprintf(f1, "%s\\TIMER.EVT", file_path);
	sprintf(f2, "%s\\TIMER.BAK", file_path);
	
	fd_r = fopen(f1, "r");					/* Zum lesen ffnen	*/
	fd_w = fopen(f2, "w");					/* Zum schreiben ffnen	*/
		
	if (fd_w != NULL && fd_r != NULL) {
		while(fgets(dummy, 255, fd_r) != NULL) {			/* noch nicht am Ende ?	*/
			for (c = dummy; *c != '\0' && isspace(*c); c++);	/* fhrende Blanks entfernen	*/
			for (; *c != '\0' && !isspace(*c); c++);			/* Uhrzeit lesen	*/
			for (; *c != '\0' && isspace(*c); c++);				/* Blanks berlesen	*/
			for (; *c != '\0' && !isspace(*c); c++);			/* Wiederholung lesen	*/
			for (; *c != '\0' && isspace(*c); c++);				/* Blanks berlesen	*/
			for (e = kk; *c != '\0' && !isspace(*c) && (e-kk)<sizeof(kk); *e++ = *c++);/* Kennung bernehmen	*/
			*e = '\0';
			if (strcmp(ke, kk) == 0) {
				fputs(ereignis, fd_w);
			} else {
				fputs(dummy, fd_w);
			}
		}
	}
	if (fd_w != NULL) fclose(fd_w);
	if (fd_r != NULL) fclose(fd_r);

	Fdelete(f1);
	Frename(0, f2, f1);

	if (start) {
		for (c = ablauf; *c != '\0' && !isspace(*c); c++);					/* Ende suchen	*/
		*c = '\0';
		
		return(ausfuehren(ablauf, -1));	/* Ausfhrung noch gltig!	*/
	} else return(FALSE);
}

/*-----------------------------------------------------------------------
!	Berechnet den nchsten Feiertag
!	ausgehend von der sekundenzahl.
!	Liefert als f_erg einen Zeiger
+----------------------------------------------------------------------*/

FEIERTAG *feiertag(time_t start, time_t *ergebnis)

{
	FEIERTAG *f_idx, *f_beweg, *f_erg = NULL;

	struct tm *ti, tim;
	int jahr, flag = FALSE;
	time_t zeit, dummy;
	
	ti = localtime(&start);
	memcpy(&tim, ti, sizeof(struct tm));
	jahr = tim.tm_year;
	zeit = 0x7FFFFFFFL;
	
	f_idx = f_tag;
	if (f_idx == NULL) return(0);	/* Keine Feiertage	*/
	while (f_idx->tag > 0) {
		if (f_idx->art == BEWEGLICH) tim.tm_year = f_idx->jahr - 1900;
		else if (f_idx->art == JAEHRLICH) tim.tm_year = jahr;
		else if (!flag) {
			flag = TRUE;
			f_beweg = f_idx;
			if (f_idx->jahr != jahr + 1901) setze_feiertag(flags.bundesland, jahr + 1901, f_idx);
			tim.tm_year = jahr + 1;
		}
		tim.tm_mon = f_idx->monat;
		tim.tm_mday = f_idx->tag;

		dummy = mktime(&tim);
		if ((f_idx->art == JAEHRLICH) && (dummy < start)) {	/* Datum bereits im Jahr vorbei	*/
			tim.tm_year++;
			dummy = mktime(&tim);
		}
		if ((dummy < zeit) && (dummy > start)) {
			zeit = dummy;
			f_erg = f_idx;
		}
		f_idx++;
		if ((f_idx->tag <= 0) && (f_beweg->jahr != jahr + 1900)) {
			setze_feiertag(flags.bundesland, jahr + 1900, f_beweg);
			f_idx = f_beweg;
			tim.tm_year = jahr;
		}
	}
	*ergebnis = zeit;
	return(f_erg);
}

/*-----------------------------------------------------------------------
!	Fhrt das Ereignis "ereignis" aus
!	ist eine app_nr angegeben, so wird das entsprechende File
!	fortgefhrt!
!	-1 als app_nr fhrt die AKTION.DAT aus
!	-2 als app_nr fhrt die Datei "ereignis" aus!
!	Als Ergebnis = TRUE, dann wird Programm beendet!
+----------------------------------------------------------------------*/

int ausfuehren(char *ereignis, int app_nr)

{
	char text[256];
	char file[180];
	char *line, *c;
	int erg = -1, i;
	FILE *fd, *fd_w = NULL;
	struct stat st_buf;
	struct ffblk ffb;
	
	if (ereignis != NULL) strcpy(ereignis_nam, ereignis);
	if (app_nr < 0) {
		++flags.aktion;
		if (app_nr == -1) {
			sprintf(file, "%s\\aktion.dat", file_path);
			proto(" Aktionsstart", ereignis);
		} else if (app_nr == -2) {
			strcpy(file, ereignis);
			proto("   Dateistart", ereignis);
		}
	} else {
		sprintf(file, "%s\\akt_%x.dat", file_path, app_nr);
		if (stat(file, &st_buf) != 0) return(FALSE);		/* Programm wurde mit EXEC ausgefhrt!	*/

		sprintf(dummy, "Applikation Nr.: %i", app_nr);
		proto("A.fortsetzung", dummy);
		*ereignis_nam = '\0';							/* Ereignisname lschen, damit set_file_aktion diesen neu setzen kann	*/
	}

	fd = fopen(file, "r");

	if (fd != NULL) {
		if (app_nr != -2) set_file_aktion(fd, ereignis_nam);	/* wenn Batchdatei, dann nicht von Anfang an!	*/

		while ((fgets(text, 254, fd) != NULL) && (erg != -2) && (erg != -7)) {	/* Solange Datei vorhanden, oder QUIT gefunden wurde oder abbruch	*/
			for (c = text; *c != '\0' && isspace(*c); c++);	/* Leerzeichen entfernen	*/
			if (*c == '[') break;	/* Neues Ereignis!	*/
			
			if (*c == ';') continue;	/* Kommentar!	*/
			if ((line = strtok(text, "\n")) == NULL) continue;		/* Leerzeile	*/
			if ((erg = aktion(line, FALSE)) >= 0) { /* liefert app_id, wenn gewartet werden muss	*/
				sichern_aktiv(fd, ereignis_nam, erg, line);
				break;	/* While-Schleife beenden!	*/
			} else {
				if ((erg == -4) || (erg == -6)) {	/* Bedingung falsch! ELSE oder ENDIF der gleichen Ebene suchen und Rest berspringen */
					i = flags.if_ebene;
					while (fgets(text, 254, fd) != NULL) {
						for (c = text; *c != '\0' && isspace(*c); c++);	/* Leerzeichen entfernen	*/
						if (*c == '[') break;	/* Neues Ereignis!	*/
						
						line = strtok(text, " \t\n");
						if (line == NULL) continue;
							
						if (stricmp(line, "IF") == 0) i++;	/* Eine Ebene hher verschachtelt	*/
						else if ((stricmp(line, "ELSE") == 0) && (i <= flags.if_ebene)) break;	/* Kommandos ausfhren	*/
						else if ((stricmp(line, "ENDIF") == 0) && (i-- <= flags.if_ebene)) break;
					}
				} else if (erg == -8) {							/* GOTO angefordert!	*/
					fclose(fd);								/* Datei schlieen	*/

					if (app_nr >= 0) {
						Fdelete(file);							/* Datei lschen	*/
						app_nr = -1;					/* So tun, als ob kein Zweitaufruf	*/
					}

					fd = fopen(ereignis_nam, "r");	/* GOTO - Datei ffnen	*/
					if (fd == NULL)	{			/* Datei nicht vorhanden!	*/
						sprintf(file, "%s\\aktion.dat", file_path);	/* aktion.dat verwenden	*/
						fd = fopen(file, "r");
					} else app_nr = -2;				/* Kein Ereignisname vorhanden	*/
					if (fd == NULL) return(FALSE);	/* Probleme aufgetreten	*/
					if (app_nr != -2) set_file_aktion(fd, ereignis_nam);		/* Und nach Aktion suchen	*/

				}
			}
		} 
		fclose(fd);
		if (fd_w != NULL) fclose(fd_w);
	}
	if (erg < 0) --flags.aktion;	/* Aktion wurde erfolgreich beendet!	*/
	if (app_nr >= 0) Fdelete(file);

	if (erg >= 0) {	/* AKT*.TMP in AKT*.DAT umbenennen	*/
		sprintf(f1, "%s\\akt_%x.tmp", file_path, erg);
		sprintf(f2, "%s\\akt_%x.dat", file_path, erg);
		Fdelete(f2);
		Frename(0, f1, f2);
	}
	
	if ((erg == -2) || (strcmp(ereignis_nam, "_Programmende") == 0)) {
		strcpy(f1, file_path);
		strcat(f1, "\\akt_*.dat");
		if (findfirst(f1, &ffb, 0) == 0) {
			if (form_alert(1, msg[MSG_PROZESSAKT].ob_spec.free_string) == 1) {
				del_temp();
			} else return(FALSE);
		}
		return(TRUE);
	}
	else return(FALSE);
}

/*------------------------------------------------------------------------------------
!	Lscht die AKT_*-Dateien und die WAITFOR.DAT
+---------------------------------------------------------------------------------*/

void del_temp(void)

{
	long l;
	struct ffblk ffb;
	
	strcpy(dummy, file_path);
	l = strlen(dummy);
	strcpy(&dummy[l], "\\waitfor.dat");
	Fdelete(dummy);
	strcpy(&dummy[l], "\\akt_*.dat");
	l++;
	if (findfirst(dummy, &ffb, 0) == 0) {
		do {
			strcpy(&dummy[l], ffb.ff_name);
			if (unlink(dummy) != 0) fehler(ERR_FDELETE, dummy);
		} while (findnext(&ffb) == 0);
	}
}

/*-------------------------------------------------------------------------------------
!	Sucht die aktion im File fd
+-----------------------------------------------------------------------------------*/

void set_file_aktion(FILE *fd, char *aktion)

{
	char *c, *e;

	while (fgets(dummy, 254, fd) != NULL) {				/* Ereignis suchen	*/
		for (c = dummy; *c != '\0' && isspace(*c); c++);	/* Leerzeichen entfernen	*/
		if (*c != '[') continue;						/* Beginn einer Aktion suchen	*/
		for (e = ++c; *e != '\0' && *e != ']'; e++)		/* Ende suchen	*/
			 if (*e == ' ') *e = '_';					/* Ereignis mit Leerzeichen wird zu Ereignis mit '_'	*/
		*e = '\0';

		if (*aktion == '\0') strcpy(ereignis_nam, c);	/* Wenn ein forfhrungsereignis, dann erst namen feststellen	*/
		if (strcmp(c, aktion) == 0) break;				/* Ereignis gefunden	*/
	}
}

/*--------------------------------------------------------------------------------------
!	Speichert die Datei akt_<nr>.tmp in der nur ein Ereignis aber mit allen
!	IF-ELSE-ENDIF-Bedingungen vorhanden ist.
!	in Kommando steht das Kommando der Zeile
--------------------------------------------------------------------------------------*/

void sichern_aktiv(FILE *fd_r, char *ereignis, int app_nr, char *kommando)

{
	FILE *fd_w;
	char temp[180];
	char *c, *a;
	VARIABLE *va = NULL;
	int tiefe = 0, e_zweig = FALSE;
	
	if (kommando != NULL) {	/* Test auf Variable!	*/
		for (a = kommando; isspace(*a); a++);
		for (c = a; !isspace(*c) && *c != '='; c++);
		*temp = '\0';
		strncat(temp, a, c - a);
		va = teste_var(temp);
	}
	
	sprintf(temp, "%s\\akt_%x.tmp", file_path, app_nr);
	fd_w = fopen(temp, "w");
	if (fd_w != NULL) {
		if (ereignis != NULL) fprintf(fd_w, "[%s]\n", ereignis);
		if (va != NULL) fprintf(fd_w, "SET %s ERGEBNIS$\n", va->name);
		while (fgets(temp, 179, fd_r) != NULL) {
			strcpy(dummy, temp);
			c = strtok(dummy, " \t\n");
			if (c == NULL) continue;	/* Leerzeile	*/
			if (*c == '[') break;		/* Ende der Aktion erreicht!	*/
			if (stricmp("ENDIF", c) == 0 && tiefe-- <= 0) {
				tiefe = 0;
				e_zweig = FALSE;
				continue;
			}
			else if (stricmp("ELSE", c) == 0 && tiefe <= 0) e_zweig = TRUE;
			else if (stricmp("IF", c) == 0) tiefe++;

			if (!e_zweig) fprintf(fd_w, "%s", temp);
		}
		fclose(fd_w);
	}
}

/*-----------------------------------------------------------------------
!	Topped eine Applikation anhand des Fensters. Unter MagiC anhand der
!	Spezialnachricht
!	gibt TRUE zurck, wenn erfolgreich
+---------------------------------------------------------------------*/

int top_app(char *appl)

{
	char programm[10]="", name[12];
	int erg = FALSE, i, ap_sid, handle, owner, next;
	int buffer[8];
	
	if (appl == NULL) return(FALSE);
	
	if (flags.appl_search) {
		strncat(programm, appl, 8);

		i = (int )strlen(programm);
		if (i < 8) for (;i < 8; programm[i++]=' ');
		programm[8] = '\0';

		appl_search(APS_FIRST, name, &i, &ap_sid);
		do {
			if (strcmp(programm, name) == 0) {
				my_wind_get(0, WF_TOP, &handle, &owner, &next, &i);
				if (owner != ap_sid) {	/* Nur wenn nicht eh schon ganz oben!	*/
					if (flags.magix) {
						buffer[0] = SM_M_SPECIAL;
						buffer[1] = ap_id;
						buffer[2] = 0;
						buffer[3] = 0;
						buffer[4] = SMC_MAGIC1;
						buffer[5] = SMC_MAGIC2;
						buffer[6] = SMC_SWITCH;
						buffer[7] = ap_sid;
						appl_write(1, 16, buffer);	/* An den SCRNMGR senden	*/
						erg = TRUE;
					}
					do {
						if (owner == ap_sid) {
							wind_set(handle, WF_TOP);
							erg = TRUE;
							break;
						}
						handle = next;
						my_wind_get(handle, WF_OWNER, &owner, &i, &i, &next);
					} while (next >= 0);

				} else erg = TRUE;	/* oberstes Fenster gehrt schon der Appl.	*/
			}
		} while (appl_search(APS_NEXT, name, &i, &ap_sid));
	}
	return(erg);
}

/*--------------------------------------------------------------------------
!	Sendet den String an das AES
!	Sonderbehandlung: <...|...>
+-----------------------------------------------------------------------*/

int send_key(char *programm, char *string)
{
	KEYTAB *keytbl;
	int buffer[16];
	int i, cntrl, special, ap_sid;
	char *c, *d, *e;
	struct evtbuf {
		long ap_event;
		unsigned char	scan;
		unsigned char	ascii;
		int 			shift;
	} evb;
	
	if (string == NULL) return(FALSE);
	
	keytbl = Keytbl((char *)-1,(char *) -1,(char *) -1);
	if (programm != NULL) {
		aktiv(programm, &ap_sid);
		if (ap_sid < 0) return(ap_sid);
	}
	
	for (c = string; *c != '\0'; c++) {
		evb.shift = 0x0000;
		evb.ap_event = 3L;				/* EVNT_KEYBD	*/
		evb.ascii = *c;
		evb.scan = 0x00;
	
		if (*c == '<') {	/* Flucht-Zeichen	*/
			if ((e = strchr(++c, '>')) != NULL) {	/* Ende der Fluchtsequenz finden	*/
				*e = '\0';
				strupr(c);
				
				d = strchr(c, '|');
				if (d != NULL) {	/* Shift,cntrl oder alt enthalten! 	*/
					c = &d[1];
					special = (e - d) > 2 ? TRUE : FALSE;			/* Sondertasten haben mehr wie ein Zeichen!	*/
					while (*(d--) != '<') {
						switch(*d) {
							case 'S':								/* allgemeiner Shift	*/
							case 'L': evb.shift |= 0x0001; break;	/* linker Shift	*/
							case 'R': evb.shift |= 0x0002; break;	/* rechter Shift	*/
							case 'C': evb.shift |= 0x0004; break;	/* Control	*/
							case 'A': evb.shift |= 0x0008; break;	/* Alternate	*/
						}
					}
				}
				
				if (special) {
					evb.ascii = '\0';		/* Ist der Standardwert bei Sondertasten	*/
					switch(*(c++)) {
		                case 'R': evb.ascii='\r';   evb.scan=0x1C;  break; 
       			        case 'E': if (*c == 'S') { evb.ascii=0x1B; evb.scan=0x01; }	/* ESC	*/
       		    	    		  else { evb.ascii='\r';   evb.scan=0x72; }			/* Enter */
       		        			  break;
	               		case 'T': evb.ascii='\t';   evb.scan=0x0F;  break; 
		                case 'B': evb.ascii='\b';   evb.scan=0x0E;  break; 
       			        case 'D': evb.ascii=0x7F;   evb.scan=0x53;  break; 
            	   		case 'H': 					evb.scan=0x62;  break; 
	            	    case 'U': 					evb.scan=0x61;  break; 
       		        	case 'I': 					evb.scan=0x52;  break; 
	               		case 'C': switch(*c) {
    	           					case 'H':	evb.scan=0x47; break;	/* clrhome */
        	       					case 'U':	evb.scan=0x48; break;	/* cusur up */
	               					case 'D':	evb.scan=0x50; break; /* c down */
    	           					case 'L':	evb.scan=0x4B; break; /* c left */
        	       					case 'R':	evb.scan=0x4D; break; /* c right */
            	   				  }
               					  break; 
						case 'F': if (*c == '0') evb.scan=0x44;	/* F-Tasten	*/
								  else evb.scan=0x3A - '0' + *c;
								  break;
 					}
				} else {
					evb.ascii = *c;

		            for (i = 0; i < 128; i++) { /* Scancode setzen	*/
        		        if ((keytbl->unshift[i] == *c) || (keytbl->shift[i] == *c)) { 
                		    evb.scan = i; 
		                    break; 
        		        } 
        		    }    

 					if (evb.shift & 0x0004) evb.ascii &= 0x1F; 	/* Control im ASCII-Code vermerken	*/
 					if (evb.shift & 0x0008) evb.ascii =  0x00; 	/* ALT-Taste fhrt zu ASCII=0	*/
				}
			}
			c = e;	/* Durch Schleife wird um 1 erhht!	*/
		} else {	/* Normale Buchstaben	*/
            for (i = 0; i < 128; i++) { /* Scancode setzen	*/
  		        if ((keytbl->unshift[i] == *c) || (keytbl->shift[i] == *c)) { 
           		    evb.scan = i; 
                    break; 
   		        } 
   		    }    
		}

 
		if (programm == NULL) {		/*	PLAY KEY	*/
			cntrl=(int )Kbshift(-1);
			Kbshift(evb.shift);
			evnt_timer(flags.key_delay/2, 0);	/* halben Delay warten	*/
			appl_tplay(&evb, 1, 100);
			evnt_timer(flags.key_delay/2, 0);	/* halben Delay warten	*/
			Kbshift(cntrl);
		} else {
			buffer[0] = AV_SENDKEY;
			buffer[1] = ap_id;
			buffer[2] = buffer[5] = buffer[6] = buffer[7] = 0;

			buffer[3] = evb.shift;
			buffer[4] = evb.ascii + (evb.scan << 8);

			evnt_timer(flags.key_delay, 0);	/* Delay warten	*/
			appl_write(ap_sid, 16, buffer);	
		}
	}
	return(TRUE);
}

/*----------------------------------------------------------------------
!	Bearbeitet eine Zeile aus der aktion.dat
!	Gibt -1 zurck, wenn ok, die app_id, wenn auf beendigung gewartet
!	werden muss und -2, wenn ENDE angewhlt!
!	-3, wenn IF Bedingung Wahr ist (alle Kommandos bis ELSE oder ENDIF ausfhren
!	-4, wenn IF Bedingung Falsch (alle Kommandos nach ELSE bis ENDIF ausfhren
!	-5, wenn ENDIF erreicht
!	-6, wenn ELSE erreicht
!	-7, wenn Ereignis abgebrochen werden mu
!	-8, wenn GOTO verwendet
!	wenn script=TRUE, dann aufruf durch GEMSCRIPT
+---------------------------------------------------------------------*/

int aktion(const char *zeile_org, int script)

{
	char *cmd,  *p1, *p2, *c, *va = NULL, *zeile, *e[];
	char param[160], param2[20];
	long l;
	int parallel = FALSE, prog = FALSE, va_start_flag = FALSE, ret = -1, i, j, graf;
	int anz, buffer[16];
	struct tm *tm;
	struct ffblk ffb;
	time_t zeit;
	FENSTER *fenster[10], *f;
	VARIABLE *v;
	SS *ss;
	FILE *fd;

	zeile = strdup(zeile_org);	/* Kopiere damit nix durchanander kommt!	*/
	
	proto(" Befehlszeile", zeile);

	c = strchr(zeile, '=');	/* Evtl. Variable vorhanden ?	*/
	cmd = strtok(zeile, "= \t\n");
	
	/*--------- Testen ob das vermeintliche Commando nur ne Variable ist! -------------*/
	
	if (c != NULL && (teste_var(cmd) != NULL)) {
		for(c-- ;*c != '\0' && c > zeile && isspace(*c); c--);	/* ist das "=" auch als Gleichheitszeichen zu interpretieren? */
		if (*c == '\0' || c <= zeile) {
			va = cmd;
			cmd = strtok(NULL, "= \t\n");
		}
	}
	if (cmd == NULL) {
		free(zeile);
		return(-1);
	}
	
	cmd = setze_text(cmd, dummy, 1023);	/* Kommando selber evtl. als variable ?	*/

	proto("   Ausfhrung", cmd);
	
	if (stricmp(cmd, "EXEC") == 0) {
		prog = parallel = TRUE;
	} else if (stricmp(cmd, "RUN") == 0) {
		prog = TRUE;
	} else if ((stricmp(cmd, "VA-START") == 0) || (stricmp(cmd, "VA_START") == 0)) {	/* RUN bei VA-START nicht mglich!	*/
		va_start_flag = prog = TRUE;
	} else if (stricmp(cmd, "PATH") == 0) {
		p2 = p1 = setze_text(strtok(NULL, " \t"), dummy, 1023);
		if (p1 != NULL) {
			if (p1[1] == ':') {
				*p1 = toupper(*p1) - 'A';
				Dsetdrv(*p1);
				if (Dgetdrv() != *p1) {
					setze_var(va, NULL, -46);	/* Invalid drive Specifikation	*/
					free(zeile);
					return(ret);
				}
				p2 = p1 + 2;
			}
			i = Dsetpath(p2);
		} else i = -1;
		if (i == 0) setze_var(va, "TRUE", i);
		else setze_var(va, NULL, i);
	} else if (stricmp(cmd, "GETENV") == 0) {
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		p2 = NULL;
		if (p1 != NULL) p2 = getenv(p1);
		if (p2 != NULL) setze_var(va, p2, 0);
		else setze_var(va, "", -1);
	} else if (stricmp(cmd, "GOTO") == 0) {
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p1 != NULL) {
			strcpy(ereignis_nam, p1);
			ret = -8;
			setze_var(va, "TRUE", 0);
		} else setze_var(va, NULL, -1);
	} else if (stricmp(cmd, "EXIST") == 0) {
		fd = NULL;
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p1 != NULL) fd = fopen(p1, "rb");
		if (fd != NULL) {
			setze_var(va, NULL, 0);	/* -> Datei gefunden	*/
			fclose(fd);
		} else setze_var(va, NULL, -33);	/* -> Datei nicht gefunden	*/
	} else if (stricmp(cmd, "COOKIE") == 0) {
		fd = NULL;
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p1 != NULL) {
			p1[4] = '\0';	/* Maximal 4 Zeichen!	*/
			for (i = (int )strlen(p1); i < 4; p1[i++]=' ');
			p1[i] = '\0';
			if (test_cookie(p1, NULL)) {
				setze_var(va, NULL, 0);
			} else setze_var(va, NULL, -1);
		} else setze_var(va, NULL, -1);
	} else if (stricmp(cmd, "SOMMERZEIT") == 0) {
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p1 != NULL) {
			switch(*p1) {
				case 'E': Tsettime(Tgettime() + (1 << 11));	/* Bit 11 gibt die Stunden an	*/
						  break;	
				case 'A': Tsettime(Tgettime() - (1 << 11));	/* Bit 11 gibt die Stunden an	*/
						  break;	
			}
		}
		l = Tgettime();
		setze_var(va, NULL, ((l & 0x001F) * 2) + (((l >> 5) & 0x003F) * 60) + ((l >> 11) * 3600));
	} else if ((stricmp(cmd, "PLAY-KEY") == 0) || (stricmp(cmd, "PLAY_KEY") == 0)) {
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		i = send_key(NULL, p1);	/* NULL als Programm Wird zu Play Key	*/
		setze_var(va, NULL, i);
	} else if ((stricmp(cmd, "AV-SENDKEY") == 0) || (stricmp(cmd, "AV_SENDKEY") == 0)){
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		i = -1;
		if (p1 != NULL) {
			strcpy(param, p1);	/* erster Parameter bei send_key das Programm, dann AV-SENDKEY	*/
			p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
			i = send_key(param, p1);
		}
		setze_var(va, NULL, i);
	} else if (stricmp(cmd, "TOP") == 0) {
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		i = top_app(p1);
		setze_var(va, NULL, i);
	} else if (stricmp(cmd, "EXIT") == 0) {
		buffer[0] = buffer[5] = AP_TERM;
		buffer[1] = ap_id;
		buffer[2] = buffer[3] = buffer[4] = buffer[6] = buffer[7] = 0;

		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		if (p1 != NULL) {
			aktiv(p1, &i);
			if (i > 0) appl_write(i, 16, buffer);	/* Auf Appl=0 (Desktop) keinen SHUTDOWN erlauben!	*/
		}
	} else if (stricmp(cmd, "KILL") == 0) {
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		if (p1 != NULL) {
			if (flags.magix) {
				aktiv(p1, &i);
				buffer[0] = SM_M_SPECIAL;
				buffer[1] = ap_id;
				buffer[2] = buffer[3] = 0;
				buffer[4] = SMC_MAGIC1;
				buffer[5] = SMC_MAGIC2;
				buffer[6] = SMC_TERMINATE;
				buffer[7] = i;
				appl_write(1, 16, buffer);	/* An den SCRNMGR senden	*/
			} else if (flags.mint) {
				strcpy(param, "U:\\PROC\\");
				strcat(param, p1);
				strcat(param, ".*");
				Fdelete(param);
			}
		}
	} else if (stricmp(cmd, "AKTIV") == 0) {
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p1 != NULL) {
			if (aktiv(p1, NULL)) setze_var(va, "0", 0);	/* Werte >= 0 sind TRUE!	*/
			else setze_var(va, "FALSE", -1);
		}
	} else if (stricmp(cmd, "FSELECT") == 0) {
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		
		*param = Dgetdrv() + 'A';
		Dgetpath(&param[2], 0);
		param[1] = ':';
		strcat(param, "\\*.*");
		*param2 = '\0';
		
		if (p1 != NULL) fsel_exinput(param, param2, &i, p1);
		else fsel_input(param, param2, &i);
		
		if (i == 0)	{	/* CANCEL gedrckt!	*/
			setze_var(va, "", -1);
		} else {
			p1 = strrchr(param, '\\');
			if (p1 != NULL) *(++p1) = '\0';
			strcat(param, param2);
			setze_var(va, param, 0);
		}		
	} else if ((stricmp(cmd, "SEND") == 0) || (stricmp(cmd, "SENDFILE") == 0)) {
		j = (int )cmd[4];
		p1 = setze_text(strtok(NULL, " \t"), dummy, 1023);
		if ((ss = get_dev(p1)) == NULL) {
			setze_var(va, NULL, -15);
			free(zeile);
			return(ret);
		}
		p2 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p2 != NULL) {
			i = TRUE;
			if (j == '\0') {		/* Befehl SEND!	*/
				send_string(ss, p2);
				send_string(ss, "\r\n");
			} else {
				i = send_file(ss, p2);
				if (!i) i = -33;
			}
		} else i = -1;
		if (i) setze_var(va, "TRUE", 0);
		else setze_var(va, NULL, i);
	} else if ((stricmp(cmd, "MIDI-COM") == 0) || (stricmp(cmd, "MIDI_COM") == 0)){	/* Befehle an MidiCom bergeben	*/
		if (flags.midi_com) {
			flags.midi_ring = mc_closed();
			p1 = setze_text(strtok(NULL, " \t"), dummy, 1023);
			
			if (flags.midi_ring) {
				if (*p1 < '1' || *p1 > '7' || p1[1] != '\0') i = hole_midi_nr(p1);	/* Rechnername angegeben	*/
				else i = *p1 - '0';
			} else i = -1;
			
			if (i >= -1) {
				if (flags.midi_ring) {	
					p2 = setze_text(strtok(NULL, "\n\r"), dummy, 1023);
					if (p2 != NULL) {
						if ((l = strlen(p2)) > 128) p2[128] = '\0';	/* maximal 128 Byte senden!	*/
						l = transmit((int )l + 1, i, "EVENTMAN", p2);
					}
				}
			}
			if (l < 0) setze_var(va, NULL, l);
			else setze_var(va, "TRUE", 0);
		}
	} else if (stricmp(cmd, "SS") == 0) {	/* Schnittstellenberwachung ein-ausschalten		*/
					/* Beispiel:	"SS AUX: EIN" oder "SS MODEM2 AUS"	*/
		p1 = setze_text(strtok(NULL, " \t"), dummy, 1023);
		if ((ss = get_dev(p1)) == NULL) {
			setze_var(va, NULL, -15);		/* Schnittstelle nicht gefunden	*/
			free(zeile);
			return(ret);
		}
		p2 = setze_text(strtok(NULL, " \t"), dummy, 1023);
		if (p2 == NULL) {
			setze_var(va, NULL, -1);		/* Nicht angegeben, ob ein oder aus.	*/
			free(zeile);
			return(ret);
		}
		strupr(p2);	/* Gro-Kleinschreibung egal!	*/
		
		switch(*p2) {
			case 'E':	ss->on_off++;	/* Einschalten = positiv zhlen	*/
						break;
			case 'A':	ss->on_off--;	/* Ausschalten = negativ!	*/
						break;
			default:	break;			/* Alles andere wird als Baudrate setzen gewertet!	*/
		}
		
		i = -32;
		if (ss->fd_w > 0 && *p2 == 'A') {	/* Beim Ausschalten mu VOR update getestet werden!	*/
			ss->baudrate = -1;
			i = Fcntl(ss->fd_w, (long )&ss->baudrate, TIOCOBAUD);
			if (i < 0) ss->baudrate = -1;	/* fehler!	*/
		}

		update_ss(ss);			/* Schnittstelle ffnen	bzw. schlieen */
		
		c = NULL;
		if (ss->fd_w > 0 && *p2 != 'A') {	/* Beim Einschalten mu NACH update getestet werden!	*/
			if ((c = strtok(NULL, " \t")) != NULL) ss->baudrate = atol(c);
			if (ss->baudrate >= 0) {
				i = Fcntl(ss->fd_w, (long )&ss->baudrate, TIOCOBAUD);
				if (i < 0) ss->baudrate = -1;	/* Fehler aufgetreten!	*/
			}
		}
		if (i < 0 && c != NULL) fehler(ERR_NO_SSKONF, p1);

		if (ss->on_off > 0) setze_var(va, "EIN", ss->on_off);
		else setze_var(va, "AUS", ss->on_off);
		
	} else if (stricmp(cmd, "CLEAR") == 0) {	/* Schnittstelle lschen		*/
		p1 = setze_text(strtok(NULL, " \t\r\n"), dummy, 1023);				/* Beispiel:	"CLEAR AUX:" 	*/
		if ((ss = get_dev(p1)) == NULL) {
			setze_var(va, NULL, -15);
			free(zeile);
			return(ret);
		}
		clear(ss->dev);
		setze_var(va, "TRUE", 0);
	} else if (stricmp(cmd, "SAVE_INF") == 0) {	/* Konfiguration sichern		*/
		if (sichern_inf()) setze_var(va, "TRUE", 0);
		else setze_var(va, "FALSE", -10);
	} else if ((stricmp(cmd, "DISABLE") == 0) || (stricmp(cmd, "ENABLE") == 0)) {	/* Knopf sperren		*/
		anz = (*cmd=='d' || *cmd=='D') ? FALSE : TRUE;
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		c = strchr(p1, '-');
		if (c != NULL) *(c++) = '\0';
		else c = p1;
		
		j = atoi(c) - 1;
		for (i = atoi(p1) - 1; i <= j; i++) {
			if ((i >= 0) && (i < MAX_KNOPF)) 
				tasten[i].enabled = anz;
		}
		setze_var(va, strupr(cmd), 0);
		disp_button(TRUE);
	} else if (stricmp(cmd, "PNICE") == 0) {	/* MultiTOS Prio ndern		*/
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		setze_var(va, NULL, Pnice(atoi(p1)));
	} else if (stricmp(cmd, "DELAY") == 0) {	/* Timemanager anhalten!		*/
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		warte_zeit = atoi(p1) + time(NULL);

		tm = localtime(&warte_zeit);
		strftime(param, 19, "%H%M%S%d%m%Y", tm);
		param[19]='\0';
		setze_ob(haupt.ob, ZEIT, param);
		setze_ob(haupt.ob, EREIGNIS_NAME, ">>> DELAY bis");
		setze_ob(haupt.ob, ART, "");
		ret = 998;	/* Kennung fr Delay!	*/

		setze_var(va, NULL, ret);
	} else if (stricmp(cmd, "WAIT") == 0) {		/* Aktion mu warten		*/
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		for (i = 32767; i > 1000; i--) {
			sprintf(param, "%s\\akt_%x.dat", file_path, i);
			fd = fopen(param, "r");
			if (fd == NULL) break;
			else fclose(fd);
		}
		if (i > 1000) {
			ret = i;
			if ((stricmp(p1, "NO-AKTION") == 0) || (stricmp(p1, "NO_AKTION") == 0)) {
				sprintf(param, "%s\\waitfor.dat", file_path);
				fd = fopen(param, "a");
				if (fd != NULL) {
					flags.w_noakt = TRUE;
					--flags.aktion;	/* 1 abziehen, sonst wird flags.aktion nie auf 0 kommen!	*/
				}
				fprintf(fd, "%d\t%s\n", ret, p1);
				fclose(fd);
			} else if ((stricmp(p1, "NO-AKTIV") == 0) || (stricmp(p1, "NO_AKTIV") == 0)) {
				p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
				wait_neu(p1, FALSE, ret); 
			} else if (stricmp(p1, "AKTIV") == 0) {
				p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
				wait_neu(p1, TRUE, ret); 
			}
		}
	} else if (stricmp(cmd, "VOLUME") == 0) {	/* Lautstrke einstellen		*/
		if ((!test_cookie("_SND", &l)) || !(l & 0x06)) {
			fehler(ERR_NO_DMASOUND, NULL);
			setze_var(va, "FALSE", ret);
			free(zeile);
			return(ret);
		}
		while ((p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023)) != NULL) {
			if (p1[1] != '=') {
				i = j = atoi(p1);
				break;
			} else if (toupper(*p1) == 'L') i = atoi(&p1[2]);
			else if (toupper(*p1) == 'R') j = atoi(&p1[2]);
		}
		if (l & 0x04) {
			i = 15 - i;
			j = 15 - j;
			if ((i >= 0) && (i <= 15)) Soundcmd(LTATTEN, i << 4);
			if ((j >= 0) && (j <= 15)) Soundcmd(RTATTEN, j << 4);
		} else {
			if ((i >= 0) && (i <= 20)) Sound_tt('L', i);
			if ((j >= 0) && (j <= 20)) Sound_tt('R', j);
		}
	} else if (stricmp(cmd, "SOUND") == 0) {	/* Sound ausgeben		*/
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p1 != NULL && (stricmp(p1, "GONG") != 0)) {
			if (!aktiv("GEMJING", &i) && flags.parallel) {
				strcpy(parameter, " -q ");
				strcat(parameter, p1);
				*parameter = (char )strlen(&parameter[1]);
				shel_envrn(e, "GEMJINGPATH=");
				if (*e != NULL) shel_write(SHW_APPEXEC, TRUE, SHW_PARALLEL, *e, parameter);
			} else {
				va_startprog("GEMJING", p1, FALSE);
			}
		} else gong();
		setze_var(va, "TRUE", 0);
	} else if (stricmp(cmd, "SCRIPT") == 0) {	/* Scripter ein Script bergeben		*/
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p1 != NULL) {
			shel_envrn(e, "GEMSCRIPT=");
			c = strrchr(*e, '\\');
			if (c != NULL) c++;
			else c = *e;
			
			if (!aktiv(c, &i) && flags.parallel) {
				strcpy(&parameter[1], p1);
				*parameter = (char )strlen(&parameter[1]);
				
				if (*e != NULL) shel_write(SHW_APPEXEC, TRUE, SHW_PARALLEL, *e, parameter);
			} else {
				va_startprog(c, p1, FALSE);
			}
		} else gong();
		setze_var(va, "TRUE", 0);
	} else if (stricmp(cmd, "ALERT") == 0) {	/* Alertbox ausgeben		*/
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		j = atoi(p1);
		if (j>3 || j<0) j = 0;
		p1 = setze_text(strtok(NULL, "[\n"), dummy, 1023);

		if (p1 != NULL) {

			for (i = 0, c = p1; *c != '\0'; c++, i++) {
				if (*c == '|') i = 0;
				if (*c == ' ') p2 = c;
				if (i >= 30) {
					*p2 = '|';
					i = (int )(c - p2);
				}
			}

			p2 = setze_text(strtok(NULL, "]\n"), param2, sizeof(param2)-1);

			if (p2 != NULL) sprintf(param, msg[MSG_ALERT].ob_spec.free_string, j, p1, p2);
			else sprintf(param, msg[MSG_ALERT].ob_spec.free_string, j, p1, "OK");

			i = form_alert(1, param);
			setze_var(va, NULL, i);
		}
	} else if (stricmp(cmd, "INFO") == 0) {	/* Infobox ausgeben		*/
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		setze_infobox(p1, time(NULL));
		
	} else if (stricmp(cmd, "SKIP") == 0) {	/* Infobox ausgeben		*/
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);	/* Aktionsname	*/
		p2 = setze_text(strtok(NULL, "\n"), param, 100);		/* Verschieben auf:	*/
		if (p2 != NULL) {
			c = &p2[strlen(p2)-1];
			switch(*c) {
				case 't':	l = 86400L;
							break;
				case 'h':	l = 3600L;
							break;
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':	c++;	/* kein Buchstabe am Ende, daher c auf's Ende setzen	*/
				default:	l = 60L;
							break;
			}
			*c = '\0';
			l *= atol(p2);			/* Mit Wert multiplizieren	*/
		} else l = -1L;				/* Genau ein Zeitereignis berspringen!	*/
		skip_timer(p1, l);
		test_evt(FALSE);			/* Fenster updaten!	*/
	} else if (stricmp(cmd, "DIM") == 0) {	/* Dimensioniere Variablen	*/
		p1 = strtok(NULL, "\r\n");
		if (p1 != NULL) ret = dim_var(p1);
		if (ret == -7) {
			free(zeile);
			return(ret);
		}
	} else if (stricmp(cmd, "SET") == 0) {	/* Variablen Setzen	*/
		p1 = strtok(NULL, " \t\n");			/* Variable feststellen	*/
		if ((v = teste_var(p1)) == NULL) {
			free(zeile);
			return(ret);	/* Keine Variable gefunden	*/
		}
		p2 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		setze_var(v->name, p2, atol(p2));
	} else if (stricmp(cmd, "WINDOW") == 0) {	/* Fenter ffnen/schliee	*/
		setze_var(va, NULL, -1);
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		if (p1 != NULL) {
			switch(toupper(*p1)) {
				case 'T':	f = hole_fenster(-1);
							break;
				case 'S':	f = &haupt;
							break;
				case 'M':	f = &knopf;
							break;
				case 'K':	f = &kal;
							break;
				case 'I':	f = &grins;
							break;
				default:	f = &info;
							break;
			}
		}
		p1 = strtok(NULL, " \t\n");
		if (p1 != NULL && f != NULL) {
			switch(toupper(*p1)) {
				case 'C':	schliesse_fenster(f);
							break;
				case 'O':	oeffne_fenster(f);
							break;
			}
		}
		setze_var(va, NULL, 0);
	} else if (stricmp(cmd, "QUIT") == 0) {	/* Programmende		*/
		ret = -2;
	} else if (stricmp(cmd, "IF") == 0) {
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		for (; *p1 != '(' && *p1 != '\0'; p1++) {	/* erste Klammer suchen	*/
			if (!isspace(*p1)) {					/* dazwischen darf nix stehen!	*/
				fehler(ERR_IF_OHNE_KLAMMER, NULL);
				free(zeile);
				return(-7);	/* Ereignis abbrechen!	*/
			}
		}
		if (*p1 != '\0') p1++;
		c = strrchr(p1, ')');
		if (c != NULL) *c = '\0';
		ret = bedingung(p1) ? -3 : -4;
		flags.if_ebene++;
/*
!	-3, wenn IF Bedingung Wahr ist (alle Kommandos bis ELSE oder ENDIF ausfhren
!	-4, wenn IF Bedingung Falsch (alle Kommandos nach ELSE bis ENDIF ausfhren
*/		
	} else if (stricmp(cmd, "ENDIF") == 0) {
		ret = -5;
		if (flags.if_ebene > 0) flags.if_ebene--;
	} else if (stricmp(cmd, "ELSE") == 0) {
		ret = -6;
	} else if (stricmp(cmd, "PROTOKOLL") == 0) {
		p1 = setze_text(strtok(NULL, " \t\n"), dummy, 1023);
		if (p1 != NULL) {
			i = *p1;
			p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);	/* evtl. Dateiname angegeben?	*/
			switch (toupper(i)) {
				case 'E':	flags.protokoll = TRUE;
							if (p1 != NULL) {
								*proto_file = '\0';
								strncat(proto_file, p1, sizeof(proto_file)-1);
							}
							break;
				case 'L':	strcpy(param, file_path);
							strcat(param, "\\");
							l = strlen(param);
                            if (p1 != NULL) { 
                                zeit = time(NULL); 
                                l += strftime(&param[l], sizeof(proto_file)-1, p1, localtime(&zeit)); 
                                strcpy(&param[l], ".PRO"); 
                                Fdelete(param); 
                            } else { 
                                strcat(param, "*.PRO"); 
                                if (findfirst(param, &ffb, 0) == 0) { 
                                    do { 
                                        strcpy(&param[l], ffb.ff_name); 
                                        Fdelete(param); 
                                    } while(findnext(&ffb) == 0); 
                                } 
                            } 
							break;
				case 'S':	i = flags.protokoll;
							flags.protokoll = TRUE;
							if (p1 != NULL) proto("MELDUNG", p1);
							else proto("MELDUNG", "<NULL>");
							flags.protokoll = i;
							break;
				default:	flags.protokoll = FALSE;
							break;
			}
		}
	} else {	/* Ansonsten wird noch berprft, ob gerechnet werden soll, oder ob's
					als Fehlermeldung ausgegeben wird! */
		strcpy(param, cmd);
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		if (p1 != NULL) {
			strcat(param, " ");
			strcat(param, p1);
		}
		ret = -7;	/* Fehler aufgetreten!	*/
		if (!script) fehler(ERR_KEIN_KOMMANDO, param);
	}
	
	if (prog) {
		p1 = setze_text(strtok(NULL, "\n"), dummy, 1023);
		p1 = strtok(p1, " \t");
		
		graf = -1;
		if (strcmp(p1, "TOS") == 0) graf = FALSE;
		else if (strcmp(p1, "GEM") == 0) graf = TRUE;
		if (graf != -1) p1 = strtok(NULL, " \t");

		proto("Programmstart", p1);
		
		l = strlen(p1) - 1;
		if (p1[l] == '\n') {
			p1[l] = '\0';
			p2 = NULL;
		} else p2 = strtok(NULL, "\n");
		if (p2 != NULL) {
		
			proto(NULL, " ");
			proto(NULL, p2);
		
			strcpy(&param[1], p2);
			*param = (char )strlen(&param[1]);
		} else *param = param[1] = '\0';


		if (graf < 0) {			
			c = strrchr(p1, '.');
			if ((c != NULL) && (toupper(*(++c)) == 'T')) graf = FALSE;
			else graf = TRUE;
		}
		if (va_start_flag) {	/* VA-Start-Protokoll wird gewnscht!	*/
			i = va_startprog(p1, &param[1], TRUE);
			setze_var(va, NULL, i);
		} else if (flags.parallel) {	/* parallellauf mglich (MultiTOS/MagiX)*/
			i = shel_write(SHW_APPEXEC, graf, SHW_PARALLEL, p1, param);
			if (i == 0) {	/* Fehler aufgetreten!	*/
				setze_var(va, "FALSE", -1);
				ret = -1;
			} else {
				if (!parallel) ret = i; 
				setze_var(va, NULL, 0);
			}
		} else if (!_app) {
			/* Programmstart als ACC ist schwierig!	*/
			if (flags.mint || flags.magix) ret = shel_write(SHW_APPEXEC, graf, 0, p1, param);
			else {	/* VA_STARTPROTOKOLL	*/
				strcpy(programm, p1);
				if (param == NULL) *parameter = '\0';
				else strcpy(parameter, &param[1]);
				
				buffer[0] = AV_STARTPROG;
				buffer[1] = ap_id;
				buffer[2] = 0;

				buffer[3] = (int )((long )programm >> 16);
				buffer[4] = (int ) programm;

				buffer[5] = (int )((long )parameter >> 16);
				buffer[6] = (int ) parameter;
				buffer[7] = ret = 999;
				appl_write(0, 16, buffer);
				setze_var(va, NULL, 0);
			}
		} else {
			anz = 0;
			wind_get(0, WF_TOP, &i);
			while (i > 0) {
				wind_close(i);		/* Auch ACC-Fenster schlieen!	*/
				wind_delete(i);
				if ((f = hole_fenster(i)) != NULL) {
					f->aktiv = FALSE;
					f->wind_handle = -1;
					fenster[anz++] = f;
				}
				wind_get(0, WF_TOP, &i);
			}

			if (flags.menu_bar) menu_bar(menu, FALSE);
			appl_exit();
			l = Pexec(0, p1, param, environment);			/* Parallellauf nicht mglich	*/
			ap_id = appl_init();
			setze_var(va, NULL, l);	/* Ergebnis setzen!	*/
			
			if (flags.menu_bar) menu_bar(menu, TRUE);

			for (--anz; anz >= 0; oeffne_fenster(fenster[anz--]));
		}
		
	}
	
	switch(ret) {
		case -1:	proto(NULL, "...beendet!");
					break;
		case -2:	proto("Programmende", "Fhre Befehl ENDE aus!");
					break;
		case -3:	proto(" IF-Bedingung", "ist wahr!");
					break;
		case -4:	proto(" IF-Bedingung", "ist falsch!");
					break;
		case -5:	proto(" IF-Bedingung", "ENDIF erreicht!");
					break;
		case -6:	proto(" IF-Bedingung", "ELSE erreicht");
					break;
		case -8:	proto("Neue Aktion: ", ereignis_nam);
					break;
		default:	sprintf(param, "...warte auf Ende der Appl. %d", ret);
					proto(NULL, param);
					break;
	}
	
	if (va == NULL) v = &var;
	else v = teste_var(va);
	
	if (v != NULL) {
		proto(NULL, " Ergebnis: ");
		if (v->art > 0) proto(NULL, v->v_art.c_string);
		else proto(NULL, ltoa(v->v_art.l_wert, param, 10));
	}
	free(zeile);
	return(ret);
}

/*-------------------------------------------------------------------
!	Startet eine Applikation mit VA_START und wartet auf AV_STARTED,
!	wenn "warten" auf TRUE gesetzt ist.
!	Liefert den Returncode
+-----------------------------------------------------------------*/

int va_startprog(char *prog, char *parameter, int warten)

{
	int buffer[16];
	int start_id;

	aktiv(prog, &start_id);

	if (start_id >= 0) {
		strcpy(va_parameter, parameter);
		buffer[0] = VA_START;
		buffer[1] = ap_id;
		buffer[2] = 0;

		buffer[3] = (int )((long )va_parameter >> 16);
		buffer[4] = (int ) va_parameter;

		buffer[5] = buffer[6] = buffer[7] = 0;
		appl_write(start_id, 16, buffer);
		return(TRUE);
	} else return(FALSE);
}


/*----------------------------------------------------------------------
!	Setzt den TT SOund
+--------------------------------------------------------------------*/

void Sound_tt(int wo, int laut)

{
	void *ssp;
	
	int *mask;
	int *wert;
	
	mask = (int *)0xFFFF8924L;
	wert = (int *)0xFFFF8922L;
	
	ssp = (void *)Super(0);
	*mask = 0x07FF;

	if (wo == 'L') *wert = 0x0540 + laut;
	else if (wo == 'R')	*wert = 0x0500 + laut;
	
	Super(ssp);
}

/*----------------------------------------------------------------------
!	Legt die wait_struktur an und trgt ein Programm ein, auf das
!	gewartet werden mu!
+--------------------------------------------------------------------*/

void	wait_neu(char *prog, int aktiv, int nr)

{
	WAIT_STRUKT *ws, *w_neu;
	
	w_neu = (WAIT_STRUKT *) malloc (sizeof(WAIT_STRUKT));
	w_neu->next_ws = NULL;
	strncpy(w_neu->programm, prog, 14);
	w_neu->programm[14] = '\0';
	w_neu->aktiv = aktiv;
	w_neu->file_nr = nr;

	ws = wait_strukt;
	
	if (ws != NULL) {
		while (ws->next_ws != NULL) ws = ws->next_ws; 			/* Letzen Eintrag suchen	*/
		ws->next_ws = w_neu;
	} else {													/* ersten Eintrag anlegen	*/
		wait_strukt = w_neu;									/* auch globale wait_strukt setzen	*/
	}
}

/*---------------------------------------------------------------------
!	Gibt Speicherbereich fr alle Wait frei!
+--------------------------------------------------------------------*/

void	wait_del(void)
{
	WAIT_STRUKT *ws;
	
	ws = wait_strukt;
	while (ws != NULL) {
		ws = ws->next_ws;
		free(ws);
	}
	wait_strukt = NULL;
}

/*---------------------------------------------------------------------
!	Setzt die INFO-BOX
+--------------------------------------------------------------------*/

void setze_infobox(char *text, time_t zeit) 

{
	char *c, *p;
	int zeile, i;
	time_t z;
	FILE *fd;
	
	if (info_box == NULL) return;
	z = zeit;
	memcpy(&info_box[1], info_box, sizeof(INFO_BOX) * (flags.info_anzahl - 1));
	
	if (flags.akute_infos < flags.info_anzahl) {
		flags.akute_infos++;
	}
	
	strftime(info_box->datum, sizeof(info_box->datum), "%d%m%Y", localtime(&z));
	strftime(info_box->zeit, sizeof(info_box->zeit), "%H%M%S", localtime(&z));
	info_box->datum[sizeof(info_box->datum)-1] = '\0';
	info_box->zeit[sizeof(info_box->zeit)-1] = '\0';
	
	if (text != NULL) {
		c = text;
		for (i = zeile = 0; *c != '\0'; c++, i++) {
			if (*c == ' ') p = c;
			if ((*c == '|') || (i >= 50)) {
				if (i >= 50) c = p;
				*c = '\0';
				strcpy(info_box->text[zeile], text);
				text = c + 1;
				if (++zeile >= 6) break;
				i = 0;
			}
		}
		strcpy(info_box->text[zeile++], text);
		for (; zeile < 6; strcpy(info_box->text[zeile++], ""));
	}
	grins.wert = 0;

	strcpy(f1, file_path);
	strcat(f1, "\\info.dat");
	fd = fopen(f1, "w");
	if (fd != NULL) {
		for (i = 0; i < flags.akute_infos; i++) {
			fprintf(fd, "%s %s\n", info_box[i].datum, info_box[i].zeit);
			for (zeile = 0; zeile < 6; zeile++) {
				fprintf(fd, "%s\n", info_box[i].text[zeile]);
			}
		}
		fclose(fd);
	}
	zeige_infobox(0, TRUE);
}

/*--------------------------------------------------------
!	Ldt die INFO.DAT ein und setzt die ensprechenden Werte
+-----------------------------------------------------*/

void lade_infobox(void)

{
	int i, zeile;
	FILE *fd;
	char *c;

	strcpy(f1, file_path);
	strcat(f1, "\\info.dat");
	fd = fopen(f1, "r");
	if (fd != NULL) {
		i = zeile = 0;
		while (fscanf(fd, "%s %s ", info_box[i].datum, info_box[i].zeit) != EOF) {
			for (zeile = 0; zeile < 6; zeile++) {
				fgets(info_box[i].text[zeile], 50, fd);
				c = strchr(info_box[i].text[zeile], '\n');
				if (c != NULL) *c = '\0';
			}
			if (++i > flags.info_anzahl) break;
		}
		fclose(fd);
		flags.akute_infos = i;
		zeige_infobox(0, FALSE);	/* Im Info ist verkehrt herumsortiert, dahr ist 0 der letzte Eintrag! */
	} else flags.akute_infos = 0;
}

/*-----------------------------------------------------------------------
!	Stellt die Infobox dar und zwar mit der Meldung nr
!	Wenn oeffnen TRUE ist, dann wird das Fenster geffnet
+----------------------------------------------------------------------*/

void zeige_infobox(int nr, int oeffnen)

{
	int j;
	INFO_BOX *i;

	if (info_box == NULL || flags.akute_infos <= 0) return;

	i = &info_box[nr];
	
	setze_ob(grins.ob, INFO_DATUM, i->datum);
	setze_ob(grins.ob, INFO_ZEIT, i->zeit);

	for (j = 0; j < 6; j++) setze_ob(grins.ob, j + ZEILE1, i->text[j]);

	if (flags.menu_bar) menu_ienable(menu, MENU_INF, TRUE);
	info.ob[OPEN_INFO].ob_state &= ~DISABLED;

	if (grins.aktiv) {
		j = flags.akute_infos -1;
		grins.vslide = (j - nr) * 1000 / j;
		wind_get(0, WF_TOP, &j);
		if (j != grins.wind_handle) wind_set(grins.wind_handle, WF_TOP);
		
		wind_set(grins.wind_handle, WF_VSLSIZE, 1000 / flags.akute_infos);
		wind_set(grins.wind_handle, WF_VSLIDE, grins.vslide);
		setze_ob(info.ob, OPEN_INFO, NULL);
	} else if (oeffnen) oeffne_fenster(&grins);
}

/*---------------------------------------------------------------------
!	Setzt die  SS-Strings im Statusdialog
+--------------------------------------------------------------------*/

void update_ss(SS *ss)

{
	char *c, file[40]="U:\\DEV\\";
	int ki=-1;
	long l;
	
	switch(ss->dev) {
		case AUX:	ki = TEXT_AUX;
					break;
		case MIDI:	ki = TEXT_MIDI;
					break;
		case MODEM1:ki = TEXT_MODEM1;
					break;
		case MODEM2:ki = TEXT_MODEM2;
					break;
		case SERIAL1:ki = TEXT_SERIAL1;
					break;
		case SERIAL2:ki = TEXT_SERIAL2;
					break;
	}

	strcat(file, ss->file);
	
	if (ss->on_off > 0) {
		if (ki > 0) haupt.ob[ki].ob_state &= ~DISABLED;

		if (flags.mint || flags.magix || ss->hsmodem) {
			if (!flags.mint) {	/* Bei MultiTOS gibts Probleme	*/
				if (ss->fd_r < 0) {		/* Nur wenn noch nicht geffnet!	*/
					l = Fopen(file, FO_READ);
					if (l > 0) {
						ss->fd_r = (int )l;
						if (flags.fcntl && (Fcntl(ss->fd_r, (long ) &l, FIONREAD) < 0)) flags.fcntl = FALSE;
						if (flags.finstat && (Finstat(ss->fd_r) < 0)) flags.finstat = FALSE;
					}
				}
			}
			if (ss->fd_w < 0) {		/* Nur wenn noch nicht geffnet!		*/
				l = Fopen(file, FO_WRITE);
				if (l > 0) ss->fd_w = (int )l;
			}
		}
	} else {
		haupt.ob[ki].ob_state |= DISABLED;
		if (ss->fd_r > 0) Fclose(ss->fd_r);
		if (ss->fd_w > 0) Fclose(ss->fd_w);
		ss->fd_w = ss->fd_r = -1;
	}
	
	if (ss->pointer > 23) c = &ss->buffer[ss->pointer - 23];
	else c = ss->buffer;
	if (ki > 0) setze_ob(haupt.ob, ki, c);	
}

/*----------------------------------------------------------------------
!	Setzt die erste Zeile im Objekt und zeichnet diesen Teil neu!
+----------------------------------------------------------------------*/

void setze_ob(OBJECT *ob, int kind, char *text)

{
	FENSTER *akt;
	GRECT wi, re, dr;
	int i, cs = 0x100;	/* Check and set vorbelegen	*/
	int tiefe = 0; 
	
	for (i = 0; i < MAX_FENSTER; i++) {
		if (ob == alle_fenster[i]->ob) {
			akt = alle_fenster[i];
			break;
		}
	}
	if (_GemParBlk.global[0] < 0x399) cs = 0;	/* Kein Check and Set mglich	*/

	switch(ob[kind].ob_type) {
		case G_TEXT:
		case G_BOXTEXT:
		case G_FTEXT:
		case G_FBOXTEXT:
			if (text != NULL) strncpy(ob[kind].ob_spec.tedinfo->te_ptext, text, ob[kind].ob_spec.tedinfo->te_txtlen);
			break;
		case G_CICON:
		case G_ICON:
			tiefe = 10;
			kind = 0;
			break;
		default: 
			tiefe = 10;
			break;
	}

	if (!akt->aktiv) return;

	objc_offset(ob, kind, &re.g_x, &re.g_y);			/* Nur das zeichnen was notwendig ist	*/
	re.g_w = ob[kind].ob_width;
	re.g_h = ob[kind].ob_height;

	if (wind_update(BEG_UPDATE | cs) != 0) {		/* check and set!	*/
		wind_get(akt->wind_handle, WF_FIRSTXYWH, &wi.g_x, &wi.g_y, &wi.g_w, &wi.g_h);
		while (wi.g_w != 0 || wi.g_h != 0) {

			if (intersect(&dr, &re, &wi))
				objc_draw(ob, kind, tiefe, dr.g_x, dr.g_y, dr.g_w, dr.g_h);
				
			wind_get(akt->wind_handle, WF_NEXTXYWH, &wi.g_x, &wi.g_y, &wi.g_w, &wi.g_h);
		} 
		akt->restore = FALSE;
		akt->rest_ob = -1;
		wind_update(END_UPDATE);
	} else {
		akt->restore = flags.restore = TRUE;
		if (akt->rest_ob < 0) akt->rest_ob = kind;
		else if (akt->rest_ob != kind) 
			akt->rest_ob = 0;	/* Wenn bereits ein anderes Objekt vermerkt ist, dann alles zeichnen	*/
	}
}

/*----------------------------------------------------------------------
!	Initialisiert das RSC-File
+---------------------------------------------------------------------*/

void rsrc_init(void)

{
	register int i;
	FILE *fd;
	char *c, t[128];

	strcpy(rsrc_file, "EVENTMAN.RSC");
	
	fd = fopen(inf_file, "r");
	if (fd != NULL) {
		while (fgets(dummy, 127, fd) != NULL) {
			if ((c = strtok(dummy, " \t\n")) == NULL) continue;
			if (stricmp(c, "Use-RSCFile:") == 0) {
				c = strtok(NULL, " \t\n");
				if (c != NULL) {
					*rsrc_file = '\0';
					strncat(rsrc_file, c, 127);
				}
				break;	/* Mehr wolln wir nicht wissen	*/
			}
		}
		fclose(fd);
	}

	if (!rsrc_load(rsrc_file)) {
		sprintf(t, "[3][Can't load file/|Kann Datei nicht finden|%s][Quit/Abbruch]", rsrc_file);
		form_alert(1, t);
		appl_exit();
		exit(0);
	} else {
		flags.rsrc_load = TRUE;	/* Laden hat geklappt!	*/
		rsrc_gaddr(0, MESSAGES, &msg);
		rsrc_gaddr(0, GRUPPEN_ICON, &gruppen_icon);
	
		rsrc_gaddr(0, DIALOG, &haupt.ob);
		rsrc_gaddr(0, H_ICON, &haupt.ic);
		rsrc_gaddr(0, KNOEPFE, &knopf.ob);
		rsrc_gaddr(0, M_ICON, &knopf.ic);
		rsrc_gaddr(0, INFOBOX, &grins.ob);
		rsrc_gaddr(0, KALENDER, &kal.ob);
		rsrc_gaddr(0, K_ICON, &kal.ic);
		rsrc_gaddr(0, BEM_INFO, &info.ob);
		rsrc_gaddr(0, LEISTE, &menu);
		strcpy(info.ob[INFO_NAME].ob_spec.free_string, "Michael Pieper");
		strcpy(info.ob[INFO_STRASSE].ob_spec.free_string, "Flurstrae 5");
		strcpy(info.ob[INFO_ORT].ob_spec.free_string, "86368 Gersthofen");
	}
	
	info.ic = NULL;
	
	haupt.art = NAME|CLOSER|MOVER;
	knopf.art = NAME|INFO|CLOSER|MOVER;
	grins.art = NAME|CLOSER|MOVER|UPARROW|DNARROW|VSLIDE;
	kal.art = NAME|CLOSER|MOVER|INFO|UPARROW|DNARROW|VSLIDE;
	info.art = NAME|CLOSER|MOVER|INFO;
	
	if (flags.iconify) {
		knopf.art |= SMALLER;
		haupt.art |= SMALLER;
		kal.art |= SMALLER;
	}
	
	if (flags.menu_bar) {
		menu_bar(menu, TRUE);
		if (!_app) menu_ienable(menu, MENU_ENDE, FALSE);
		menu_ienable(menu, MENU_INF, FALSE);
	}

	init_win(&haupt, msg[MSG_STATUS].ob_spec.free_string, NULL, "Haupt");
	init_win(&kal, msg[MSG_KALENDER].ob_spec.free_string, kal_info, "Kalen");
	init_win(&knopf, msg[MSG_BUTTON].ob_spec.free_string, k_info, "Knopf");
	init_win(&info, c_titel, c_text, "");
	init_win(&grins, msg[MSG_INFO].ob_spec.free_string, NULL, "InTxt");	

	for (i = TEXT_AUX; i <= TEXT_SERIAL2; haupt.ob[i++].ob_state |= DISABLED);	/* Schnittstellen aus!	*/
	for (i = ZEILE1; i < ZEILE1 + 6; *(grins.ob[i++].ob_spec.tedinfo->te_ptext) = '\0');

	lese_inf(&haupt, &knopf, &kal, &grins);

	setze_buttons();

}

/*-----------------------------------------------------------------------
!	Zentriert ein Object und trgt die Werte in die Fensterstruktur
+----------------------------------------------------------------------*/

void init_win(FENSTER *f, char *titel, char *info, char *kennung)

{
	if (f->ob != NULL) form_center(f->ob, &f->wx, &f->wy, &f->ww, &f->wh);

	wind_calc(WC_BORDER, f->art, f->wx, f->wy, f->ww, f->wh, &f->fx, &f->fy, &f->fw, &f->fh);

	f->dx = f->wx - f->fx;	/* Randbreite berechnen	*/
	f->dy = f->wy - f->fy;

	f->iconified = FALSE;
	f->titel = titel;
	f->info = info;
	strcpy(f->kennung, kennung);

	f->wind_handle = f->vslide = -1;
	
}

/*-----------------------------------------------------------------------
!	Diese Funktion liest die Datei PROGRAMM.EVT aus und stellt eine
!	Struktur zur Verfgung, die die zu vergleichenden Strings enthlt
!	Liefert die Adresse zurck. Bei Fehler -> NULL
+-----------------------------------------------------------------------*/

PROG_STRUKT *setze_programm(void)

{
	char *p, *se, *ee;
	PROG_STRUKT *prog = NULL, *p_str;
	FILE *fd;
	long l;
	
	strcpy(f1, file_path);
	strcat(f1, "\\PROGRAMM.EVT");

	fd = fopen(f1, "r");
	if (fd != NULL) {

		for (l = 0; fgets(dummy, 255, fd) != NULL; l++);
		if (l == 0) {
			fclose(fd);
			return(NULL);
		}
		rewind(fd);

		if ((prog = p_str = (PROG_STRUKT *)malloc((l+1) * sizeof(PROG_STRUKT))) != NULL) {
	
			while (fgets(dummy, 255, fd) != NULL) {

				p = strtok(dummy, " \t");
				se = strtok(NULL, " \t");
				ee = strtok(NULL, " \t\r\n");
				
				if (p == NULL) continue;

				*(p_str->start_ereignis) = *(p_str->end_ereignis) = 
				*(p_str->programm) = '\0';
				strncat(p_str->programm, p, 15);
				if ((p = strchr(p_str->programm, '.')) != NULL) *p = '\0';
				if (se == NULL) strcat(p_str->start_ereignis, "-");
				else strncat(p_str->start_ereignis, se, 49);
				if (ee == NULL) strcat(p_str->end_ereignis, "-");
				else strncat(p_str->end_ereignis, ee, 49);
				p_str->aktiv = FALSE;
				p_str++;
			}
			fclose(fd);
			p_str->programm[0] = '\xff';	/* Ende markieren! deswegen mu l+1 reserviert werden!	*/
		} else fehler(ERR_NO_MEM, "um PROGRAMM.EVT zu laden");
	}
	return(prog);
}

/*-----------------------------------------------------------------------
!	Diese Funktion liest die Datei "BUTTON.EVT" aus, um die Knpfe
!	Richtig zu setzen
+-----------------------------------------------------------------------*/

void setze_buttons(void)

{
	char *but, *nam;
	int i;
	FILE *fd;

	for (i = 0 ; i < MAX_KNOPF; i++) {
		strcpy(tasten[i].name, "-------------");
		tasten[i].enabled = FALSE;
	}
	
	strcpy(f1, file_path);
	strcat(f1, "\\BUTTON.EVT");

	fd = fopen(f1, "r");
	if (fd != NULL) {
		while (fgets(dummy, 254, fd) != NULL) {
			but = strtok(dummy, " \t");
			i = atoi(but) - 1;
			if (i >= 0 && i < MAX_KNOPF) {
				nam = strtok(NULL, " \t");
				*(tasten[i].name) = '\0';
				strncat(tasten[i].name, nam, 13);
				nam = strtok(NULL, " \t\n");
				*(tasten[i].ereignis) = '\0';
				strncat(tasten[i].ereignis, nam, 31);
				tasten[i].enabled = TRUE;
			}
		}
		fclose(fd);
	}
	disp_button(TRUE);
}

/*-----------------------------------------------------------------------
!	Zeigt die aktuellen Tasten an!
!	Wird -1 bergeben, so wird abgefragt, welche Sondertasten gerade
!	gedrckt sind und auf alle Flle gezeichnet!
+----------------------------------------------------------------------*/

void disp_button(int zeichnen)

{
	int i = K1, b = 0, ks;

	ks = (int )Kbshift(-1);
	if (ks & 0x0008) 		b = (MAX_KNOPF / KNOPF_EBENE) * 3;	/* ALT-Taste		*/
	else if (ks & 0x0004) 	b = (MAX_KNOPF / KNOPF_EBENE) * 2;	/* CONTROL-Taste	*/
	else if (ks & 0x0013) 	b = MAX_KNOPF / KNOPF_EBENE;		/* SHIFT- oder CAPS-Lock	*/

	if (zeichnen || flags.button_off != b) {	/* Anzeige nur ndern, wenn andere Buttons angezeigt werden sollen, oder wenn TRUE brgeben	*/

		flags.button_off = b;
		
		if (knopf.art & INFO) {
			*k_info = '\0';
			if (ks & 0x0001) strcat(k_info, " R_SHIFT");
			if (ks & 0x0002) strcat(k_info, " L_SHIFT");
			if (ks & 0x0004) strcat(k_info, " CONTROL");
			if (ks & 0x0008) strcat(k_info, " ALTERNATE");
			if (ks & 0x0010) strcat(k_info, " CAPS-LOCK");
			wind_set(knopf.wind_handle, WF_INFO, k_info);
		}

		for (; i <= K16; b++, i++) {
			switch(knopf.ob[i].ob_type) {
				case G_TEXT:
				case G_BOXTEXT:
				case G_FBOXTEXT:
				case G_FTEXT:
						strcpy(knopf.ob[i].ob_spec.tedinfo->te_ptext, tasten[b].name);
						break;
				default:strcpy(knopf.ob[i].ob_spec.free_string, tasten[b].name);
						break;
			}
			
			if (tasten[b].enabled) knopf.ob[i].ob_state &= ~DISABLED;
			else knopf.ob[i].ob_state |= DISABLED;
		}
		setze_ob(knopf.ob, 0, NULL);
	}
}

/*-----------------------------------------------------------------------
!	Diese Funktion berprft, welche Schnittstellen mit HSMODEM ansprechbar
!	sind.
+----------------------------------------------------------------------*/

void init_ss(void)

{
	long l;
	int i;
	RSVF_COOK *rs;
	SS *ss;
	char device[20];
	if (test_cookie("RSVF", &l)) {		/* HSMODEM aktiv	*/

		for (i = 0; i < 10; i++) {
			set_dev(i, device);
			ss = get_dev(device);
			if (ss == NULL) continue;

			rs = (RSVF_COOK *)l;

			while (rs != NULL) {
				if (!rs->schnittstelle) rs = (RSVF_COOK *)rs->name;
				else {
					if (strcmp(ss->file, rs->name) == 0) {
						ss->hsmodem = TRUE;	/* von HSMODEM untersttzt	*/
						break;
					} else rs++;	
				}
			}
		}
	}
}

/*-----------------------------------------------------------------------
!	Diese Funktion liest die Datei SS.EVT aus und stellt eine
!	Struktur zur Verfgung, die die zu vergleichenden Strings enthlt
+-----------------------------------------------------------------------*/

void setze_ss(void)

{
	char *d, *t, *e, *c;
	long l;
	SS_AKT *ss_buf;
	SS *ss;
	FILE *fd;
	
	strcpy(f1, file_path);
	strcat(f1, "\\SS.EVT");

	max_ss_laenge = haupt.ob[TEXT_AUX].ob_spec.tedinfo->te_txtlen;
	
	fd = fopen(f1, "r");
	if (fd != NULL) {
		for (l = 0; fgets(dummy, 255, fd) != NULL; l++);
		rewind(fd);

		if ((ss_buffer = (SS_AKT *)malloc((l + 1) * sizeof(SS_AKT))) != NULL) {
			ss_buf = ss_buffer;
/*			max_ss_laenge = 1;*/
			while (fgets(dummy, 255, fd) != NULL) {
				for(d = dummy; isspace(*d); d++);
				for(t = d; !isspace(*t); t++);
				*(t++) = '\0';
				for(; isspace(*t); t++);
				if (*t == '\"') {
					for(e = t+1; *e != '\"'; e++);
					e++;
				} else for(e = t; !isspace(*e); e++);
				*(e++) = '\0';
				for( ;isspace(*e); e++);
				for(c = e; !isspace(*c); c++);
				*c = '\0';		
				
				if ((d == NULL) || (t == NULL) || (e == NULL)) continue;
				if ((strlen(d) == 0) || (strlen(t) == 0) || (strlen(e) == 0)) continue;
				
				if ((ss = get_dev(d)) == NULL) continue;
				
				ss_buf->dev = ss->dev;
				if (*t == '\"') t++;
				d = strrchr(t, '\"');
				if (d != NULL) *d = '\0';
				strcpy(ss_buf->string, t);		/* max 49 lang!!	*/
				while ((c = strstr(ss_buf->string, "^M")) != NULL) {
					*(c++) = '\r';
					*c = '\n';	
				}
				l = strlen(t);
/*				max_ss_laenge = (int )(l > max_ss_laenge ? l : max_ss_laenge);*/
				strcpy(ss_buf->ereignis, e);	/* max 49 lang!!	*/
				ss_buf++;
			}
			ss_buf->dev = -99;
		} else fehler(ERR_NO_MEM, "um SS.EVT zu lesen");
		fclose(fd);
	}
}

/*-----------------------------------------------------------------------
!	Vergleicht einen angekommenen String in SS und fhrt evtl. ein
!	ntiges Programm aus.
+----------------------------------------------------------------------*/

void teste_ss(SS *ss)

{
	SS_AKT *ss_buf;
	if (ss_buffer == NULL) return;
	
	for (ss_buf = ss_buffer; ss_buf->dev != -99; ss_buf++) {
		if (ss_buf->dev != ss->dev) continue;
		if (strlen(ss_buf->string) > ss->pointer) continue;
		if (strstr(ss->buffer, ss_buf->string) == NULL) continue;
		ss->pointer = 0;
		*(ss->buffer) = '\0';
		ausfuehren(ss_buf->ereignis, -1);
		break;
	}
}

/*-----------------------------------------------------------------------
!	Liest von der Schnittstelle "dev" zeichen ein.
!	ohne Sonderzeichenbehnadlung
+----------------------------------------------------------------------*/

void lese_ss(SS *ss)

{
	register int i,j;
	long l = 0L;
	if (ss->fd_r < 0) {
		if (!Bconstat(ss->dev)) return;

		do {
			i = (int )Bconin(ss->dev);
			ss->buffer[(ss->pointer)++] = (char )i;
			j = ss->pointer - max_ss_laenge;
			if (j > 0) {
				teste_ss(ss);
				update_ss(ss);
				memmove(ss->buffer, &ss->buffer[j], max_ss_laenge + 1);
				ss->pointer -= j;
			}
		} while (Bconstat(ss->dev));

		ss->buffer[ss->pointer] = '\0';
		teste_ss(ss);
		update_ss(ss);
	} else {
		if (flags.fcntl) Fcntl(ss->fd_r, (long )&l, FIONREAD);
		else if (flags.finstat) l = Finstat(ss->fd_r);
		else l = -1;
		while (l > 0) {
			if ((l = Fread(ss->fd_r, l, &(ss->buffer[ss->pointer]))) <= 0) break;
			ss->pointer += (int )l;
			ss->buffer[ss->pointer] = '\0';
			teste_ss(ss);
			j = ss->pointer - max_ss_laenge;
			if (j > 0) {
				memmove(ss->buffer, &(ss->buffer[j]), max_ss_laenge + 1);
				ss->pointer -= j;
			}
			update_ss(ss);
			if (ss->fd_r < 0) break;	/* wenn durch teste_ss() Schnittstelle abgeschaltet wurde	*/
			if (flags.fcntl) Fcntl(ss->fd_r, (long )&l, FIONREAD);
			else if (flags.finstat) l = Finstat(ss->fd_r);
			else l = -1;
		}
	}
}


/*------------------------------------------------------------------------
!	Lscht alle anstehenden Zeichen von dev
+----------------------------------------------------------------------*/

void clear(int dev)

{
	if (dev <= 0) return;	/* 0 = Drucker!!	*/
	while (Bconstat(dev)) Bconin(dev);
}

/*-----------------------------------------------------------------------
!	Testet die aktuellen Daten der *.EVT-Dateien und startet evtl. einen
!	Update der entsprechenden Dateien
+----------------------------------------------------------------------*/

void test_evt(int start)

{
	struct ffblk ffb;
	long l;
	int i;

	strcpy(f1, file_path);
	l = strlen(f1);
	strcpy(&f1[l], "\\SS.EVT");
	if (findfirst(f1, &ffb, 0) == 0) {
		if (!start) {
			if ((file_zeit.ss.fdate < (unsigned int )ffb.ff_fdate) || (file_zeit.ss.ftime < (unsigned int )ffb.ff_ftime)) {
				free(ss_buffer);
				setze_ss();
			}
		}
		file_zeit.ss.fdate = ffb.ff_fdate;
		file_zeit.ss.ftime = ffb.ff_ftime;
	}

	strcpy(&f1[l], "\\BUTTON.EVT");
	if (findfirst(f1, &ffb, 0) == 0) {
		if (!start) {
			if ((file_zeit.button.fdate < (unsigned int )ffb.ff_fdate) || (file_zeit.button.ftime < (unsigned int )ffb.ff_ftime)) {
				setze_buttons();
			}
		}
		file_zeit.button.fdate = ffb.ff_fdate;
		file_zeit.button.ftime = ffb.ff_ftime;
	}

	strcpy(&f1[l], "\\PROGRAMM.EVT");
	if (findfirst(f1, &ffb, 0) == 0) {
		if (!start) {
			if ((file_zeit.programm.fdate < (unsigned int )ffb.ff_fdate) || (file_zeit.programm.ftime < (unsigned int )ffb.ff_ftime)) {
				free(prog_strukt);
				prog_strukt = setze_programm();
			}
		}
		file_zeit.programm.fdate = ffb.ff_fdate;
		file_zeit.programm.ftime = ffb.ff_ftime;
	}

	strcpy(&f1[l], "\\TIMER.EVT");
	if (findfirst(f1, &ffb, 0) == 0) {
		if (!start) {
			if ((file_zeit.timer.fdate < (unsigned int )ffb.ff_fdate) || (file_zeit.timer.ftime < (unsigned int )ffb.ff_ftime)) {
				ereignis_zeit = lade_n_ereignis(timer_ereignis);
			}
		}
		file_zeit.timer.fdate = ffb.ff_fdate;
		file_zeit.timer.ftime = ffb.ff_ftime;
	}
/* Bei KEYBOARD.EVT wird die Datei immer aktuell gelesen! Keine Aktion notwendig!	*/

	strcpy(&f1[l], "\\FEIERTAG.DAT");
	if (findfirst(f1, &ffb, 0) == 0) {
		if (!start) {
			if ((file_zeit.feiertag.fdate < (unsigned int )ffb.ff_fdate) || (file_zeit.feiertag.ftime < (unsigned int )ffb.ff_ftime)) {
				if (f_tag != NULL) free(f_tag);
				i = 0;
				f_tag = lade_feiertag(file_path, &flags.bundesland, &i, 0);
				setze_kalender(kal_mon, kal_jahr);
			}
		}
		file_zeit.feiertag.fdate = ffb.ff_fdate;
		file_zeit.feiertag.ftime = ffb.ff_ftime;
	}

}

/*--------------------------------------------------------------------
!	testet welche Programme per appl_find zu finden sind!
+--------------------------------------------------------------------*/

void test_progs(PROG_STRUKT *prog)

{
	PROG_STRUKT *p_str;
	
	if (prog == NULL) return;
	p_str = prog;
	while (*(p_str->programm) != '\xff') {
		
		if (!aktiv(p_str->programm, NULL)) {	/* Nicht gefunden	*/
			if (p_str->aktiv) {
				ausfuehren(p_str->end_ereignis, -1);
				p_str->aktiv = FALSE;
			}
		} else {
			if (!(p_str->aktiv)) {	/* Gefunden	*/
				ausfuehren(p_str->start_ereignis, -1);
				p_str->aktiv = TRUE;
			}
		}
		p_str++;
	}
}

/*-------------------------------------------------------------------
!	Versucht herauszufinden, ob <programm> bereits geladen ist
!	Gibt TRUE zurck, wenn dem so ist, ansonsten FALSE
+------------------------------------------------------------------*/

int aktiv(char *programm, int *ap_id)

{
	char dummy[10]="", *c;
	char pr[30]="U:\\PROC\\";
	int i;
	if (ap_id != NULL) *ap_id = -1;
	
	strncat(dummy, programm, 8);	/* maximal 8 Zeichen kopieren	*/
	c = strchr(dummy, '.');			/* evtl. extensionen lschen!	*/
	if (c != NULL) *c = '\0';		/* extension lschen			*/
	i = (int )strlen(dummy);		/* Krzer als 8 Zeichen?		*/
	if (i < 8) for (; i < 8; dummy[i++]=' ');	/* Mit ' ' auffllen	*/
	dummy[8] = '\0';				/* Ende Markierung setzen		*/
	strupr(dummy);					/* Alles gro schreiben!		*/
	if ((i = appl_find(dummy)) < 0) {		/* nicht gefunden?				*/
		strcat(pr, programm);
		strcat(pr, ".*");
		if (Fsfirst(pr, 0) == 0) return(TRUE);
		else return(FALSE);
	} else {
		if (ap_id != NULL) *ap_id = i;
		return(TRUE);
	}
}

/*--------------------------------------------------------------------
!	testet welche Programme per appl_find zu finden sind um die Struktur wait_strukt
!	damit abarbeiten zu knnen
+--------------------------------------------------------------------*/

int test_wait(WAIT_STRUKT *ws)

{
	WAIT_STRUKT *ww = NULL;
	int akt, i;
	
	while (ws != NULL) {
		akt = aktiv(ws->programm, NULL);
		
		if ((!akt && !ws->aktiv) || (akt && ws->aktiv)) {
			i = ws->file_nr;						/* Vor dem freigeben des Speichers file-nr merken	*/
			if (ww != NULL) ww->next_ws = ws->next_ws;	/* Zeiger auf nchsten Eintrag setzen	*/
			else wait_strukt = ws->next_ws;				/* Wird der erste Eintrag bearbeitet?	*/

			free(ws);

			return(ausfuehren(NULL, i));			/* Ausfhren und Ergebnis zurckliefern	*/
		}
		ww = ws;
		ws = ws->next_ws;
	}
	return(FALSE);		/* BEM nicht beenden!	*/
}

/*--------------------------------------------------------------------
!	Speichert eine EVENTMAN.INF Datei, in der folgende Dinge gesichert
!	werden:
!	1. Position beider Fenster
!	2. Buttonfenster geffnet oder nicht?
!	3. Kalenderfenster   "     "     "
!	4. Zeitdauer der berprfungen
!	5. Pfad der EVT-Dateien fr das ACC
!	6. Pfad des Editors
!
!	Liefert TRUE, wenn ok, ansonsten FALSE
+------------------------------------------------------------------------*/

int sichern_inf(void)

{
	FILE *fd;
	FENSTER *f;
	int handle, owner, next, i;
	
	fd = fopen(inf_file, "w");
	if (fd != NULL) {
		fprintf(fd, "AccFilePath: %s\n", file_path);
		fprintf(fd, "Use-RSCFile: %s\n", rsrc_file);
		fprintf(fd, "BEMEditPath: %s\n", edit_prog);
		fprintf(fd, "ProFileMask: %s\n", proto_file);
		fprintf(fd, "INFO-Anzahl: %d\n", flags.info_anzahl);
		fprintf(fd, "SekProgFind: %d\n", flags.sek_prog);
		fprintf(fd, "KeyDelayTim: %d\n", flags.key_delay);
		fprintf(fd, "SekEvtDatei: %d\n", flags.sek_evt);
		fprintf(fd, "KnopfInfoln: %s\n", (haupt.art & INFO) ? "Ja" : "Nein" );
		knopf.gesichert = kal.gesichert = haupt.gesichert = grins.gesichert = FALSE;
		info.gesichert = TRUE;	/* Diese Fenster werden nicht gesichert!	*/
		
		if (flags.wind_sort) {
			my_wind_get(0, WF_TOP, &handle, &owner, &next, &i);
			do {
				if (owner == ap_id) {
					if (handle == knopf.wind_handle) f = &knopf;
					else if (handle == kal.wind_handle) f = &kal;
					else if (handle == haupt.wind_handle) f = &haupt;
					else if (handle == grins.wind_handle) f = &grins;
					else f = NULL;
				
					if (f != NULL) {
						fprintf(fd, "%.5sWindow: %s %d %d\n", f->kennung, f->iconified ? "Iconified" : (f->aktiv ? "Opend" : "Closed"), f->fx, f->fy);
						f->gesichert = TRUE;
					}
				}
				handle = next;
				my_wind_get(handle, WF_OWNER, &owner, &i, &i, &next);
			} while(next >= 0);
		}
		
		for (i = 0; i < MAX_FENSTER; i++)
			if (!(alle_fenster[i]->gesichert)) fprintf(fd, "%.5sWindow: %s %d %d\n", alle_fenster[i]->kennung, alle_fenster[i]->iconified ? "Iconified" : (alle_fenster[i]->aktiv ? "Opend" : "Closed"), alle_fenster[i]->fx, alle_fenster[i]->fy);

		fclose(fd);
		return(TRUE);
	} else return(FALSE);
}

/*-----------------------------------------------------------------------
!	Sucht die EVENTMAN.INF und setzt die Variable inf_file
+---------------------------------------------------------------------*/

void suche_inf(void)

{
	char *c;
	struct ffblk ffb;
	
	strcpy(inf_file, file_path);
	strcat(inf_file, "\\EVENTMAN.INF");
	
	if (findfirst(inf_file, &ffb, 0) != 0) {
		strcpy(inf_file, file_path);
		c = strrchr(inf_file, '\\');
		if (c != NULL) *c = '\0';
		strcat(inf_file, "\\EVENTMAN.INF");
	}
}

/*------------------------------------------------------------------------
!	Ldt die Infodatei und stellt die Fenster ein!
+-----------------------------------------------------------------------*/

void lese_inf(FENSTER *h, FENSTER *k, FENSTER *ka, FENSTER *g)

{
	char *c;
	FILE *fd;
	FENSTER *f[4];
	int i = 0, fx,fy,fb,fh;
	time_t t;
	struct tm *tm;
	
	wind_get(0, WF_WORKXYWH, &fx, &fy, &fb, &fh);
	
	fd = fopen(inf_file, "r");
	if (fd != NULL) {
		while (fgets(dummy, 127, fd) != NULL) {
			c = strtok(dummy, " \n");
			if (c == NULL) continue;
			if (i > 3) i = 3;	/* Falls mehr als 4 Fensterzeilen enthalten sind!	*/
			if (stricmp(c, "HauptWindow:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				h->aktiv = (*c == 'O') ? TRUE : FALSE;
				h->iconified = (*c == 'I') ? TRUE : FALSE;
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				h->fx = atoi(c);
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				h->fy = atoi(c);
				f[i++] = h;
			} else if (stricmp(c, "KnopfWindow:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				k->aktiv = (*c == 'O') ? TRUE : FALSE;
				k->iconified = (*c == 'I') ? TRUE : FALSE;

				if ((c = strtok(NULL, " \n")) == NULL) continue;
				k->fx = atoi(c);
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				k->fy = atoi(c);
				f[i++] = k;
			} else if (stricmp(c, "KalenWindow:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				ka->aktiv = (*c == 'O') ? TRUE : FALSE;
				ka->iconified = (*c == 'I') ? TRUE : FALSE;

				if ((c = strtok(NULL, " \n")) == NULL) continue;
				ka->fx = atoi(c);
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				ka->fy = atoi(c);
				f[i++] = ka;
			} else if (stricmp(c, "InTxtWindow:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				g->aktiv = (*c == 'O') ? TRUE : FALSE;
				g->iconified = (*c == 'I') ? TRUE : FALSE;

				if ((c = strtok(NULL, " \n")) == NULL) continue;
				g->fx = atoi(c);
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				g->fy = atoi(c);
				f[i++] = g;
			} else if (stricmp(c, "INFO-Anzahl:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				flags.info_anzahl = atoi(c);
				if (flags.info_anzahl < 1) flags.info_anzahl = 1;
			} else if (stricmp(c, "KeyDelayTim:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				flags.key_delay = atoi(c);
				if (flags.key_delay < 1) flags.key_delay = 200;
			} else if (stricmp(c, "SekProgFind:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				flags.sek_prog = atoi(c);
			} else if (stricmp(c, "SekEvtDatei:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				flags.sek_evt = atoi(c);
			} else if (stricmp(c, "ProFileMask:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				strcpy(proto_file, c);
			} else if (stricmp(c, "BEMEditPath:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				strcpy(edit_prog, c);
			} else if (stricmp(c, "AccFilePath:") == 0) {
				if ((flags.bav_env) || ((c = strtok(NULL, " \n")) == NULL)) continue;
				strcpy(file_path, c);
			} else if (stricmp(c, "KnopfInfoln:") == 0) {
				if ((c = strtok(NULL, " \n")) == NULL) continue;
				if (toupper(*c) == 'N') {
					k->art &= ~INFO;		/* Es wird die Fenstergre gendert, daher neuberechnung!	*/
					init_win(&knopf, msg[MSG_BUTTON].ob_spec.free_string, k_info, "Knopf");	
				}
			}
		}
		fclose(fd);

		for (i--; i >= 0; i--) {
			if (f[i]->fx + f[i]->fw > fx + fb) f[i]->fx = fx + fb - f[i]->fw;
			if (f[i]->fy + f[i]->fh > fy + fh) f[i]->fy = fy + fh - f[i]->fh;
			if (f[i]->fx < fx) f[i]->fx = fx;
			if (f[i]->fy < fy) f[i]->fy = fy;
			f[i]->ob->ob_x = f[i]->wx = f[i]->dx + f[i]->fx;			/* Geladene OBjects anpassen	*/
			f[i]->ob->ob_y = f[i]->wy = f[i]->dy + f[i]->fy;
			if (f[i]->aktiv || f[i]->iconified) {
				if (!flags.iconify) f[i]->iconified = FALSE;
				f[i]->aktiv = FALSE;
				if (f[i] == ka) {
					t = time(NULL);
					tm = localtime(&t);
					setze_kalender(tm->tm_mon, tm->tm_year);
				}
				oeffne_fenster(f[i]);
			}
		}
	} else {
		strcpy(inf_file, file_path);
		strcat(inf_file, "\\EVENTMAN.INF");
	}
}

/*-------------------------------------------------------------------------
|    Lt einen Zweitongong erklingen (als Hinweis fr den Chatruf
|    Verwendet wird Dosound()! Die Tonerzeugung wird durch einen
|    Interrupt verarbeitet. Das Programm luft weiter !!!
+------------------------------------------------------------------------*/

void gong(void)

{
     char save;
     
     save = Giaccess(0, 7);        /* Retten der Floppyregister */
     Dosound(bingbong);            /* Glckchen fr den SYSOP */
     Giaccess(save, 128+7);        /* Gerettete Werte zurckschreiben */
}

/*----------------------------------------------------------------------------
!	Setzt den Kalender auf den Monat(0-11)/Jahr 
+---------------------------------------------------------------------------*/

void setze_kalender(int mon, int jahr)

{
	FEIERTAG *ft;
	struct tm tim, *ti;
	time_t zeit, f;
	int i, j, start, l_tag, l_mon, l_jahr;
	long l;
	OBJECT *k;
	TEDINFO *ted;
	char *c;
	
	kal_mon = mon;
	kal_jahr = jahr;
	
	k = kal.ob;

	zeit = time(NULL);
	ti = localtime(&zeit);
	l_tag = anz_tag = ti->tm_mday;
	l_mon = ti->tm_mon;
	l_jahr = ti->tm_year;
	ti->tm_hour = ti->tm_min = ti->tm_sec = 0;
	zeit = mktime(ti);

	f = zeit - 86400L;	/* Einen Tag frher	*/
	ft = feiertag(f, &f);	/* nchsten Feiertag suchen. Wenn heute, dann ist f == zeit !	*/
	
	sprintf(kal_info, " %.2i.%.2i.%.4i ", l_tag, l_mon + 1, l_jahr + 1900);	/* aktuelles Datum in die INFO-Zeile eintragen	*/
	if (f == zeit) {
		strcat(kal_info, "(");
		if (ft->art > JAEHRLICH) strcat(kal_info, ft_name[ft->art]);
		else strcat(kal_info, ft->bemerkung);
		strcat(kal_info, ")");
	}

	wind_set(kal.wind_handle, WF_INFO, kal_info);
	
	tim.tm_year = jahr;
	tim.tm_mon = mon;
	tim.tm_mday = 1;
	tim.tm_hour = tim.tm_min = tim.tm_sec = 0;
	zeit = f = mktime(&tim);
	ti = localtime(&zeit);
	
	c = k[MONAT].ob_spec.tedinfo->te_ptext;
	strcpy(c, monate[ti->tm_mon]);
	strcat(c, " ");
	itoa(ti->tm_year + 1900, &c[strlen(c)], 10);
	
	j = start = MO_1 + ti->tm_wday - 1;
	if (j < MO_1) j = start = MO_1 + 6;
	for (i = MO_1; i < j; k[i++].ob_spec.tedinfo->te_ptext[0] = '\0') {	/* Anfang festlegen	*/
		k[i].ob_flags |= SELECTABLE;
		k[i].ob_spec.tedinfo->te_thickness = 0;
	}
	
	for (j = 1; i <= SO_6; i++, j++) {
		ted = k[i].ob_spec.tedinfo;
		ted->te_color &= 0x00FF;	/* Text und Rahmen ausmaskieren	*/
		switch(ti->tm_wday) {
			case 6:
				ted->te_color |= 0x0A00;	/* dunkelroter Text	*/
				break;
			case 0:
				ted->te_color |= 0x0200;	/* dunkelroter Text	*/
				break;
			default:			
				ted->te_color |= 0x0100;	/* schwarzer Text	*/
				break;
		}
		itoa(j, ted->te_ptext, 10);
		k[i].ob_flags &= ~SELECTABLE;
		if ((j == l_tag) && (l_mon == ti->tm_mon) && (l_jahr == ti->tm_year)) {
			ted->te_thickness = -2;
			ted->te_color |= 0x4000;	/* Blauer Rahmen	*/
		} else {
			ted->te_thickness = -1;
			ted->te_color |= 0x1000;	/* Schwarzer Rahmen	*/
		}
		zeit += 86400L;
		ti = localtime(&zeit);
		if (ti->tm_mday == 1) break;
	}
	
	for (i++; i <= SO_6; k[i++].ob_spec.tedinfo->te_ptext[0] = '\0') {
		k[i].ob_flags |= SELECTABLE;
		k[i].ob_spec.tedinfo->te_thickness = 0;
	}
	
	start--;
	f -= 86400L;	/* Beginn einen Tag vorher	*/
	do {
		if ((feiertag(f, &f)) == 0) break;	/* Kein Feiertag!	*/
		ti = localtime(&f);
		if ((ti->tm_year == jahr) && (ti->tm_mon == mon)) {
			k[start + ti->tm_mday].ob_spec.tedinfo->te_color &= 0xF0FF;	/* text ausmaskieren */
			k[start + ti->tm_mday].ob_spec.tedinfo->te_color |= 0x0200;	/* hellroter Text	*/
		}
	} while ((ti->tm_year == jahr) && (ti->tm_mon == mon));
	if (kal.aktiv) setze_ob(k, 0, NULL);
	
	l = ((jahr - 70) * 12) + mon;				/* Schieber berechnen	*/
	kal.vslide = (int )((1000 * l) / 815L);
	if (kal.aktiv) wind_set(kal.wind_handle, WF_VSLIDE, kal.vslide);
}

/*-----------------------------------------------------------------------------
!	ffnet ein fenster. Wenn noch kein Handle vorhanden, dann wird es created
!	Wenn bereits offen, dann wird es getoppt
!	Wenn ionified angegeben, aber wind_handle -1, dann wird es Iconified geffnet
+-----------------------------------------------------------------------------*/

void oeffne_fenster(FENSTER *f)

{
	int i, x, y, b, h;
	if (f->ob == NULL) return;	/* Ohne Objct kann nicht geffnet werden!	*/
	
	if (flags.grp_icon && f->iconified) {	/* Fenster wurde all-iconifiziert	*/
		for (i = 0; i < MAX_FENSTER; i++) {
			if (alle_fenster[i]->all_ic) break;
		}
		if (i < MAX_FENSTER) wind_set(alle_fenster[i]->wind_handle, WF_TOP);
		return;
	}
	if (f->wind_handle < 0) f->wind_handle = wind_create(f->art, f->fx, f->fy, f->fw, f->fh);
	
	if (f->wind_handle >= 0) {

		if (f->titel != NULL) wind_set(f->wind_handle, WF_NAME, f->titel);
		if (f->info != NULL) wind_set(f->wind_handle, WF_INFO, f->info);
		
		if (f->art & VSLIDE) {
			if (f == &kal) wind_set(f->wind_handle, WF_VSLSIZE, 100);
			else if (f == &grins) {
				if (flags.akute_infos <= 0) wind_set(f->wind_handle, WF_VSLSIZE, 1000);
				else wind_set(f->wind_handle, WF_VSLSIZE, 1000 / flags.akute_infos);
				f->vslide = 1000;
			} 
		}
		
		if (f->iconified && flags.iconify) {	/* Darf nur gemacht werden, wenn Iconify untersttzt wird!	*/
			wind_set(f->wind_handle, WF_ICONIFY, -1,-1,-1,-1);
			wind_open(f->wind_handle, -1,-1,-1,-1);
			wind_get(f->wind_handle, WF_CURRXYWH, &f->fx, &f->fy, &f->fw, &f->fh);
			wind_get(f->wind_handle, WF_WORKXYWH, &x, &y, &b, &h);
			f->i_dx = x - f->fx;
			f->i_dy = y - f->fy;
			f->ic->ob_x = x;
			f->ic->ob_y = y;
			f->ic->ob_width = b;
			f->ic->ob_height = h;
			f->ic[1].ob_x = ((b - f->ic[1].ob_width) / 2);
			f->ic[1].ob_y = ((h - f->ic[1].ob_height) / 2);
			f->ic[1].ob_spec.iconblk->ib_ytext = h - f->ic[1].ob_y - f->ic[1].ob_spec.iconblk->ib_htext;
			f->aktiv = TRUE;
		}
		if (!f->aktiv) {
			wind_open(f->wind_handle, f->fx, f->fy, f->fw, f->fh);
			f->aktiv = TRUE;
			f->grp_ic = f->all_ic = FALSE;
		} else wind_set(f->wind_handle, WF_TOP);

		if (f->vslide > 0) wind_set(f->wind_handle, WF_VSLIDE, f->vslide);
		set_menu(f, TRUE);
	} else {
		form_alert(1, msg[MSG_ERRFENSTER].ob_spec.free_string);
	}
}

/*-----------------------------------------------------------------------------------
!	Schliet ein Fenster und lscht dieses gleich wieder
+-----------------------------------------------------------------------------------*/

void schliesse_fenster(FENSTER *f)

{
	int i,w,h;
	
	if (f->wind_handle < 0) return;
	if (f->aktiv) {
		wind_get(f->wind_handle, WF_CURRXYWH, &i, &i, &w, &h);
		if ((w > 0) && (h > 0))	wind_close(f->wind_handle);
		wind_delete(f->wind_handle);
		if (!f->iconified) set_menu(f, FALSE);
		f->aktiv = FALSE;
		f->wind_handle = -1;
	}
}

/*---------------------------------------------------------------
!	Hakelt die entsprechenden Meneintrge ab
+----------------------------------------------------------------*/

void set_menu(FENSTER *f, int check)

{
	int i;
	if (!flags.menu_bar) return;
	
	if (f == &haupt) i = MENU_HF;
	else if (f == &knopf) i = MENU_MS;
	else if (f == &kal) i = MENU_KAL;
	else if (f == &grins) i = MENU_INF;
	else return;
	menu_icheck(menu, i, check);
}

/*-----------------------------------------------------------------------
!	Erweitert das environment um die Variablen BAVARIA-SYSTEM
!	und BAVARIA-ZENTRAL
!	Reserviert mit malloc und gibt das neue env zurck
+----------------------------------------------------------------------*/

char *erweitere_env(char *alt_env)

{
	long alt, l;
	char *c = NULL;
	char bav_sys[128];

	if (alt_env != NULL) {
		for(l = 0, c = alt_env; !((*c == '\0') && (*(c+1) == '\0')); c++, l++);
		alt = l+1;
	} else alt = l = 0;
	
	if (!flags.bav_env) {
		strcpy(bav_sys, "BAVARIA-SYSTEM=");
		strcat(bav_sys, file_path);
	
		if (flags.mint) shel_write(SHW_SETENV, 1, SHWF_ENV, bav_sys, NULL);
		else l += strlen(bav_sys) + 2;
	}
	
	if (l == 0) c = alt_env;
	else {
		if ((c = (char *)malloc(l)) != NULL) {
			if ((alt_env != NULL) && (alt > 0)) memcpy(c, alt_env, alt);
			if (!flags.bav_env) {
				strcpy(&c[alt], bav_sys);
				alt += strlen(bav_sys) + 1;
			}
			c[alt] = '\0';
		} else fehler(ERR_NO_MEM, "um Environment anzulegen");
	}
	return(c);
}

/*-----------------------------------------------------------------------
!	Liefert die Adresse des Fensters wieder
+----------------------------------------------------------------------*/

FENSTER *hole_fenster(int wind_handle)

{
	int wh, i;

	if (wind_handle < 0) wind_get(0, WF_TOP, &wh);
	else wh = wind_handle;
	
	for (i = 0; i < MAX_FENSTER; i++) {
		if (wh == alle_fenster[i]->wind_handle) return(alle_fenster[i]);
	}
	return(NULL);
}

/*--------------------------------------------------------------------------
!	Bringt eine Fehlermeldung und bietet Hilfsmglichkeiten an!
+-------------------------------------------------------------------------*/

void fehler(int err, char *text)

{
	char f[300], *c, *l;
	char node[20];
	int i,m;
	
	if (text != NULL) {	/* Dann mu TExt formatiert werden!	*/
		for(i = 0, l = c = text; *c != '\0'; c++, i++) {
			if (*c == ' ') l = c;
			if (*c == '|') {
				i = 0;
				l = c;
			}
			if ((i >= 30) && (*l == ' ')) {
				*l = '|';
				c = l;
				i = 0;
			}
		}
	}

	switch (err) {
		case ERR_IF_OHNE_KLAMMER:
			m = MSG_ERRIF;
			strcpy(node, "IF");
			break;
		case ERR_NO_DMASOUND:
			m = MSG_ERRDMASOUND;
			strcpy(node, "VOLUME");
			break;
		case ERR_KEIN_KOMMANDO:
			m = MSG_UNKNOWNCMD;
			strcpy(node, "Aktions-Dateien");
			break;
		case ERR_NO_SSKONF:
			m = MSG_NOHSMODEM;
			strcpy(node, "SS");
			break;
		case ERR_NO_MEM:
			m = MSG_NOMEM;
			break;
		case ERR_VAR_ZULANG:
			m = MSG_LONGVAR;
			strcpy(node, "Variablen");
			break;
		case ERR_VAR_VORHANDEN:
			m = MSG_VARINIT;
			strcpy(node, "Variablen");
			break;
		case ERR_FDELETE:
			m = MSG_DELFILE;
			break;
	}
	sprintf(f, msg[m].ob_spec.free_string, text);
	
	proto("Fehler", f);
	
	i = form_alert(1, f);
	if (i == 2) go_help(node);
}

/*--------------------------------------------------------------------------
!	Hilfstextaufruf ruft "node" auf, oder abhngig vom Fenster wenn node = NULL
+--------------------------------------------------------------------------*/

void go_help(char *node)

{
	FENSTER *akt;
	char *c, ziel[128];
	
	strcpy(ziel, "*:\\BEM.HYP");
	
	if (node == NULL) {		
		akt = hole_fenster(-1);
		if (akt == &info) strcat(ziel, " Registrier-Fenster");
		else if (akt != NULL) {
			strcat(ziel, akt->titel);
			c = &ziel[strlen(ziel)-1];
			while (*c == ' ') *(c--) = '\0';	/* Leerzeichen lschen	*/
		}
	} else {
		strcat(ziel, " ");
		strcat(ziel, node);
	}

	if (!va_startprog("ST-GUIDE", ziel, FALSE)) {
		form_alert(1,msg[MSG_NOSTGUIDE].ob_spec.free_string);
		return;
	}
}

/*------------------------------------------------------------------------
!	Lscht alle Variablen rekursiv!!!
+-----------------------------------------------------------------------*/

void del_var(VARIABLE *v)

{
	if (v->next_var != NULL) del_var(v->next_var);
	if (v->art > 0) free(v->v_art.c_string);
	if (v->mem) free(v);
}

/*-------------------------------------------------------------------------
!	Legt Speicher fr die Variable var an und kettet ans Ende der Liste an
!	Als v_name wird verlangt: "Name" oder "Name$(10)"
!	Es sind auch mehrere Variablen erlaubt, die durch , getrennt sind!
+------------------------------------------------------------------------*/

int dim_var(char *v_namen)

{
	VARIABLE *v;
	char *name, *anzahl, *c, *o;
	int ok;
	
	name = strtok(v_namen, ",");	/* erste Variable holen	*/
	while(name != NULL) {
		for(c = o = name; *o != '\0'; o++) {
			if (!isspace(*o)) *(c++) = *o;	/* Spaces entfernen!	*/
		}
		*c = '\0';
		c = strchr(name, '(');
		if (c != NULL) {
			*c = '\0';
			anzahl = c+1;
		}
		if (strlen(name) > 9) {
			fehler(ERR_VAR_ZULANG, name);
		} else {
			v = &var;					/* Ende der Liste suchen	*/
			ok = TRUE;
			
			while (v->next_var != NULL) {
				if (strcmp(v->name, name) == 0) {
					fehler(ERR_VAR_VORHANDEN, name);
					ok = FALSE;
					break;
				}
				v = v->next_var;
			}

			if (ok && strcmp(v->name, name) == 0) {	/* letzte Variable auch noch prfen!	*/
				fehler(ERR_VAR_VORHANDEN, name);
				ok = FALSE;
			}
			
			if (ok) {
				if ((v->next_var = (VARIABLE *)malloc(sizeof(VARIABLE))) == NULL) {
					fehler(ERR_NO_MEM, "um Variablen anzulegen!");
					return(-7);	/* Ereignis abbrechen!	*/
				} else {
					v = v->next_var;
					v->next_var = NULL;	/* Ende der Liste	*/
					v->mem = TRUE;
					strcpy(v->name, name);
					if (name[strlen(name)-1] == '$') {	/* Stringvariable	*/
						v->art = atoi(anzahl);			/* Lnge eintragen			*/
						if (v->art <= 0) v->art = 20;	/* Keine Lnge, dann 20 Byte!	*/
						if ((v->v_art.c_string = (char *)malloc(v->art + 1)) == NULL) {
							fehler(ERR_NO_MEM, "um Stringvariable anzulegen");
							return(-7);	/* Ereignis abbrechen	*/
						} else *(v->v_art.c_string) = '\0';
					} else {						/* Long-Variable	*/
						v->art = 0;
						v->v_art.l_wert = 0L;
					}
				}	
			}	
		}
		name = strtok(NULL, ",");		/* nchste Variable	*/
	}
	return(-1);	/* -1 bedeutet OK!	*/
}

/*-------------------------------------------------------------------------
!	Setzt eine Variable mit einem bestimmten Wert!
+------------------------------------------------------------------------*/

void setze_var(char *v_name, char *c_string, long l_wert)

{
	VARIABLE *v;
	v = &var;
	if (v_name != NULL && *v_name != '\0') {	/* Standardvariable hernehmen	*/
		do {
			if (strcmp(v->name, v_name) == 0) break;
			else v = v->next_var;
		} while (v != NULL);
	}
	if (c_string != NULL) {	/* Stringvariable	*/
		if (v->art > 0) {
			*(v->v_art.c_string) = '\0';
			strncat(v->v_art.c_string, c_string, v->art);
		} else v->v_art.l_wert = l_wert;
	} else {
		if (v->art == 0) v->v_art.l_wert = l_wert;
		else ltoa(l_wert, v->v_art.c_string, 10);
	}
}

/*---------------------------------------------------------------------------
!	berprft, ob die Variable existiert und liefert NULL, oder VARIABLE
!	Erlaubt ist auch die Angabe test$(<von>-<bis>)
+--------------------------------------------------------------------------*/

VARIABLE *teste_var(char *v_name)

{
	VARIABLE *v;
	char *c, name[10]="";
	long l = 9;
	
	if ((c = strchr(v_name, '(')) != NULL) {
		l = (long )(c - v_name);
		if (l > 9) l = 9;
	}
	strncat(name, v_name, l);
	
	v = &var;
	do {
		if (strcmp(v->name, name) == 0) return(v);
		v = v->next_var;
	} while (v != NULL);
	return(NULL);
}

/*---------------------------------------------------------------------------
!	setzt einen String, der sowohl Text als auch Variablen enthalten
!	darf in einen neuen String zusammen, der nur Text enthlt.
!
!	"abcdef";a$;"test" mit a$=hallo wird "abcdefhallotest"
!	"abcdef";a;"test" mit a=15      wird "abcdef15test"
!   "abcdef";a$(5-5) 
!	Spezialvariablen sind: 1$ 2$ 3$ 4$ als Kommandozeilenvar.
!	Als Kettungszeichen ist nur ein ; erlaubt!
+--------------------------------------------------------------------------*/

char *setze_text(char *alt, char *neu, long max_laenge)

{
	char *c1, *c2, *esc, *c, ch;
	VARIABLE *v;
	long l;
	
	if (alt == NULL) return(NULL);
	
	l = max_laenge;
	*neu = '\0';
	
	c1 = alt;
	do {
		switch(*c1) {
			case '\"':	c2 = ++c1;
						do {
							esc = strchr(c2, '\\');		/* ESC-Zeichen		*/
							if (esc != NULL) {
								switch(esc[1]) {
									case '\"':	break;
									default:	esc = NULL;
												break;
								}
							}
							c2 = strchr(c2, '\"');		/* normaler Text	*/
							if (esc != NULL && c2 != NULL && esc < c2) {	/* ESC-Zeichen mu bearbeitet werden!	*/
								*(esc++) = '\0';
								strncat(neu, c1, l);
								l -= strlen(c1);
								c = &neu[strlen(neu)];
								if (l > 0) {
									*c++ = *esc++;
									*c = '\0';
								}
								c2 = esc;
							} else if (c2 != NULL) {
								*(c2++) = '\0';
								strncat(neu, c1, l);
							} else strncat(neu, c1, l);
							c1 = c2;
						} while (esc != NULL);
						break;
			case ' ':								/* Leerzeichen mssen auch in String	*/
			case '\t':
						c = &neu[strlen(neu)];
						*(c++) = *(c1++);
						*c = '\0';
						break;
			case '+':
			case ';':	c1++;						/* Direkt verkettet	*/
						break;
			default:	c2 = strpbrk(c1, " \t+;\"");
						ch = '\0';
						if (c2 != NULL) {
							ch = *c2;
							*c2 = '\0';
						}
						v = teste_var(c1);
						if (v != NULL) {
							if (v->art == 0) ltoa(v->v_art.l_wert, &neu[strlen(neu)], 10);
							else strncat(neu, v->v_art.c_string, l);
						} else strncat(neu, c1, l);
						
						if (c2 != NULL) *c2 = ch;
						c1 = c2;
		}
		l = max_laenge - strlen(neu);
	} while (c2 != NULL && *c2 != '\0');
	return(neu);
}

/*-----------------------------------------------------------------
!	Holt den Rechnerwert anhand des bergebenen Strings
+----------------------------------------------------------------*/

int  hole_midi_nr(char *rechner)

{
	int i;
	procs vw;
	
	get_Karte(&vw);
	
	for (i = 0; i < 7; i++) if (strcmp(vw[i].r_name, rechner) == 0) return(i);
	return(-1);
}

/*--------------------------------------------------------------------
!	Testet die Bedingung und fhrt evtl. Kommandos aus
+-------------------------------------------------------------------*/

int bedingung(char *frage)

{
	char *verg, *c;
	int art = -1;
	char bed1[1024], bed2[1024];
	
	c = frage;

	do {
		verg = strpbrk(c, "\"!=<>");
		if (verg != NULL) {
			switch(*verg) {
				case '\"':	c = strchr(++c, '\"');				/* abschlieendes Zeichen suchen	*/
							if (c != NULL) {
								c++;
								continue;
							} 
				case '!':	if (verg[1] == '=') art = 1;		/* ungleich	*/
							c = &verg[1];
							break;
				case '<':	if (verg[1] == '>') art = 1;		/* ungleich	*/
							else if (verg[1] == '=') art = 2;	/* kleiner gleich	*/
							else art = 3;						/* kleiner	*/
							c = &verg[1];
							break;
				case '>':	if (verg[1] == '=') art = 4;		/* groesser gleich	*/
							else art = 5;						/* groesser	*/
							c = &verg[1];
							break;
				case '=':	if (verg[1] == '=') art = 0;		/* gleich	*/
							c = &verg[1];
							break;
			}
		}
	} while (art < 0 && verg != NULL);	/* um Stings auszuschlieen!	*/

	if (verg == NULL) {		/* Befehl ausfhren und auf TRUE testen!	*/
		aktion(frage, FALSE);
		art = 0;
		setze_text("ERGEBNIS$", bed1, 1023);
		setze_text("0", bed2, 1023);
	} else {
		*verg = '\0';
		for (c = verg-1; isspace(*c); c--);	/* Leerzeichen zwischen 1. Par und "=" lschen	*/
		*(c+1) = '\0';
		
		if ((art == 3) || (art == 5)) c = &verg[1];
		else c = &verg[2];
		for (; isspace(*c); c++);	/* Leerzeiehn zw. "=" und 2. Par. lschen	*/
		
		setze_text(frage, bed1, 1023);
		setze_text(c, bed2, 1023);
	}

	switch(art) {
		case 0:	return((strcmp(bed1, bed2) == 0) ? TRUE : FALSE);
		case 1:	return((strcmp(bed1, bed2) != 0) ? TRUE : FALSE);
		case 2:	return((strcmp(bed1, bed2) <= 0) ? TRUE : FALSE);
		case 3:	return((strcmp(bed1, bed2) < 0) ? TRUE : FALSE);
		case 4:	return((strcmp(bed1, bed2) >= 0) ? TRUE : FALSE);
		case 5:	return((strcmp(bed1, bed2) > 0) ? TRUE : FALSE);
	}
	return(TRUE);
}

/*----------------------------------------------------------------------------
!	Korrigiertes wind_get
+---------------------------------------------------------------------------*/

int	my_wind_get(int handle, int mode, int *p1, int *p2, int *p3, int *p4)

{
	contrl[0] = 0x68;
	contrl[1] = 2;
	contrl[2] = 5;
	contrl[3] = 0;
	contrl[4] = 0;
	intin[0] = handle;
	intin[1] = mode;
	if (mode == WF_DCOLOR || mode == WF_COLOR) {
		intin[2] = *p1;
		contrl[1] = 3;
	}

	_crystal(&aespb);

	*p1 = intout[1];
	*p2 = intout[2];
	*p3 = intout[3];
	*p4 = intout[4];

	return(intout[0]);
}

/*----------------------------------------------------------------------------
!	Erstellt ein Protokollfile "PROTOKOL.TXT" im EVENTMAN.DAT-Ordner
!	Dazu mu das flag "protokol" auf TRUE sein!
!	Wird als art NULL bergeben, wird nur der text angehngt!
+---------------------------------------------------------------------------*/

void proto(char *art, char *text)

{
	int fd, i;
	long l;
	char ti[21];
	time_t zeit;
	
	if (!flags.protokoll) return;
	
	strcpy(f1, file_path);
	strcat(f1, "\\");

	zeit = time(NULL);
	i = (int )strlen(f1);
	i += (int )strftime(&f1[i], sizeof(proto_file)-1, proto_file, localtime(&zeit));
	f1[i] = '\0';
	strcat(f1, ".pro");
		
	l = Fopen(f1, FO_WRITE);
	if (l == -33) l = Fcreate(f1, 0);	/* Wenn Datei nicht vorhanden, dann anlegen!	*/
	if (l >= 0) {						/* Fehlerfrei geffnet		*/
		fd = (int )l;					/* Ergebnis auf int bringen	*/
		Fseek(0, fd, 2);				/* An das Dateiende gehen	*/
		if (art != NULL) {
			zeit = time(NULL);
			strftime(ti, 20, "%x %X %Z:", localtime(&zeit));
			ti[20] = '\0';
			Fwrite(fd, 2, "\r\n");
			Fwrite(fd, strlen(ti), ti);
			Fwrite(fd, strlen(art), art);
			Fwrite(fd, 1, " ");
		}
		Fwrite(fd, strlen(text), text);
		Fclose(fd);
	}
}
